function [wrapped,status,nrows,finalwidth]=betterlinewrap(string,maxpixels,charwidths)
%wrap a string to fit a width of "pixels" using the characterwidth matrix
%charwidths (see also characterwidths.m)
%status is 1 if string was wrapped successfully or did not need wrapping
%          0 if string could not be wrapped.

status=1;
wrapped=string;
cumwidth=cumsum(charwidths(string));


nrows=1;
finalwidth=cumwidth(end);

if isempty(string);return;end

if cumwidth(end)<maxpixels;return;end %no need to wrap

% breakafter=[find(ismember(string,' /)?;:_=+-*~]}')),length(string)];
% breakbefore=find(ismember(string,'({['));
%faster version using ismembc:

brkaft=[32 41 42 43 45 47 58 59 61 63 93 125 126]; % = )*+-/:;=?]}~  ...characters allowed to line break after
brkbfr=[40 91 123];% =([{ ...characters allowed to break before
breakafter=find(ismembc(double(string),brkaft));
breakbefore=find(ismembc(double(string),brkbfr));

breakat=union(breakafter,breakbefore-1); %ok to break after these characters.

cumwordwidths=cumwidth(breakat);
%determine number of rows needed:
breaks=[];

origwordwidths=cumwordwidths;

while any(cumwordwidths>0)
    if cumwordwidths(1)<=maxpixels
        bestbreak=breakat(cumwordwidths==max(cumwordwidths(cumwordwidths<=maxpixels)));
    else
        bestbreak=breakat(1);
    end
    breaks(end+1)=bestbreak;
    cumwordwidths=origwordwidths-cumwidth(bestbreak);
end

breaks=[0 breaks];

if breaks(end)~=length(string)
    breaks=[breaks length(string)];
end

newstr={};
finalwidth=[];
for q=1:numel(breaks)-1;
    st=strtrim(string(breaks(q)+1:breaks(q+1)));
    if ~isempty(st)
        newstr{end+1}=strtrim(string(breaks(q)+1:breaks(q+1)));
        finalwidth(end+1)=cumwidth(breaks(q+1))-cumwidth(breaks(q)+1); %note this may be slightly larger than actual string due to strtrim
    end
end

wrapped=newstr;
finalwidth=max(finalwidth);
if finalwidth>maxpixels
    status=0;
end

if iscell(wrapped)
    nrows=numel(wrapped);
end





