function [axhandles]=drawcheckbox(parent,peer,pos,value,words,callback)
%
%callback must take 3 inputs: (peer,eventdata,value)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(parent);

pos(3)=13; %enforce correct size
pos(4)=13;

a=axes('parent',parent,'units','pixels','position',pos,'color',[.8 .8 .8]);

checkon=imread('checkon.bmp');
checkoff=imread('checkoff.bmp');

if value
    img=image(checkon,'parent',a,'hittest','on','buttondownfcn',{callback,peer},'userdata',0);
else
    img=image(checkoff,'parent',a,'hittest','on','buttondownfcn',{callback,peer},'userdata',1);
end

text(18,13,words,'parent',a,'vertical','baseline');

set(a,'visible','off','userdata',value,'tag','vhslideax','hittest','on','buttondownfcn',{callback,peer})

set(a,'userdata',[]);

%callback(img,[],peer);

axhandles=a;

% 
