function raveresizeaxesbackgroundframe(src,ev,targetindex)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%targetaxes=handles.allgraphs(targetindex);
pos=get(handles.allblockers(targetindex),'position');


radius=udata.format.radius;
if (2*radius)>pos(4)
    radius=floor(pos(4)/2);
end
if (2*radius)>pos(3)
    radius=floor(pos(3)/2);
end

if radius==0
    allxdata=[pos(1) pos(1) pos(1)+pos(3) pos(1)+pos(3)];
    allydata=[pos(2) pos(2)+pos(4) pos(2)+pos(4) pos(2)];
else
    xdata=0:radius;
    ydata=sqrt(radius.^2-xdata.^2);
    allxdata=[pos(1)-xdata+radius pos(1)-fliplr(xdata)+radius pos(1)+pos(3)+xdata-radius pos(1)+pos(3)-xdata];
    allydata=[pos(2)-ydata+radius pos(2)+pos(4)+fliplr(ydata)-radius pos(2)+pos(4)+ydata-radius pos(2)-fliplr(ydata)+radius];
end

offset=radius;
if offset<5
    offset=5;
end

set(udata.view.rectangle,'xdata',allxdata,'ydata',allydata,'zdata',0*ones(size(allxdata)));
set(udata.view.title,'position',[pos(1)+offset pos(2)+pos(4) 0.5]);

guidata(src,handles);