function formattabcalculatedvalue(src,eventdata)
%rave format tab.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% do work

appeartext=text(.15-.10317,.97*1.0317-.0317,'Appearance','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

texttext=text(.15-.10317,.73*1.0317-.0317,'Text','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

condtext=text(.15-.10317,.45*1.0317-.0317,'Conditions','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


%% APPEARANCE:
fontlist=listfonts;

sizelist={'10';'12';'14';'16';'18';'20';'22';'24';'28';'32';'36';'42';'48';'60';'72';'96'};

fontvalue=find(strcmpi(fontlist,udata.format.fontname),1);
if isempty(fontvalue)
    fontvalue=1;
end

sizevalue=find(strcmp(sizelist,num2str(udata.format.fontsize)),1);
if isempty(sizevalue)
    sizevalue=1;
end

if udata.format.fontstyle==3
    boldvalue=1;
    italicvalue=1;
elseif udata.format.fontstyle==1
    boldvalue=1;
    italicvalue=0;
elseif udata.format.fontstyle==2;
    italicvalue=1;
    boldvalue=0;
else
    boldvalue=0;
    italicvalue=0;
end

%uicontrols
fontpicker=uicontrol('position',[origin(1)+25 origin(2)+124+450 219 22],'style','popupmenu',...
    'string',fontlist,'parent',handles.fig,'max',10,'value',fontvalue,...
    'backgroundcolor',[1 1 1],'tag','fontpicker','callback',@fontpicker_callback);

boldbutton=uicontrol('position',[origin(1)+25 origin(2)+90+455 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('bold.bmp'),...
    'tag','boldbutton','callback',@fontpicker_callback,'value',boldvalue);

italicbutton=uicontrol('position',[origin(1)+55 origin(2)+90+455 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('italic.bmp'),...
    'tag','italicbutton','callback',@fontpicker_callback,'value',italicvalue);

underlinebutton=uicontrol('position',[origin(1)+85 origin(2)+90+455 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('underline.bmp'),'tag','underlinebutton');

fontdownbutton=uicontrol('position',[origin(1)+145 origin(2)+90+455 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontdown.bmp'),...
    'callback',@fontdown_callback);

fontsizer=uicontrol('position',[origin(1)+176 origin(2)+90+455 40 22],'style','popupmenu',...
    'string',sizelist,...
    'parent',handles.fig,'max',1,'value',sizevalue,...
    'backgroundcolor',[1 1 1],'tag','fontsizer','callback',@fontpicker_callback);

fontupbutton=uicontrol('position',[origin(1)+220 origin(2)+90+455 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontup.bmp'),...
    'callback',@fontup_callback);

% TEXT COLOR BLOBS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


fgindex=eye(5);
fgin=udata.format.fg;

textcolortext=uicontrol('position',[origin(1)+25 origin(2)+56+460 180 20],...
    'style','text','string','Text Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

textblack=uicontrol('position',[origin(1)+124 origin(2)+58+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 0],'value',fgindex(1,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',1);

textblue=uicontrol('position',[origin(1)+149 origin(2)+58+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 .9],'value',fgindex(2,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',2);

textred=uicontrol('position',[origin(1)+174 origin(2)+58+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.9 0 0],'value',fgindex(3,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',3);

textwhite=uicontrol('position',[origin(1)+199 origin(2)+58+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],'value',fgindex(4,fgin),...
    'callback',@colorblob_Callback,'tag','textblob','userdata',4);

textrainbow=uicontrol('position',[origin(1)+224 origin(2)+58+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],'value',fgindex(5,fgin),...
    'callback',@colorrainbow_Callback,'cdata',imread('rainbow.bmp'),'tag','textblob','userdata',5);

% BACKGROUND COLOR BLOBS: (userdata = gridcolor; textcolor; index)%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

bgindex=eye(5);
bgin=udata.format.bg;

bgcolortext=uicontrol('position',[origin(1)+25 origin(2)+31+460 180 20],...
    'style','text','string','Background:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

bgwhite=uicontrol('position',[origin(1)+124 origin(2)+33+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],...
    'callback',@bgblob_Callback,'userdata',[.6 .6 .6;0 0 0;1 0 0],'value',bgindex(1,bgin));
bglight=uicontrol('position',[origin(1)+149 origin(2)+33+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.753 .753 .753],...
    'callback',@bgblob_Callback,'userdata',[1 1 1;0 0 0;2 0 0],'value',bgindex(2,bgin));
bgdark=uicontrol('position',[origin(1)+174 origin(2)+33+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[.502 .502 .502],...
    'callback',@bgblob_Callback,'userdata',[.6 .6 .6;1 1 1;3 0 0],'value',bgindex(3,bgin));
bgblack=uicontrol('position',[origin(1)+199 origin(2)+33+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[0 0 0],...
    'callback',@bgblob_Callback,'userdata',[.6 .6 .6;0 0 0;1 0 0],'value',bgindex(4,bgin));
bgrainbow=uicontrol('position',[origin(1)+224 origin(2)+33+460 20 20],...
    'style','togglebutton','string','','backgroundcolor',[1 1 1],...
    'callback',@bgrainbow_Callback,'userdata',[.3 .3 .3;1 1 1;4 0 0],'cdata',imread('rainbow.bmp'),...
    'tooltip','Choose Color','value',bgindex(5,bgin));

handles.bgblobs=[bgwhite bglight bgdark bgblack bgrainbow];

edgecheck=uicontrol('position',[origin(1)+25 origin(2)+05+460 200 26],...
    'style','checkbox','string','Draw border around text box','fontsize',9,...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.showedge,'callback',@edgecheck_Callback,'tag','edgecheck','value',0);

%% TEXT

prefixtext=uicontrol('position',[origin(1)+25 origin(2)+56+344+25 180 20],...
    'style','text','string','Prefix:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

prefixedit=uicontrol('position',[origin(1)+35 origin(2)+56+324+25 215 22],...
    'style','edit','string',udata.format.prefix,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal','callback',@prefix_Callback);

suffixtext=uicontrol('position',[origin(1)+25 origin(2)+56+300+25 180 20],...
    'style','text','string','Suffix:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

suffixedit=uicontrol('position',[origin(1)+35 origin(2)+56+280+25 215 22],...
    'style','edit','string',udata.format.suffix,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal','callback',@suffix_Callback);


formattext=uicontrol('position',[origin(1)+25 origin(2)+56+256+25 180 20],...
    'style','text','string','Format String:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

formatedit=uicontrol('position',[origin(1)+35 origin(2)+56+236+25 215 22],...
    'style','edit','string',udata.format.format,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal','callback',@format_Callback);

formatinst=uicontrol('position',[origin(1)+35 origin(2)+56+203+25 200 30],...
    'style','text','string','Read help file for sprintf for instructions. Leave blank for default format.','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',8,'horizontalalignment','left','fontweight','normal');

%% conditions:

condcheck1=uicontrol('position',[origin(1)+25 origin(2)+205+35 200 26],...
    'style','checkbox','string','If value is ','fontsize',10,'fontweight','bold',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.usecondition1,'callback',@condcheck1_Callback,'tag','condcheck1');

condedit1=uicontrol('position',[origin(1)+110 origin(2)+205+35 140 22],...
    'style','edit','string',udata.format.condition1,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal','callback',@condedit1_Callback);

c1text1=uicontrol('position',[origin(1)+45 origin(2)+175+35+3 100 20],...
    'style','text','string','Text:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

c1text2=uicontrol('position',[origin(1)+135 origin(2)+175+35+3 100 20],...
    'style','text','string','Background:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

c1color=uicontrol('position',[origin(1)+85 origin(2)+178+35+3 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.c1color,...
    'callback',@c1color_Callback);

c1bg=uicontrol('position',[origin(1)+224 origin(2)+178+35+3 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.c1bg,...
    'callback',@c1bg_Callback);



condcheck2=uicontrol('position',[origin(1)+25 origin(2)+205-80+55 200 26],...
    'style','checkbox','string','If value is ','fontsize',10,'fontweight','bold',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.usecondition2,'callback',@condcheck2_Callback,'tag','condcheck1');

condedit2=uicontrol('position',[origin(1)+110 origin(2)+205-80+55 140 22],...
    'style','edit','string',udata.format.condition2,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal','callback',@condedit2_Callback);

c2text1=uicontrol('position',[origin(1)+45 origin(2)+175-80+55+3 100 20],...
    'style','text','string','Text:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

c2text2=uicontrol('position',[origin(1)+135 origin(2)+175-80+55+3 100 20],...
    'style','text','string','Background:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

c2color=uicontrol('position',[origin(1)+85 origin(2)+178-80+55+3 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.c2color,...
    'callback',@c2color_Callback);

c2bg=uicontrol('position',[origin(1)+224 origin(2)+178-80+55+3 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.c2bg,...
    'callback',@c2bg_Callback);

condishtext=uicontrol('position',[origin(1)+15 origin(2)+50+70 240 30],...
    'style','text','string',{'Enter a conditional statement in the text box';' (e.g. "<0") or the word "feasible" or "infeasible".'},'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',8,'horizontalalignment','left','fontweight','normal');

consttext=uicontrol('position',[origin(1)+25 origin(2)+90 200 26],...
    'style','text','string','Active Constraints:','fontsize',10,'fontweight','bold','hor','left',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.usecondition2,'callback',@condcheck2_Callback,'tag','condcheck1');


if isempty(handles.constrainttext{udata.view.dataset}{udata.view.analysis})
    conststring='No constraints have been created yet.';
else
    conststring=[cellstr('') handles.constrainttext{udata.view.dataset}{udata.view.analysis}];
end

constraintmenu=uicontrol('position',[origin(1)+40 origin(2)+10 215 90],...
    'style','listbox','string',conststring,...
    'callback',@constraintmenu_Callback,...
    'backgroundcolor',[1 1 1],'tag','constraintmenu','max',100,'value',udata.view.constraints+1);

%% group items and finish up
handles.tabobjects=[appeartext texttext fontpicker ...
    boldbutton italicbutton underlinebutton fontupbutton fontdownbutton edgecheck ...
    fontsizer textblack textred textblue textwhite textrainbow bgwhite bglight bgdark bgblack bgrainbow ...
    textcolortext bgcolortext prefixtext suffixtext prefixedit suffixedit formattext formatedit formatinst...
    condtext condcheck1 condedit1 c1text1 c1text2 c1color c1bg condcheck2 condedit2 c2text1 c2text2 c2color...
    c2bg condishtext constraintmenu consttext];

handles.activetab='format';
set(handles.infobar,'string','');
guidata(src,handles);




function fontdown_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');

value=get(fontsizer,'value');
if value>=2
    value=value-1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end


function fontup_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
maxvalue=numel(get(fontsizer,'string'));

value=get(fontsizer,'value');
if value<maxvalue
    value=value+1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end


function fontpicker_callback(src,ev) %#ok<INUSD>

handles=guidata(src);
getudata;

fontpicker=findobj(handles.tabobjects,'tag','fontpicker');
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
boldbutton=findobj(handles.tabobjects,'tag','boldbutton');
italicbutton=findobj(handles.tabobjects,'tag','italicbutton');
%underlinebutton=findobj(handles.tabobjects,'tag','underlinebutton');

fontlist=get(fontpicker,'string');
fontname=fontlist(get(fontpicker,'value'));

sizelist=get(fontsizer,'string');
fontsize=str2double(sizelist{get(fontsizer,'value')});

if get(boldbutton,'value') && get(italicbutton,'value')
    fontstyle=3;
elseif get(boldbutton,'value')
    fontstyle=1;
elseif get(italicbutton,'value')
    fontstyle=2;
else
    fontstyle=4;
end

udata.format.fontname=fontname{1};
udata.format.fontsize=fontsize;
udata.format.fontstyle=fontstyle;

setudata;
guidata(src,handles);

ravecreatecalculatedvalue(handles.fig,[]);

function prefix_Callback(src,ev)
handles=guidata(src);
getudata;
udata.format.prefix=get(src,'string');
setudata;
ravecreatecalculatedvalue(handles.fig,[]);


function suffix_Callback(src,ev)
handles=guidata(src);
getudata;
udata.format.suffix=get(src,'string');
setudata;
ravecreatecalculatedvalue(handles.fig,[]);


function format_Callback(src,ev)
handles=guidata(src);
getudata;
udata.format.format=get(src,'string');
setudata;
ravecreatecalculatedvalue(handles.fig,[]);


function colorblob_Callback(src,ev)
%callback for textbox text color buttons.
handles=guidata(src);
uicontrol(handles.dummyobj)

getudata
newcolor=get(src,'backgroundcolor');

%update fakerax userdata
udata.format.fg=get(src,'userdata');
udata.format.color=newcolor;
setudata;

%unpop blobs:
textblobs=findobj(handles.tabobjects,'tag','textblob');
set(textblobs,'value',0);
set(src,'value',1)

ravecreatecalculatedvalue(src,ev);

function colorrainbow_Callback(src,ev)
%callback for textbox text color buttons.
handles=guidata(src);
uicontrol(handles.dummyobj)

getudata
newcolor=ravecolorchooser(handles.fig,udata.format.color,'Choose a text color');

%update fakerax userdata
udata.format.fg=get(src,'userdata');
udata.format.color=newcolor;
setudata;

%unpop blobs:
textblobs=findobj(handles.tabobjects,'tag','textblob');
set(textblobs,'value',0);
set(src,'value',1)

ravecreatecalculatedvalue(src,ev);




function bgblob_Callback(src,ev)
handles=guidata(src);
uicontrol(handles.dummyobj)

colors=get(src,'userdata');
plotcolor=get(src,'backgroundcolor');

%update fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.bg=colors(3,1);
udata.format.bgcolor=plotcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%unpop blobs:
set(handles.bgblobs,'value',0);
set(src,'value',1)

%change colors
set(handles.allblockers(handles.activeindex),'facecolor',plotcolor)


function bgrainbow_Callback(src,ev)
handles=guidata(src);
uicontrol(handles.dummyobj)

getudata;
plotcolor=ravecolorchooser(handles.fig,udata.format.bgcolor,'Choose a background color');

%update fakerax userdata
udata.format.bg=5;
udata.format.bgcolor=plotcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%unpop blobs:
set(handles.bgblobs,'value',0);
set(src,'value',1)

%change colors
set(handles.allblockers(handles.activeindex),'facecolor',plotcolor)


function edgecheck_Callback(src,ev)

handles=guidata(src);
getudata;

udata.format.showedge=get(src,'value');

setudata;

if udata.format.showedge;
    set(handles.allblockers(handles.activeindex),'edgecolor',[0 0 0],'linewidth',1)
    
end


function condcheck1_Callback(src,ev)
handles=guidata(src);
getudata;
udata.format.usecondition1=get(src,'value');
setudata;
ravecreatecalculatedvalue(handles.fig,[]);

function condedit1_Callback(src,ev)
handles=guidata(src);
getudata;
udata.format.condition1=get(src,'string');
setudata;
ravecreatecalculatedvalue(handles.fig,[]);

function c1color_Callback(src,ev)
handles=guidata(src);
getudata;
newcolor=ravecolorchooser(handles.fig,udata.format.c1color,'Choose a text color');
set(src,'backgroundcolor',newcolor)
udata.format.c1color=newcolor;
setudata;
ravecreatecalculatedvalue(handles.fig,[]);

function c1bg_Callback(src,ev)
handles=guidata(src);
getudata;
newcolor=ravecolorchooser(handles.fig,udata.format.c1bg,'Choose a background color');
set(src,'backgroundcolor',newcolor)
udata.format.c1bg=newcolor;
setudata;
ravecreatecalculatedvalue(handles.fig,[]);


function condcheck2_Callback(src,ev)
handles=guidata(src);
getudata;
udata.format.usecondition2=get(src,'value');
setudata;
ravecreatecalculatedvalue(handles.fig,[]);

function condedit2_Callback(src,ev)
handles=guidata(src);
getudata;
udata.format.condition2=get(src,'string');
setudata;
ravecreatecalculatedvalue(handles.fig,[]);

function c2color_Callback(src,ev)
handles=guidata(src);
getudata;
newcolor=ravecolorchooser(handles.fig,udata.format.c2color,'Choose a text color');
set(src,'backgroundcolor',newcolor)
udata.format.c2color=newcolor;
setudata;
ravecreatecalculatedvalue(handles.fig,[]);

function c2bg_Callback(src,ev)
handles=guidata(src);
getudata;
newcolor=ravecolorchooser(handles.fig,udata.format.c2bg,'Choose a background color');
set(src,'backgroundcolor',newcolor)
udata.format.c2bg=newcolor;
setudata;
ravecreatecalculatedvalue(handles.fig,[]);

function constraintmenu_Callback(src,ev)



