function viewtabcalculatedvalue(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

d=udata.view.dataset;
a=udata.view.analysis;



%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
valuetext=text(.15-.10317,.77*1.0317-.0317,'Value','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


%% project:
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',a);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',d);



%% value:
splaintext=uicontrol('style','text','position',[origin(1)+15 origin(2)+400 240 70],'string','Enter expression for calculated value in the field below. Any MATLAB expression that evaluates to a single value may be entered.',...
    'horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.fig,'fontsize',10,'fontname','arial','foregroundcolor',[0 0 0],'fontweight','normal');

varlisttext=text(.17-.10317,.63*1.0317-.0317,'Click to insert variable name:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

constraintvarlist=uicontrol('position',[origin(1)+45 origin(2)+230+120 205 30],...
    'style','popupmenu','string',handles.allnames{d},'callback',@constraintvarlist_callback,...
    'backgroundcolor',[1 1 1],'tag','constraintvarlist');
%NOTE: constraintvarlist should always list all variables, even hidden columns.

%make java constraint editor:
j=javax.swing.JTextPane;
h=javax.swing.JScrollPane(j,javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
[crap,handy]=javacomponent(h,[origin(1)+15 origin(2)+110+120 235 120]); %#ok<NASGU>

j.setText(udata.view.expression)

crap.FocusLostCallback={@expressionedit_Callback,handles.fig};
crap.KeyTypedCallback=@expressionedit_Callback;
crap.KeyTypedCallback=@expressionedit_Callback;

applybutton=uicontrol('position',[origin(1)+90 origin(2)+202 160 20],...
    'style','pushbutton','string','Apply Changes','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@applybutton_Callback);

handles.tabobjects=[valuetext splaintext constraintvarlist  ...
    varlisttext handy analysistext datasettext analysismenu datasetmenu projecttext applybutton];

handles.javacomps=crap;
handles.temp.textpane=j;

guidata(src,handles);



function expressionedit_Callback(jsrc,jev,src)


function applybutton_Callback(src,ev)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');


jtext=handles.temp.textpane;
newstring=jtext.getText;
newstring=char(newstring);

if isempty(newstring) || isempty(newstring)
    return
end

udata.view.expression=newstring;

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatecalculatedvalue(handles.fig,[]);


function constraintvarlist_callback(src,ev) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

thisvariable=handles.allnames{udata.view.dataset}{get(src,'value')};
jtext=handles.temp.textpane;
caretpos=jtext.getCaretPosition;
currentstring=jtext.getText;
currentstring=char(currentstring);
newstring=[currentstring(1:caretpos),' ',thisvariable,' ',currentstring(caretpos+1:end)];
jtext.setText(newstring)
jtext.requestFocus

newcaretpos=caretpos+2+length(thisvariable);
jtext.setCaretPosition(newcaretpos);

