function formattabderivativeprofiler(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%rave format tab for a scatterplot matrix graph.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata'); %i think the (1) is for if multiple graphs are selected.

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% highlight the selected subplot... this only gets highlighted on the format tab, and goes away when you click another tab.
set(handles.activesubgraph,'xcolor',[1 .5 0],'ycolor',[1 .5 0]);


%% clear existing tab
delete(handles.tabobjects)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%find this subax in the matrix:
[r,c]=find(handles.subax{handles.activeindex}==handles.activesubgraph);


%% text headers
graphtext=text(.15-.10317,.97*1.0317-.0317,'Graph','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
axestext=text(.15-.10317,.85*1.0317-.0317,'Axes','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.515*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
optionstext=text(.15-.10317,0.15,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

%% GRAPH UICONTROLS

bgtext=uicontrol('position',[origin(1)+25 origin(2)+575 180 20],...
    'style','text','string','Background Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
gridtext=uicontrol('position',[origin(1)+25 origin(2)+550 180 20],...
    'style','text','string','Grid Lines:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

bgidx=udata.format.bg;

% color blobs: (userdata = gridcolor; textcolor; index)
bgwhite=uicontrol('position',[origin(1)+155 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{1}(2,:),'value',bgidx==1,...
    'callback',@bgblobsubax_callback,'userdata',1,'tag','bgblob');
bglight=uicontrol('position',[origin(1)+180 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{2}(2,:),'value',bgidx==2,...
    'callback',@bgblobsubax_callback,'userdata',2,'tag','bgblob');
bgdark=uicontrol('position',[origin(1)+205 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{3}(2,:),'value',bgidx==3,...
    'callback',@bgblobsubax_callback,'userdata',3,'tag','bgblob');
bgblack=uicontrol('position',[origin(1)+230 origin(2)+578 20 20],...
    'style','togglebutton','string','','backgroundcolor',handles.colors.axes{4}(2,:),'value',bgidx==4,...
    'callback',@bgblobsubax_callback,'userdata',4,'tag','bgblob');

gridindex=eye(3);
gridin=udata.format.grid;

%grid radios
nogrid=uicontrol('position',[origin(1)+100 origin(2)+551 60 20],...
    'style','radiobutton','string','None','backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(1,gridin),'callback',@nogrid_callback);
magrid=uicontrol('position',[origin(1)+152 origin(2)+551 60 20],...
    'style','radiobutton','string','Major','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(2,gridin),'callback',@magrid_callback);
migrid=uicontrol('position',[origin(1)+204 origin(2)+551 55 20],...
    'style','radiobutton','string','Minor','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',gridindex(3,gridin),'callback',@migrid_callback);

handles.gridchecks=[nogrid magrid migrid];

%% Axes UICONTROLS
globalcheck=uicontrol('position',[origin(1)+85 origin(2)+523 160 20],...
    'style','checkbox','string','Scale to global limits','backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',9,'horizontalalignment','left','value',udata.format.globallimits,'callback',@axislimit_callback);

xlim=get(handles.activesubgraph,'xlim'); %for scatterplot matrix, can select individual subplots and change their properities from here.
ylim=get(handles.activesubgraph,'ylim');

if udata.format.xlabelbelow && udata.view.showcurrentpoint
    xlab=get(get(handles.subax{handles.activeindex}(end,c),'xlabel'),'string');
    xlab=xlab{4};
elseif udata.format.xlabelbelow
    xlab=get(get(handles.subax{handles.activeindex}(end,c),'xlabel'),'string');
    xlab=xlab{3};
else
    xlab='';
end

if ~udata.view.singleyaxis
    ylab=get(get(handles.subax{handles.activeindex}(r,1),'ylabel'),'string');
    ylab=ylab{1};
else
    ylab='';
end

xlabeltext=uicontrol('position',[origin(1)+25 origin(2)+498 180 20],...
    'style','text','string','X Label:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xlimtext=uicontrol('position',[origin(1)+35 origin(2)+474 180 20],...
    'style','text','string','Limits:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xto=uicontrol('position',[origin(1)+158 origin(2)+474 20 20],...
    'style','text','string','to','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
xlabelbox=uicontrol('position',[origin(1)+85 origin(2)+500 160 20],...
    'style','edit','string',xlab,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@xlabel_callback);
xminbox=uicontrol('position',[origin(1)+85 origin(2)+476 70 20],...
    'style','edit','string',xlim(1),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmin_callback,...
    'tag','xminbox');
xmaxbox=uicontrol('position',[origin(1)+175 origin(2)+476 70 20],...
    'style','edit','string',xlim(2),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@xmax_callback,...
    'tag','xmaxbox');
xresetbutton=uicontrol('position',[origin(1)+85 origin(2)+452 160 20],...
    'style','pushbutton','string','Reset X Axis Limits','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@xresetbutton_callback);

ylabeltext=uicontrol('position',[origin(1)+25 origin(2)+410 180 20],...
    'style','text','string','Y Label:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
ylimtext=uicontrol('position',[origin(1)+35 origin(2)+386 180 20],...
    'style','text','string','Limits:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
yto=uicontrol('position',[origin(1)+158 origin(2)+386 20 20],...
    'style','text','string','to','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
ylabelbox=uicontrol('position',[origin(1)+85 origin(2)+412 160 20],...
    'style','edit','string',ylab,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@ylabel_callback);
yminbox=uicontrol('position',[origin(1)+85 origin(2)+388 70 20],...
    'style','edit','string',ylim(1),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@ymin_callback,...
    'tag','yminbox');
ymaxbox=uicontrol('position',[origin(1)+175 origin(2)+388 70 20],...
    'style','edit','string',ylim(2),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','center','callback',@ymax_callback,...
    'tag','ymaxbox');
yresetbutton=uicontrol('position',[origin(1)+85 origin(2)+364 160 20],...
    'style','pushbutton','string','Reset Y Axis Limits','backgroundcolor',handles.colors.buttonbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold','callback',@yresetbutton_callback);

titletext=uicontrol('position',[origin(1)+25 origin(2)+332 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

titel=findobj(handles.activegraph,'tag','title');

titlebox=uicontrol('position',[origin(1)+65 origin(2)+333 180 20],...
    'style','edit','string',get(titel,'string'),'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

%% DATA SERIES UICONTROLS

smoothtext=uicontrol('position',[origin(1)+25 origin(2)+274 180 20],...
    'style','text','string','Resolution:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

%smoothness slider:
[jslider hslider]=javacomponent('javax.swing.JSlider',[origin(1)+110 origin(2)+262 140 40]);
jslider.setPaintTicks(1)

jslider.setSnapToTicks(1)
jslider.setMinimum(4)
jslider.setMaximum(64)
jslider.setMajorTickSpacing(2);
jslider.setValue(udata.view.numpts);
set(jslider,'background',java.awt.Color.white)
set(jslider,'StateChangedCallback',{@jslider_Callback,handles.fig});

smoothtext2=uicontrol('position',[origin(1)+107 origin(2)+248 150 20],...
    'style','text','string','Low                                  High','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',8,'horizontalalignment','left','fontweight','normal');

linecolortext=uicontrol('position',[origin(1)+25 origin(2)+220 180 20],...
    'style','text','string','Profiler:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

haircolortext=uicontrol('position',[origin(1)+30 origin(2)+190-55+20+13 80 20],...
    'style','text','string','Tracer:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

linecolorbutton=uicontrol('position',[origin(1)+85 origin(2)+222 22 22],...
    'style','pushbutton','string','','backgroundcolor',udata.format.linecolor,'callback',@linecolor_Callback);

%width slider:
[jslider2 hslider2]=javacomponent('javax.swing.JSlider',[origin(1)+125 origin(2)+167-30+55+30 110 27]);
jslider2.setPaintTicks(1)
jslider2.setSnapToTicks(1)
jslider2.setMinimum(1)
jslider2.setMaximum(10)
jslider2.setMajorTickSpacing(1);
jslider2.setValue(udata.format.linesize);
set(jslider2,'background',java.awt.Color.white)
set(jslider2,'StateChangedCallback',{@linewidth_callback,handles.fig});

handles.javacomps=[jslider jslider2];

widthaxes=axes('units','pixels','position',[origin(1)+125 origin(2)+215 110 5],'visible','off');
gauge=imread('widthgauge.bmp');
image(gauge,'parent',widthaxes)
set(widthaxes,'visible','off');

haircolorbutton=uicontrol('position',[origin(1)+85 origin(2)+170 22 22],...
    'style','pushbutton','string','','backgroundcolor',udata.format.haircolor,'callback',@haircolor_Callback);

%width slider:
[jslider3 hslider3]=javacomponent('javax.swing.JSlider',[origin(1)+125 origin(2)+172 110 27]);
jslider3.setPaintTicks(1)
jslider3.setSnapToTicks(1)
jslider3.setMinimum(1)
jslider3.setMaximum(10)
jslider3.setMajorTickSpacing(1);
jslider3.setValue(udata.format.tracersize);
set(jslider3,'background',java.awt.Color.white)
set(jslider3,'StateChangedCallback',{@linewidth2_callback,handles.fig});

handles.javacomps=[jslider jslider2];

widthaxes2=axes('units','pixels','position',[origin(1)+125 origin(2)+164 110 5],'visible','off');
gauge=imread('widthgauge.bmp');
image(gauge,'parent',widthaxes2)
set(widthaxes2,'visible','off');


showtracertext=uicontrol('position',[origin(1)+40 origin(2)+136 80 20],...
    'style','text','string','Show:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal');

xhaircheck=uicontrol('position',[origin(1)+85 origin(2)+140 80 20],...
    'style','checkbox','string','X-Tracers',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.showxtracer,'callback',@xhaircheck_Callback);

yhaircheck=uicontrol('position',[origin(1)+170 origin(2)+140 80 20],...
    'style','checkbox','string','Y-Tracers',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.showytracer,'callback',@yhaircheck_Callback);

smartcolorcheck=uicontrol('position',[origin(1)+85 origin(2)+114 170 20],...
    'style','checkbox','string','Draw invalid tracers in gray',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.smarthaircolors,'callback',@smartcolor_Callback);

showpointscheck=uicontrol('position',[origin(1)+25 origin(2)+59 100 20],...
    'style','checkbox','string','Show Data Set',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.showpoints,'callback',@showpoints_Callback);

flatcolorcheck=uicontrol('position',[origin(1)+25 origin(2)+39 200 26],...
    'style','radiobutton','string','Fixed Color:',...
    'backgroundcolor',handles.colors.tabbg,'callback',@flatcolor_Callback,'tag','flatcolorcheck','visible','off');

ccolorcheck=uicontrol('position',[origin(1)+25 origin(2)+19 200 26],...
    'style','radiobutton','string','Color by Variable',...
    'backgroundcolor',handles.colors.tabbg,'callback',@ccolor_Callback,'tag','ccolorcheck','visible','off');

pointcolorbutton=uicontrol('position',[origin(1)+122 origin(2)+57 22 22],...
    'style','pushbutton','string','','backgroundcolor',udata.format.pointcolor,'callback',@pointcolor_Callback);

markersizeaxes=axes('units','pixels','position',[origin(1)+150 origin(2)+58 144 20],...
    'xlimmode','manual','ylimmode','manual','visible','off','nextplot','add','xcolor',[1 1 1],...
    'ycolor',[1 1 1],'zcolor',[1 1 1],'parent',handles.fig);
%gap=.9/7;
%markersizeoptions:
offcolor=[.9 .9 .9];
oncolor=handles.colors.text;
line(.05,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',1,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.12,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',4,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.22,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',5,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.33,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',8,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')
line(.45,.5,'marker',udata.format.marker,'parent',markersizeaxes,'markersize',10,'markerfacecolor',offcolor,'markeredgecolor',[0 0 0],'buttondownfcn',@sizeblob_callback,'tag','sizeblob')

%handles.sizeblobs=get(markersizeaxes,'children');

%make size blobs the right style

%color the selected blob
hhh=findobj(markersizeaxes,'markersize',udata.format.markersize);
set(hhh,'markerfacecolor',oncolor);

labelabovecheck=uicontrol('position',[origin(1)+25 origin(2)+35 170 20],...
    'style','checkbox','string','Show X labels above graphs',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.xlabelabove,'callback',@labelabovecheck_callback);
labelbelowcheck=uicontrol('position',[origin(1)+25 origin(2)+15 170 20],...
    'style','checkbox','string','Show X labels below graphs',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.xlabelabove,'callback',@labelbelowcheck_callback);

%% group items and finish up
handles.tabobjects=[graphtext axestext dataseriestext bgtext gridtext bgwhite...
    bglight bgdark bgblack nogrid magrid migrid xlabeltext ylabeltext...
    xlimtext ylimtext xlabelbox ylabelbox xminbox yminbox xto xmaxbox...
    xresetbutton yto ymaxbox yresetbutton showtracertext yhaircheck...
    titletext titlebox smoothtext smoothtext2 linecolortext haircolortext...
    linecolorbutton haircolorbutton smartcolorcheck hslider xhaircheck...
    widthaxes widthaxes2 hslider2 hslider3 showpointscheck pointcolorbutton...
    flatcolorcheck ccolorcheck globalcheck markersizeaxes optionstext...
    labelabovecheck labelbelowcheck];

handles.javacomps=[jslider jslider2 jslider3];

handles.activetab='format';

set(handles.infobar,'string','Note: You cannot change profiler variable values while on Format Tab')

guidata(src,handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function magrid_callback(src, eventdata)
handles=guidata(src);
%inputs=get(handles.fakerax{handles.activeindex},'userdata');

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=2;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.subfakerax{handles.activeindex},'XGrid','on','YGrid','on')
set(handles.subfakerax{handles.activeindex},'XminorGrid','off','YminorGrid','off')
set(handles.subfakeax{handles.activeindex},'XGrid','off','YGrid','off')

function migrid_callback(src, eventdata)
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)


%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=3;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(handles.subfakerax{handles.activeindex},'XminorGrid','on','YminorGrid','on')
set(handles.subfakerax{handles.activeindex},'XGrid','off','YGrid','off')
set(handles.subfakeax{handles.activeindex},'XGrid','on','YGrid','on')

function nogrid_callback(src, eventdata)
handles=guidata(src);

set(handles.gridchecks,'value',0)
set(src,'value',1)

%updata fakerax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.grid=1;
set(handles.fakeax(handles.activeindex),'userdata',udata);


set(handles.subfakerax{handles.activeindex},'XminorGrid','off','YminorGrid','off')
set(handles.subfakerax{handles.activeindex},'XGrid','off','YGrid','off')
set(handles.subfakeax{handles.activeindex},'XGrid','off','YGrid','off')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function xmin_callback(src, eventdata)

handles=guidata(src);
newval=str2double(get(src,'string'));
xlim=get(handles.activesubgraph,'xlim');
xlim(1)=newval;

%get coords of this subgraph:
[r,c]=find(handles.subax{handles.activeindex}==handles.activesubgraph);

set(handles.subax{handles.activeindex}(:,c),'xlim',xlim)
set(handles.subfakeax{handles.activeindex}(:,c),'xlim',xlim)
set(handles.subfakerax{handles.activeindex}(:,c),'xlim',xlim)

function xmax_callback(src, eventdata)
handles=guidata(src);
newval=str2double(get(src,'string'));
xlim=get(handles.activesubgraph,'xlim');
xlim(2)=newval;
[r,c]=find(handles.subax{handles.activeindex}==handles.activesubgraph);

set(handles.subax{handles.activeindex}(:,c),'xlim',xlim)
set(handles.subfakeax{handles.activeindex}(:,c),'xlim',xlim)
set(handles.subfakerax{handles.activeindex}(:,c),'xlim',xlim)

function ymin_callback(src, eventdata)

handles=guidata(src);
newval=str2double(get(src,'string'));
ylim=get(handles.activesubgraph,'ylim');
ylim(1)=newval;
[r,c]=find(handles.subax{handles.activeindex}==handles.activesubgraph); %#ok<NASGU>
set(handles.subax{handles.activeindex}(r,:),'ylim',ylim)
set(handles.subfakeax{handles.activeindex}(r,:),'ylim',ylim)
set(handles.subfakerax{handles.activeindex}(r,:),'ylim',ylim)


function ymax_callback(src, eventdata)

handles=guidata(src);
newval=str2double(get(src,'string'));
ylim=get(handles.activesubgraph,'ylim');
ylim(2)=newval;
[r,c]=find(handles.subax{handles.activeindex}==handles.activesubgraph); %#ok<NASGU>
set(handles.subax{handles.activeindex}(r,:),'ylim',ylim)
set(handles.subfakeax{handles.activeindex}(r,:),'ylim',ylim)
set(handles.subfakerax{handles.activeindex}(r,:),'ylim',ylim)


function xresetbutton_callback(src,eventdata)

handles=guidata(src);
set(handles.activesubgraph,'xlimmode','auto')
xlim=get(handles.activesubgraph,'xlim');

[r,c]=find(handles.subax{handles.activeindex}==handles.activesubgraph);
set(handles.subax{handles.activeindex}(:,c),'xlim',xlim)
set(handles.subfakeax{handles.activeindex}(:,c),'xlim',xlim)
set(handles.subfakerax{handles.activeindex}(:,c),'xlim',xlim)


xminbox=findobj(handles.tabobjects,'tag','xminbox');
xmaxbox=findobj(handles.tabobjects,'tag','xmaxbox');

set(xminbox,'string',num2str(xlim(1)))
set(xmaxbox,'string',num2str(xlim(2)))

function yresetbutton_callback(src,eventdata)

handles=guidata(src);
set(handles.activesubgraph,'ylimmode','auto')
ylim=get(handles.activesubgraph,'ylim');


[r,c]=find(handles.subax{handles.activeindex}==handles.activesubgraph); %#ok<NASGU>
set(handles.subax{handles.activeindex}(r,:),'ylim',ylim)
set(handles.subfakeax{handles.activeindex}(r,:),'ylim',ylim)
set(handles.subfakerax{handles.activeindex}(r,:),'ylim',ylim)

yminbox=findobj(handles.tabobjects,'tag','yminbox');
ymaxbox=findobj(handles.tabobjects,'tag','ymaxbox');

set(yminbox,'string',num2str(ylim(1)))
set(ymaxbox,'string',num2str(ylim(2)))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xlabel_callback(src,eventdata)

handles=guidata(src);
set(get(handles.activegraph,'xlabel'),'string',get(src,'string'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ylabel_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if udata.view.singleyaxis
    set(get(handles.subax{handles.activeindex}(1),'ylabel'),'string',{get(src,'string');'';'';''})
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function jslider_Callback(src,ev,fighandle) %#ok<INUSL>
moving = get(src,'ValueIsAdjusting');
if moving
    return
end

handles=guidata(fighandle);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.numpts=src.getValue;

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatederivativeprofiler(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function linecolor_Callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.linecolor=ravecolorchooser(handles.fig,udata.format.linecolor,'Pick a Color');

udata.format.linecolorString=num2str(udata.format.linecolor);
set(src,'backgroundcolor',udata.format.linecolor)

targets=findobj(cell2mat(get(handles.subax{handles.activeindex},'children')),'tag','keeper');
set(targets,'color',udata.format.linecolor)

set(handles.fakeax(handles.activeindex),'userdata',udata);

for r=1:size(handles.subax{handles.activeindex},1)
    oldstring=get(get(handles.subfakeax{handles.activeindex}(r,1),'ylabel'),'string');
    start=find(oldstring{1}=='{');
    finish=find(oldstring{1}=='}');
    newstring=[oldstring{1}(1:start),udata.format.linecolorString,oldstring{1}(finish:end)];
    set(get(handles.subfakeax{handles.activeindex}(r,1),'ylabel'),'string',{newstring;'';''});
end

for c=1:size(handles.subax{handles.activeindex},2)
    oldstring=get(get(handles.subfakeax{handles.activeindex}(end,c),'xlabel'),'string');
    start=find(oldstring{3}=='{');
    finish=find(oldstring{3}=='}');
    newstring=[oldstring{3}(1:start),udata.format.linecolorString,oldstring{3}(finish:end)];
    set(get(handles.subfakeax{handles.activeindex}(end,c),'xlabel'),'string',{' ';' ';newstring});
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function haircolor_Callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%udata.format.haircolor=uisetcolor(udata.format.haircolor);

oldcolor=udata.format.haircolor;
udata.format.haircolor=ravecolorchooser(handles.fig,udata.format.haircolor,'Pick a Color');

set(src,'backgroundcolor',udata.format.haircolor)

targets=findobj(cell2mat(get(handles.subax{handles.activeindex},'children')),'tag','hair','color',oldcolor);
set(targets,'color',udata.format.haircolor)

set(handles.fakeax(handles.activeindex),'userdata',udata);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function smartcolor_Callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.smarthaircolors=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatederivativeprofiler(src,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function title_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

titel=findobj(handles.activegraph,'tag','title');
titlestring=get(src,'string');
set(titel,'string',titlestring)

udata.format.title=titlestring;
set(handles.fakeax(handles.activeindex),'userdata',udata);

raveresizeaxes(handles.fig,[],handles.activeindex);
clear ravearrangeobjects

if isempty(titlestring)
    titoffset=0;
else
    titoffset=25;
end

handles=guidata(src);

%copied from ravemovegraph:
numy=size(handles.subax{handles.activeindex},1);
numx=size(handles.subax{handles.activeindex},2);
pos = get(handles.activegraph,'Position');

vspace=0.05;
hspace=0.00;

width = pos(3)/numx;
height = (pos(4)-titoffset)/numy;

pos(1:2) = pos(1:2) + [hspace*width vspace*height];

ax=handles.subax{handles.activeindex};
fakeax=handles.subfakeax{handles.activeindex};
fakerax=handles.subfakerax{handles.activeindex};

%set up grid of axes.
for r=numy:-1:1,
    for c=numx:-1:1,
        axPos = [pos(1)+(c-1)*width pos(2)+(numy-r)*height ...
            width*(1-hspace) height*(1-vspace)];
        set([ax(r,c) fakerax(r,c) fakeax(r,c)],'Position',axPos);
        
    end
end


function linewidth_callback(src,eventdata,fighandle) %#ok<INUSL>
handles=guidata(fighandle);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.linesize=src.getValue/2;
set(handles.fakeax(handles.activeindex),'userdata',udata);
targets=findobj(handles.subax{handles.activeindex},'tag','keeper');
set(targets,'linewidth',udata.format.linesize);

function linewidth2_callback(src,eventdata,fighandle) %#ok<INUSL>
handles=guidata(fighandle);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.tracersize=src.getValue/2;
set(handles.fakeax(handles.activeindex),'userdata',udata);
set(udata.view.xhair,'linewidth',udata.format.tracersize);
set(udata.view.yhair,'linewidth',udata.format.tracersize);

function showpoints_Callback(src,ev)
handles=guidata(src);

%update inputs

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.showpoints=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatederivativeprofiler(src,[]);


function pointcolor_Callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.pointcolor=ravecolorchooser(handles.fig,udata.format.haircolor,'Pick a Color');
set(src,'backgroundcolor',udata.format.pointcolor)

chd=get(handles.subax{handles.activeindex},'children');
if iscell(chd);chd=cell2mat(chd);end

targets=findobj(chd,'tag','points');
set(targets,'markerfacecolor',udata.format.pointcolor)

set(handles.fakeax(handles.activeindex),'userdata',udata);


function flatcolor_Callback(src,ev)

function ccolor_Callback(src,ev)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function axislimit_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.globallimits=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatederivativeprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function lineblob_callback(src,ev)
handles=guidata(src);
lineblobs=findobj(handles.tabobjects,'tag','lineblob');

offcolor=[.5 .5 .5];
set(lineblobs,'color',offcolor)
set(src,'color',handles.colors.text)

%update inputs
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.linestyle=get(src,'linestyle');
set(handles.fakeax(handles.activeindex),'userdata',udata);


%get target data series
targets=findobj(handles.subax{handles.activeindex},'tag','hair');

%update graph
set(targets,'linestyle',get(src,'linestyle'));


function xhaircheck_Callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.showxtracer=get(src,'value');

if get(src,'value')
    set(udata.view.xhair,'visible','on')
else
    set(udata.view.xhair,'visible','off')
end
set(handles.fakeax(handles.activeindex),'userdata',udata)

function yhaircheck_Callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.showytracer=get(src,'value');

if get(src,'value')
    set(udata.view.yhair,'visible','on')
else
    set(udata.view.yhair,'visible','off')
end
set(handles.fakeax(handles.activeindex),'userdata',udata)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizeblob_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
offcolor=[.9 .9 .9];
oncolor=handles.colors.text;
sizeblobs=findobj(handles.tabobjects,'tag','sizeblob');

%get new size:
newsize=get(src,'markersize');

udata.format.markersize=newsize;
set(sizeblobs,'markerfacecolor',offcolor)
set(src,'markerfacecolor',oncolor)


set(handles.fakeax(handles.activeindex),'userdata',udata);

points=findobj(handles.subax{handles.activeindex},'tag','points');
set(points,'markersize',newsize);


function labelabovecheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.xlabelabove=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatederivativeprofiler(src,ev);


function labelbelowcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.xlabelbelow=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatederivativeprofiler(src,ev);


