function handles=raveupdatecarpet2dxdials(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);
%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');

%inputs=varargin{3};

targetaxes=handles.activegraph; %=handles.activegraph

xcol=udata.view.x;
ycol=udata.view.y;
zcol=udata.view.z; %"sweep through values of"
ccol=udata.view.c; %"draw a line for each value of"

a=udata.view.analysis;
d=udata.view.dataset; %data set index

sweepvar1=zcol;
[sweepvalues1,totalrows]=ravecalculatexsteps(handles.fig,d,a,sweepvar1,udata.view.numpts1,0);
sweepvalues1=sweepvalues1{1};

sweepvar2=ccol;
if ccol==0
    sweepvalues2=[1];
else
    [sweepvalues2,totalrows]=ravecalculatexsteps(handles.fig,d,a,sweepvar2,udata.view.numpts2,0);
    sweepvalues2=sweepvalues2{1};
end

if numel(sweepvalues1)==1;
    sweepvalues1=[sweepvalues1 sweepvalues1];
end

if numel(sweepvalues2)==1;
    sweepvalues2=[sweepvalues2 sweepvalues2];
end


if ccol~=zcol && ccol~=0 && ~isempty(udata.view.steps)
    zcalldata=repmat(sweepvalues1(:),numel(udata.view.steps),1);
    stepdata=repmat(udata.view.steps(:)',numel(sweepvalues1),1);
    stepdata=stepdata(:);
    
else
    zcalldata=sweepvalues1(:);
    stepdata=[];
end

[S1,S2]=meshgrid(sweepvalues1,sweepvalues2);

S1=S1(:);
S2=S2(:);

constants=repmat(handles.xdials{d}{a},[length(S1),1]);
constants(:,zcol)=S1;
if ccol~=0
    constants(:,ccol)=S2;
end

%evaluate the functions:

outvalues=raveevaluatefunction(src,d,[udata.view.x udata.view.y],constants);
xvalues=outvalues(:,1);
yvalues=outvalues(:,2);

[S1,S2]=meshgrid(sweepvalues1,sweepvalues2);

Xvalues=reshape(xvalues,size(S1));
Yvalues=reshape(yvalues,size(S2));

Zvalues=zeros(size(S1));

% constants(:,xcol)=xvalues;
% constants(:,ycol)=yvalues;
%
% ncurves=numel(zcalldata)./numel(sweepvalues1);
% npts=numel(sweepvalues1);

%if ccol~=0

%normalize cdata to desired colormap:
if ~udata.format.reversecolors1
    C1=(S1-min(S1(:)))/(max(S1(:))-min(S1(:))).*127+1+128.*(udata.format.mcmap1-1);
else
    C1=-(S1-min(S1(:)))/(max(S1(:))-min(S1(:)))*127+128*(udata.format.mcmap1);
end

%normalize cdata to desired colormap:
if ~udata.format.reversecolors2
    C2=(S2-min(S2(:)))/(max(S2(:))-min(S2(:))).*127+1+128.*(udata.format.mcmap2-1);
else
    C2=-(S2-min(S2(:)))/(max(S2(:))-min(S2(:)))*127+128*(udata.format.mcmap2);
end

set(targetaxes,'climmode','manual','clim',[1 size(get(handles.fig,'colormap'),1)]);



doupdate=0;
if min(Xvalues(:))<handles.minlimit{d}{a}(udata.view.x);handles.minlimit{d}{a}(udata.view.x)=min(Xvalues(:));doupdate=1;end
if max(Xvalues(:))>handles.maxlimit{d}{a}(udata.view.x);handles.maxlimit{d}{a}(udata.view.x)=max(Xvalues(:));doupdate=1;end
if min(Yvalues(:))<handles.minlimit{d}{a}(udata.view.y);handles.minlimit{d}{a}(udata.view.y)=min(Yvalues(:));doupdate=1;end
if max(Yvalues(:))>handles.maxlimit{d}{a}(udata.view.y);handles.maxlimit{d}{a}(udata.view.y)=max(Yvalues(:));doupdate=1;end


set(udata.view.surfacehandles(1),'xdata',Xvalues,'ydata',Yvalues,'zdata',Zvalues,'cdata',C1);
set(udata.view.surfacehandles(2),'xdata',Xvalues,'ydata',Yvalues,'zdata',Zvalues,'cdata',C2);

% 
% if ~udata.view.isvisible1;set(surf2,'visible','off');end
% if ~udata.view.isvisible2;set(surf1,'visible','off');end

%make current point:
if udata.view.showcurrentpoint
    cp=handles.xdials{d}{a};
    cpz=raveevaluatefunction(src,d,[xcol ycol],cp);
    set(udata.view.currentpointhandle,'xdata',cpz(1),'ydata',cpz(2));
end



if doupdate;
    
    xlim=[handles.minlimit{d}{a}(udata.view.x) handles.maxlimit{d}{a}(udata.view.x)];
    ylim=[handles.minlimit{d}{a}(udata.view.y) handles.maxlimit{d}{a}(udata.view.y)];
    set(targetaxes,'xlim',[xlim(1)-0.02*diff(xlim) xlim(2)+0.02*diff(xlim)],'ylim',[ylim(1)-0.02*diff(ylim) ylim(2)+0.02*diff(ylim)]);
    
    xlim = get(targetaxes,'xlim');
    ylim = get(targetaxes,'ylim');
    
    set(handles.fakeax(handles.activeindex),'xlim',xlim,'ylim',ylim);
    set(handles.fakerax(handles.activeindex),'xlim',xlim,'ylim',ylim);
    
 %  guidata(handles.fig,handles);
    
end


