function pointselectscattergrad3D(src,ev)
handles=guidata(src);

if ~strcmp(handles.selectionmode,'point');return;end
set(handles.infobar,'string','Shift+Click to add points to current selection, Alt+Click to remove from selection');
%determine which point was clicked:
handles=guidata(src);

ai=find(handles.allgraphs==get(src,'parent'));
udata=get(handles.fakeax(ai),'userdata');

%make uv coordinates:
%check that they clicked on current graph:
z = get(gca,'CameraTarget') - get(gca,'CameraPosition');
z = z./norm(z,2);
u = rand(1,3);
u = u - dot(z,u).*z;
u = u./norm(u);
v = cross(u,z);

d=udata.view.dataset;
a=udata.view.analysis;

handles.temp.selected=findobj(handles.allgraphs(ai),'tag','selected');

clicked=get(handles.allgraphs(ai),'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
zclick=clicked(1,3,1);
point=[xclick yclick zclick];

uclick = dot(point,u);
vclick = dot(point,v);



%convert xclick/yclick to pixels.
xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);
zdata=handles.alldata{udata.view.dataset}(:,udata.view.z);

if udata.view.c~=0
    cdata=handles.alldata{udata.view.dataset}(:,udata.view.c);
else
    if udata.format.ncolor
        cdata=rand(length(xdata),1)-.5; %noisy colors
    else
        cdata=zeros(length(xdata),1); %non-noisy colors cdata=0.5
    end
end

if udata.view.s~=0
    s=handles.alldata{udata.view.dataset}(:,udata.view.s);
    isallonesize=0;
    minsize=udata.format.minmarkersize;
    maxsize=udata.format.maxmarkersize;
    sdata=(((s-min(s))/(max(s)-min(s))).^2)*maxsize + minsize + rand(length(xdata),1)/100;
else
    sdata=ones(length(xdata),1);
    isallonesize=1;
end

nothidden=handles.isvisible{d}{a};

%project this data into uv plane:
pointdata=[xdata(:) ydata(:) zdata(:)];
pointdata=pointdata(nothidden,:);

uudata=pointdata*u';
vdata=pointdata*v';


ulim=[min(uudata) max(uudata)];
vlim=[min(vdata) max(vdata)];

Uclick=(uclick-ulim(1))/(ulim(2)-ulim(1));
Vclick=(vclick-vlim(1))/(vlim(2)-vlim(1));

Udata=(uudata-ulim(1))/(ulim(2)-ulim(1));
Vdata=(vdata-vlim(1))/(vlim(2)-vlim(1));


Udiff=Udata-Uclick;
Vdiff=Vdata-Vclick;

distnce=sqrt(Udiff.^2+Vdiff.^2);

index = distnce==min(distnce);

index=index(:); %make sure it's a column.

if sum(index)>1
    thispoint=find(distnce==min(distnce),1);
    index=false(size(distnce));
    index(thispoint)=true;
end

inpoints=index;

%ravefindclosestpoint2D does not return correct index since some points may be hidden... expand out for hidden points:
 visiblepoints=find(handles.isvisible{d}{a});
 selectedpoint=visiblepoints(inpoints);
 realpoints=false(size(handles.isvisible{d}{a}));
 realpoints(selectedpoint)=true;
% 
% 
 inpoints=realpoints;

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    inpoints=handles.isselected{d}{a} | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{d}{a};
    lastselected(inpoints)=false;
    inpoints=lastselected;
end

handles.isselected{d}{a}=inpoints;

handles.lastd=d;
handles.lasta=a;

guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',[],d,a);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=handles.alldata{udata.view.dataset}(inpoints,:);
    guidata(src,handles);
    raveupdateanalysis(src,[],'xdials',[],d,a);
end







