function updatescattergrad3Disselected(src,ai,isselected)
%updates the scatter plot with index ai to display the selection in
%isselected (logical)

handles=guidata(src);
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

x=handles.alldata{d}(:,udata.view.x);
y=handles.alldata{d}(:,udata.view.y);
z=handles.alldata{d}(:,udata.view.z);

if nargin<3
isselected=handles.isselected{d}{a}; 
end


nothidden=handles.isvisible{d}{a};

selpatchhandles=udata.view.selhandles;
patchidx=udata.view.patchidx;
npatches=max(patchidx);
%selected handles
for j=1:npatches
    selidx=patchidx==j & isselected & nothidden;
    if any(selidx)
        set(selpatchhandles(j),'xdata',x(selidx),'ydata',y(selidx),'zdata',z(selidx),'visible','on');
    else
        set(selpatchhandles(j),'visible','off');
    end
end

