function raveresizeaxessliders(src,eventdata,targetindex) %#ok<INUSL>

% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2012 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


handles=guidata(src);
udata=get(handles.fakeax(targetindex),'userdata');

targetaxes=handles.allgraphs(targetindex);
targetpos=get(handles.allblockers(targetindex),'position');

charwidths=handles.prefs.fonts.graphwidths;

%size inset for 10 characters at width of max-width numeral:
maxw=max(charwidths(48:57));
inset=[20 10 10*maxw+30 10];
targetpos=targetpos+[inset(1) inset(2) -(inset(1)+inset(3)) -(inset(2)+inset(4))];

%determine width of variable names:
varnames=handles.allnames{udata.view.dataset}(udata.view.x);

maxnamew=0;
for g=1:numel(varnames)
    namew=sum(charwidths(varnames{g}));
    if namew>maxnamew
        maxnamew=namew;
    end    
end

%allow space for names:
targetpos=targetpos+[maxnamew+15 0 -maxnamew-15 0];


%% Resize graph:
if targetpos(3)<5;targetpos(3)=5;end
if targetpos(4)<5;targetpos(4)=5;end
newpos=floor(targetpos);
set(targetaxes,'position',newpos)
set(handles.fakeax(targetindex),'position',newpos)
set(handles.fakerax(targetindex),'position',newpos)

%% do layout:
ravearrangeobjects(handles.activegraph,[]);

