function handles=raveupdateslidersxdials(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.handles=guidata(src);


%handles=guidata(src);
getudata;

d=udata.view.dataset;
a=udata.view.analysis;

txts=udata.view.valtexts;
blobs=udata.view.blobs;

if numel(blobs)>1
thesevars=cell2mat(get(blobs(logical(blobs)),'userdata'));
else
 thesevars=get(blobs(logical(blobs)),'userdata');
end

ranges=[handles.minlimit{d}{a}' handles.maxlimit{d}{a}'];
xdials=handles.xdials{d}{a};
startvalues=(xdials-ranges(:,1)')./(ranges(:,2)'-ranges(:,1)')*.3+.43;
startvalues(isinf(startvalues))=0.58; %mid range.
startvalues(isnan(startvalues))=0.58;

datatypes=handles.datatype{d};
for t=1:numel(thesevars)
    thisvar=thesevars(t);
    thistype=datatypes{thisvar};
    val=xdials(thisvar);
    
    %make current value texts:
    if ~any(strcmp(thistype,{'string','logical'}))
        valtext=strtrim(sprintf(udata.format.formatstring,val));
    elseif strcmp(thistype,'string')
        valtext=handles.discretevalues{d}{a}{xcol(t)}{val};
    else %logical
        if val
            valtext=handles.prefs.logicaltrue;
        else
            valtext=handles.prefs.logicalfalse;
        end
    end
    
    oor=false; %oor=out of range
    if startvalues(thisvar)<.43
        startvalues(thisvar)=.43;
        oor=true;
    elseif startvalues(thisvar)>.73
        startvalues(thisvar)=.73;
        oor=true;
    end
    
    if oor
        set(txts(t),'color',[1 0 0])
    else
        set(txts(t),'color',[0 0 0])
    end
    
    
    set(txts(t),'string',valtext)
    set(blobs(t),'xdata',startvalues(thisvar))
    
end

