function handles=raveupdatediscretefilterisfiltered(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.handles=guidata(src);

udata=get(handles.fakeax(handles.activeindex),'userdata');

targetaxes=handles.activegraph; %=handles.activegraph
xcol=udata.view.x;
a=udata.view.analysis;
d=udata.view.dataset; %data set index

newselection=handles.discretefilter{d}{a}{xcol};

img=findobj(udata.view.tax,'type','image');

set(img,'userdata',newselection);
numrows=size(newselection,1);

rowheight=udata.format.rowheight;
axescolors=handles.colors.axes{udata.format.bg};
unselectedcolor=axescolors(2,:);
txt=axescolors(5,:);
selectedcolor=udata.format.selectedcolor;

t=ones(numrows*rowheight,1,3);
t(:,:,1)=unselectedcolor(1);
t(:,:,2)=unselectedcolor(2);
t(:,:,3)=unselectedcolor(3);

%color according to row state:
selectedrows=find(newselection);
adders=repmat(0:rowheight-1,size(selectedrows,1),1);
pixes=selectedrows(:).*rowheight-rowheight;
pixes=bsxfun(@plus,pixes,adders);
pixes=pixes(:)+1;
t(pixes,:,1)=selectedcolor(1);
t(pixes,:,2)=selectedcolor(2);
t(pixes,:,3)=selectedcolor(3);

%color text:
txts=get(udata.view.tax,'userdata');
set(txts,'color',txt);

alpha=[0.299 0.587 0.114]'*selectedcolor;

if alpha<0.5
    set(txts(selectedrows),'color',[1 1 1])
else
    set(txts(selectedrows),'color',[0 0 0])
end

set(img,'cdata',t);

