function viewtabdiscretefilter(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% clear existing tab
delete(handles.tabobjects)

d=udata.view.dataset;
a=udata.view.analysis;


%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

optionstext=text(.15-.10317,.27,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');

datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

xaxistext=text(.25-.10317,.72*1.0317-.0317,'Choose Variable to Display:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

infotext=text(.25-.10317,.64,{'Note: Filters are enforced for all ';'variables, regardless of if they';'are currently selected above.'},'horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',9,'fontname','arial','color',[0 0 0],'fontweight','normal','ver','top');

intext=text(.5,.25,'In','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',9,'fontname','arial','color',[0 0 0],'fontweight','bold','ver','top');

outtext=text(.65,.25,'Out','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',9,'fontname','arial','color',[0 0 0],'fontweight','bold','ver','top');

nonetext=text(.81,.25,'None','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',9,'fontname','arial','color',[0 0 0],'fontweight','bold','ver','top');

astext=text(.25-.10317,.22,'Auto Select','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',9,'fontname','arial','color',[0 0 0],'fontweight','normal','ver','top');
ahtext=text(.25-.10317,.19,'Auto Hide','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',9,'fontname','arial','color',[0 0 0],'fontweight','normal','ver','top');


if udata.view.autoselectin
    selects=[1 0 0];
elseif udata.view.autoselectout
    selects=[0 1 0];
else
    selects=[0 0 1];
end

if udata.view.autohidein
    hides=[1 0 0];
elseif udata.view.autohideout
    hides=[0 1 0];
else
    hides=[0 0 1];
end

sinbox=uicontrol('style','radio','string','','pos',[origin(1)+127 origin(2)+124 16 16],'backgroundcolor',handles.colors.tabbg,'callback',@autoselect_callback,'tag','in','value',selects(1));
soutbox=uicontrol('style','radio','string','','pos',[origin(1)+172 origin(2)+124 16 16],'backgroundcolor',handles.colors.tabbg,'callback',@autoselect_callback,'tag','out','value',selects(2));
snonebox=uicontrol('style','radio','string','','pos',[origin(1)+172+45 origin(2)+124 16 16],'backgroundcolor',handles.colors.tabbg,'callback',@autoselect_callback,'tag','none','value',selects(3));
hinbox=uicontrol('style','radio','string','','pos',[origin(1)+127 origin(2)+104 16 16],'backgroundcolor',handles.colors.tabbg,'callback',@autohide_callback,'tag','in','value',hides(1));
houtbox=uicontrol('style','radio','string','','pos',[origin(1)+172 origin(2)+104 16 16],'backgroundcolor',handles.colors.tabbg,'callback',@autohide_callback,'tag','out','value',hides(2));
hnonebox=uicontrol('style','radio','string','','pos',[origin(1)+172+45 origin(2)+104 16 16],'backgroundcolor',handles.colors.tabbg,'callback',@autohide_callback,'tag','none','value',hides(3));

%% variable lists

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+540 180 30],...
    'style','popupmenu','string',handles.analysisnames,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','callback',@analysismenu_callback,...
    'value',a);

datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+495 180 30],...
    'style','popupmenu','string',handles.datasetnames,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',d,'callback',@datasetmenu_callback);

if udata.view.x>0
    xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+85+155+178 190 22],...
        'style','popupmenu','string',handles.allnames{d},...
        'backgroundcolor',[1 1 1],'tag','xaxismenu','value',udata.view.x,'callback',@xmenu_callback);
else
    xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+85+155+178 190 22],...
        'style','text','string','No Discrete Variables Found!',...
        'backgroundcolor',[1 1 1],'foregroundcolor',[.8 0 0]);
end

%% group items and finish up
handles.tabobjects=[datasettext xaxistext datasetmenu xaxismenu ,...
    analysistext projecttext analysismenu dataseriestext optionstext infotext astext,...
    intext outtext nonetext ahtext sinbox soutbox snonebox hinbox houtbox hnonebox];

handles.activetab='view';

guidata(src,handles);


function xmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.x=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatediscretefilter(src,[])

function datasetmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.dataset=get(src,'value');

[junk,idx]=ismember({'integer','discrete','string'},handles.datatype{udata.view.dataset});
idx=idx(idx>0);

if ~isempty(idx)
    udata.view.x=idx(1);
else
    udata.view.x=0;
end

set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);
ravecreatediscretefilter(src,[])
viewtabdiscretefilter(handles.fig,[]);

function analysismenu_callback(src,ev)
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatediscretefilter(src,[]);


function autoselect_callback(src,ev)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

selectblobs=findobj(handles.tabobjects,'callback',@autoselect_callback);
set(selectblobs,'value',0);
set(src,'value',1);

switch(get(src,'tag'))
    case 'in'
        udata.view.autoselectin=1;
        udata.view.autoselectout=0;
    case 'out'
        udata.view.autoselectin=0;
        udata.view.autoselectout=1;
    case 'none'
        udata.view.autoselectin=0;
        udata.view.autoselectout=0;
end

set(handles.fakeax(handles.activeindex),'userdata',udata)


function autohide_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

hideblobs=findobj(handles.tabobjects,'callback',@autohide_callback);
set(hideblobs,'value',0);
set(src,'value',1);

switch(get(src,'tag'))
    case 'in'
        udata.view.autohidein=1;
        udata.view.autohideout=0;
    case 'out'
        udata.view.autohidein=0;
        udata.view.autohideout=1;
    case 'none'
        udata.view.autohidein=0;
        udata.view.autohideout=0;
end

set(handles.fakeax(handles.activeindex),'userdata',udata)
