function ravearrangeobjectsgraphaxes(src,ev,ai)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

if nargin<3
    ai=handles.activeindex;
end



udata=get(handles.fakeax(ai),'userdata');

%raveresizeaxes(src,[],handles.activeindex)
pos=get(handles.activegraph,'position');


set(handles.activegraph,'xlim',[1 pos(3)],'ylim',[1 pos(4)]);
%set(handles.fakeax(handles.activeindex),'userdata',udata);



hasxmenu=udata.view.ispresent(1) && udata.view.isvisible(1);
hasymenu=udata.view.ispresent(2) && udata.view.isvisible(2);
haszmenu=udata.view.ispresent(3) && udata.view.isvisible(3);
hascmenu=udata.view.ispresent(4) && udata.view.isvisible(4);
hassmenu=udata.view.ispresent(5) && udata.view.isvisible(5);




switch udata.format.layout
    case 'horizontal'
        off=0;
        if hasxmenu
            set(udata.view.X.menutext,'position',[0,pos(4)-10]);
            set(udata.view.X.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.X.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-32 200 0.1]);
            off=off+220;
        end
        
        if hasymenu
            set(udata.view.Y.menutext,'position',[off,pos(4)-10]);
            set(udata.view.Y.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.Y.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 0.1]);
            off=off+220;
        end
        
        if haszmenu
            set(udata.view.Z.menutext,'position',[off,pos(4)-10]);
            set(udata.view.Z.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.Z.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 0.1]);
            off=off+220;
        end
        
        if hascmenu
            set(udata.view.C.menutext,'position',[off,pos(4)-10]);
            set(udata.view.C.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.C.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 0.1]);
            off=off+220;
        end
        
        if hassmenu
            set(udata.view.S.menutext,'position',[off,pos(4)-10]);
            set(udata.view.S.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.S.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 0.1]);
        end
        
    case 'vertical'
        off=10;
        if hasxmenu
            set(udata.view.X.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.X.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.X.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        if hasymenu
            set(udata.view.Y.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.Y.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.Y.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        if haszmenu
            set(udata.view.Z.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.Z.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.Z.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        if hascmenu
            set(udata.view.C.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.C.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.C.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        if hassmenu
            set(udata.view.S.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.S.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.S.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
        end
        
    case 'tworow'
        off=0;
        if hasxmenu
            set(udata.view.X.menutext,'position',[0,pos(4)-10]);
            set(udata.view.X.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.X.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-32 200 0.1]);
            off=off+220;
        end
        
        if hasymenu
            set(udata.view.Y.menutext,'position',[off,pos(4)-10]);
            set(udata.view.Y.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.Y.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 0.1]);
            off=off+220;
        end
        
        if haszmenu
            set(udata.view.Z.menutext,'position',[off,pos(4)-10]);
            set(udata.view.Z.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 18]);
            set(udata.view.Z.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32 200 0.1]);
            off=off+220;
        end
        off=0;
        if hascmenu
            set(udata.view.C.menutext,'position',[off,pos(4)-10-47]);
            set(udata.view.C.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32-47 200 18]);
            set(udata.view.C.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32-47 200 0.1]);
            off=off+220;
        end
        
        if hassmenu
            set(udata.view.S.menutext,'position',[off,pos(4)-10-47]);
            set(udata.view.S.menuobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32-47 200 18]);
            set(udata.view.S.menujobj,'position',[pos(1)+off+10,pos(2)+pos(4)-32-47 200 0.1]);
        end
        
    case 'twocol'
        off=10;
        if hasxmenu
            set(udata.view.X.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.X.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.X.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        if hasymenu
            set(udata.view.Y.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.Y.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.Y.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        if haszmenu
            set(udata.view.Z.menutext,'position',[0,pos(4)-off]);
            off=off+22;
            set(udata.view.Z.menuobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 18]);
            set(udata.view.Z.menujobj,'position',[pos(1)+10,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        off=10;
        
        if hascmenu
            set(udata.view.C.menutext,'position',[0+220,pos(4)-off]);
            off=off+22;
            set(udata.view.C.menuobj,'position',[pos(1)+10+220,pos(2)+pos(4)-off 200 18]);
            set(udata.view.C.menujobj,'position',[pos(1)+10+220,pos(2)+pos(4)-off 200 0.1]);
            off=off+25;
        end
        
        if hassmenu
            set(udata.view.S.menutext,'position',[0+220,pos(4)-off]);
            off=off+22;
            set(udata.view.S.menuobj,'position',[pos(1)+10+220,pos(2)+pos(4)-off 200 18]);
            set(udata.view.S.menujobj,'position',[pos(1)+10+220,pos(2)+pos(4)-off 200 0.1]);
        end
end





