function ravecreateappendcurrentpointbutton(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');


targetaxes=handles.activegraph; %=handles.activegraph
xcol=udata.view.x;
a=udata.view.analysis;
d=udata.view.dataset; %data set index

set(targetaxes,'visible','off')
set(handles.fakeax(handles.activeindex),'visible','off')
set(handles.fakerax(handles.activeindex),'visible','off')

origin=get(targetaxes,'position');

%make pixel coordinates:
set(targetaxes,'xlim',[1 origin(3)],'ylim',[1 origin(4)],'xticklabel','','yticklabel','');
thebutton=drawpushbutton(handles.wspanel,[origin(1)+5 origin(2)+5 200 26],handles.colors.togglebuttonbg,[],'Add Current Point to Data Set',@appendbutton_callback);

set(thebutton,'userdata',handles.activeindex);

udata.view.thebutton=thebutton;

set(handles.fakeax(handles.activeindex),'userdata',udata);

raveresizeaxes(handles.fig,[],handles.activeindex);
clear ravearrangeobjects

function appendbutton_callback(src,ev,value)
handles=guidata(src);

ai=get(src,'userdata');

udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;
cp=handles.xdials{d}{a};
funz=find(handles.isfunction{d});
yout=raveevaluatefunction(src,d,funz,cp);
cp(funz)=yout;

%avoid appending this row if it is identical to the last row (i.e. if they
%double clicked the button)
if all(cp==handles.alldata{d}(end,:));return;end

raveappendrows(handles.fig,[],d,cp,udata.view.rowcolor,udata.view.isselected,udata.view.isvisible,udata.view.ispointofinterest)



