function handles=raveupdatescattermatrixisfiltered(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);
getudata;
ai=handles.activeindex;

d=udata.view.dataset;
a=udata.view.analysis;

nothidden=handles.isvisible{d}{a};
isfiltered=handles.isfiltered{d}{a};

switch udata.view.layout
    case {'square';'upper';'lower'}
        xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
        ydata=handles.alldata{udata.view.dataset}(:,udata.view.x);
    otherwise
        xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
        ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);
end

%update other scatters:

filtered=udata.view.filteredhandles;
main=udata.view.mainhandles;



for r=1:size(handles.subax{ai},1)
    for c=1:size(handles.subax{ai},2)
        
        if strcmp(udata.view.layout,'square') && r==c
            continue
        end
        
        %FILTERED DATA
        if ~isempty(xdata) && any(nothidden & isfiltered)
            set(filtered(r,c),'xdata',xdata(nothidden & isfiltered,c),'ydata',ydata(nothidden & isfiltered,r),'visible','on');
        elseif ~isempty(xdata)
            set(filtered(r,c),'xdata',xdata(1,c),'ydata',ydata(1,r),'visible','off');
        end
        
        %MAIN DATA
        if ~udata.view.c %make as lines:
            rowcolors=handles.rowcolors{udata.view.dataset}{udata.view.analysis};
            %main data series:
            for s=1:10;
                if any(rowcolors==s & nothidden & ~isfiltered)
                    set(main(r,c,s),'xdata',xdata(rowcolors==s & nothidden & ~isfiltered,c),'ydata',ydata(rowcolors==s & nothidden & ~isfiltered,r),'visible','on');
                elseif ~isempty(xdata)
                    set(main(r,c,s),'xdata',xdata(1,c),'ydata',ydata(1,r),'visible','off');
                end
            end
            
        else %make as patches:
            
            cdata=handles.alldata{d}(:,udata.view.c);
            %normalize cdata to desired colormap:
            if min(cdata)~=max(cdata)
                cdata=(cdata-min(cdata))/(max(cdata)-min(cdata))*127+128*(udata.format.mcmap-1)+1;
            else
                cdata=(128*(udata.format.mcmap-1)+64)*ones(size(xdata,1),1);
            end
            
           mainidx=~isfiltered & nothidden;
           if any(mainidx)
               set(main(r,c),'xdata',xdata(mainidx,c),'ydata',ydata(mainidx,r),'cdata',cdata(mainidx));
            else
               set(main(r,c),'xdata',xdata(1,c),'ydata',ydata(1,r),'cdata',cdata(1));
           end
            
         
%             set(main(r,c),'xdata',xdata(nothidden & ~isfiltered,c),'ydata',ydata(nothidden & ~isfiltered,r),...
%                 'sizedata',s(nothidden & ~isfiltered),'cdata',cdata,'visible','on');
%             
        end
        
    end
end


switch udata.view.layout
    case {'square';'upper';'lower'}
        for k=1:numel(udata.view.x)
            try %gives error if data set is empty
                set(main(k,k,:),'visible','off','tag','nevershow');
                set(filtered(k,k),'visible','off','tag','nevershow');
            end
        end
end




