function lassoselectdensity(src,ev)
handles=guidata(src);

ai=find(handles.allgraphs==src);

udata=get(handles.fakeax(ai),'userdata'); 
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:

%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

delete(handles.axeslisteners{ai});

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.xpoints=xclick;
handles.temp.ypoints=yclick;
%fill color:
handles.temp.selection=line(xclick, yclick,'linewidth',1,'color',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','clipping','on');

%uistack(handles.temp.selection,'bottom');
%maindata=findobj(src,'tag','main');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'tag','main');

handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);

handles.temp.lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};


%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@sizelassodensity);
set(handles.fig,'WindowButtonUpFcn',@sizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);
guidata(src,handles);

function sizelassodensity(src,eventdata) %#ok<INUSD>
%must be stored in its own file since it uses persistent variable
%persistent handles
%if isempty(handles)
    handles=guidata(src);
%end
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

mousenew = get(handles.allgraphs(ai),'CurrentPoint');
mousenew = mousenew(1,1:2);

% append the new point on the end of the last lasso

xpts=get(handles.temp.selection,'xdata');
ypts=get(handles.temp.selection,'ydata');

handles.temp.xpoints = [xpts(1:end-1),mousenew(1,1),xpts(1)]; %make a closed loop
handles.temp.ypoints = [ypts(1:end-1),mousenew(1,2),ypts(1)];

% replot the newly extended lasso
set(handles.temp.selection,'xdata',handles.temp.xpoints,'ydata',handles.temp.ypoints)

%determine which points are in this region:
try
    inpoints=raveinsidepoly(handles.temp.xdata,handles.temp.ydata,handles.temp.xpoints,handles.temp.ypoints);
catch %#ok<CTCH>
    inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,handles.temp.xpoints,handles.temp.ypoints);
end

inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.temp.lastselected;
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.temp.lastselected;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

guidata(handles.fig,handles);

raveupdateanalysis(src,[],'isselected',setdiff(1:numel(handles.allgraphs),ai),udata.view.dataset,udata.view.analysis);

function sizeselectiondone(src,eventdata) %#ok<INUSD>
clear sizelassoscatter
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(handles.allgraphs(ai),'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');

%store indices of selected points.
%inpoints=get(handles.temp.selected,'userdata');
%inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,get(handles.temp.selection,'xdata'),get(handles.temp.selection,'ydata'));

try
    inpoints=raveinsidepoly(handles.temp.xdata,handles.temp.ydata,get(handles.temp.selection,'xdata'),get(handles.temp.selection,'ydata'));
catch %#ok<CTCH>
    inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,get(handles.temp.selection,'xdata'),get(handles.temp.selection,'ydata'));
end

inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end


if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

delete(handles.temp.selection);

set(handles.fakeax(ai),'userdata',udata);

try %these dont work on 2007b,
    handles.axeslisteners{ai}(1)=addlistener(handles.allgraphs(ai),'XTick','PreSet',@axeschangelistener);
    handles.axeslisteners{ai}(2)=addlistener(handles.allgraphs(ai),'YTick','PreSet',@axeschangelistener);
    handles.axeslisteners{ai}(3)=addlistener(handles.allgraphs(ai),'ZTick','PreSet',@axeschangelistener);
catch
    handles.axeslisteners{ai}=[];
end

guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',[],udata.view.dataset,udata.view.analysis);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=handles.alldata{udata.view.dataset}(inpoints,:);
    guidata(src,handles);
    raveupdateanalysis(src,[],'xdials',[]);
end
