function ravemouseoverparallelcoordsdata(src,ev,ai)
%persistent handles 

%handles can be persistent here because the only handle it accesses is
%handles.mousetimer, which never changes. (Ok and
%handles.prefs.mouseoverdelay, but im ok with that only being settable
%between sessions.) If needed, could make a function to claer this function
%when handles.prefs.mouseoverdelay is changed. 

%if isempty(handles)
    handles=guidata(src);
%end

if handles.prefs.mouseoverdelay>0
    set(handles.mousetimer,'TimerFcn',{@processmouseover,src,ai})
    stop(handles.mousetimer);
    start(handles.mousetimer);
else %process immediately
    processmouseover(handles.fig,[],src,ai);    
end

function processmouseover(src,ev,fig,ai)

handles=guidata(fig);

udata=get(handles.fakeax(ai),'userdata');

obj=hittest(handles.fig);

try %sometimes this function fires late when mouse is not on a line object
ydat=get(obj,'ydata');
catch
    return
end

%for some reason this timer also sometimes fires when the user is dragging
%a filter dragger. abort in that case:
if length(ydat)==1;return;end


set(udata.explore.mouseoverhandles(1),'visible','on','ydata',ydat);


%determine which line this is:

idx=find(obj==udata.view.mainhandles);
if isempty(idx)
    idx=find(obj==udata.view.hiddenhandles); 
end

idx=udata.view.maxlineindex(idx);


%show mouseovertext:
 loc=get(handles.allgraphs(ai),'currentpoint');

 xclick=loc(1,1);
 yclick=loc(1,2);
% 

%calculate pixel offsets:
pos=get(handles.allgraphs(ai),'position');
xlim=get(handles.allgraphs(ai),'xlim');
ylim=get(handles.allgraphs(ai),'ylim');

xpix=(xlim(2)-xlim(1))./pos(3);
ypix=(ylim(2)-ylim(1))./pos(4);

xoff=6;
yoff=6;

d=udata.view.dataset;
a=udata.view.analysis;

%show text label:
set(udata.explore.mouseoverhandles(2),'position',[xclick yclick]+[xoff*xpix (yoff+1)*ypix])
set(udata.explore.mouseoverhandles(3),'position',[xclick yclick]+[xoff*xpix (yoff-1)*ypix])
set(udata.explore.mouseoverhandles(4),'position',[xclick yclick]+[(xoff-1)*xpix yoff*ypix])
set(udata.explore.mouseoverhandles(5),'position',[xclick yclick]+[(xoff+1)*xpix yoff*ypix])
set(udata.explore.mouseoverhandles(6),'position',[xclick yclick]+[xoff*xpix yoff*ypix])




if handles.rowlabelcolumn{d}==0
    set(udata.explore.mouseoverhandles(2:end),'visible','on','string',strtrim(sprintf('%8.0f',idx)));
else
    switch handles.datatype{d}{handles.rowlabelcolumn{d}}
        case 'string'
            val=handles.discretevalues{d}{a}{handles.rowlabelcolumn{d}}{handles.alldata{d}(idx,handles.rowlabelcolumn{d})};
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string',val);
        otherwise
            val=handles.alldata{d}(idx,handles.rowlabelcolumn{d});
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string',strtrim(sprintf('%8.6g',val)));
    end
end

if udata.view.c>0 && udata.format.colorbar
    %make mouseover pointers:
    
    legdata=get(handles.fakerax(ai),'userdata');
    aaa=findobj(legdata,'tag','Colorbar');
    pos=get(aaa,'position');
    ylim=get(aaa,'ylim');
    xlim=get(aaa,'xlim');
    
    clim=[min(handles.alldata{d}(:,udata.view.c)) max(handles.alldata{d}(:,udata.view.c))];
    
    %determine current c value:
    thisvalue=handles.alldata{d}(idx,udata.view.c);
    thiscoord=interp1(clim,ylim,thisvalue);
    pixels=pos(3)./(xlim(2)-xlim(1)); %pixels per unit
    
    set(udata.explore.cbarmouseovervalue,'ydata',[thiscoord-1 thiscoord+1  thiscoord],'visible','on');
    set(udata.explore.cbarmouseovertext,'position',[xlim(2)+3/pixels,thiscoord],'visible','on','string',sprintf('%5.5g',thisvalue));
end
