function pointselecthistogram(src,ev) 
handles=guidata(src);
ai=get(gca,'userdata');
udata=get(handles.fakeax(ai),'userdata');

clicked=get(gca,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.didntmove=true;

subax=get(src,'parent');
c=find(handles.subax{ai}==subax);

handles.temp.c=c;
handles.temp.selection=rectangle('position',[xclick yclick eps(xclick) eps(yclick)],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','facecolor','none','clipping','on','visible','off');

set(handles.temp.selection,'userdata',handles.isselected{udata.view.dataset}{udata.view.analysis});

handles.temp.wasselected=handles.isselected{udata.view.dataset}{udata.view.analysis};

%maintain manual/auto sizing:
handles.temp.axesmode=get(gca,'xlimmode');
set(gca,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',{@ravesizeselection,ai});
set(handles.fig,'WindowButtonUpFcn',{@ravesizeselectiondone,ai});
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizeselection(src,eventdata,ai)
handles=guidata(src);
handles.temp.didntmove=false;
udata=get(handles.fakeax(ai),'userdata');

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:
c=handles.temp.c;
d=udata.view.dataset;
a=udata.view.analysis;
x=handles.alldata{udata.view.dataset}(:,udata.view.x(c)); 

edges=udata.view.edges{c};
[count bins]=histc(x,edges);

%find corresponding data range:
lowbin=find(abs((edges-pos1))==min(abs(edges-pos1)),1); %index of next largest edge. 
highbin=find(abs((edges-(pos1+pos3)))==min(abs(edges-(pos1+pos3))),1);

inpoints= bins>=lowbin & bins<=highbin;
if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if min(edges)==max(edges) %if this variable is constant, select all data
    inpoints=~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

mods = get(handles.fig,'currentmodifier');
if numel(mods)>1;return;end %not defined for multiple modifiers

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    %inpoints = handles.isselected{udata.view.dataset}{udata.view.analysis} | inpoints;
    inpoints = handles.temp.wasselected | inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    %lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    
    lastselected=handles.temp.wasselected;
    lastselected(inpoints)=false;
    
    inpoints= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    %inpoints= handles.isselected{udata.view.dataset}{udata.view.analysis} & inpoints;
    inpoints=handles.temp.wasselected & inpoints;
end

inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end


handles.isselected{d}{a}=inpoints;


set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

for c=1:numel(handles.subax{ai})
    selected=findobj(handles.subax{ai}(c),'tag','selected');
    x=handles.alldata{udata.view.dataset}(:,udata.view.x(c));
    edges=udata.view.edges{c};
    selectedcount=histc(x(handles.isselected{udata.view.dataset}{udata.view.analysis}),edges);
    
    if udata.view.normalize %normalize counts (make pdfs)
        selectedcount=selectedcount./length(x);
    end
    
    selectedcount=selectedcount(:);
    
    seldata=[zeros(size(selectedcount,1),2),selectedcount,selectedcount,zeros(size(selectedcount,1),1)];
    seldata=seldata';
    sh=get(selected,'children');
    sv=get(sh,'vertices');
    sv(1:end-1,2)=seldata(:);
    set(sh,'vertices',sv);
    %set(selected,'ydata',selectedcount);
end

handles.lastd=udata.view.dataset;
handles.lasta=udata.view.analysis;

guidata(handles.fig,handles);

raveupdateanalysis(src,[],'isselected',ai,udata.view.dataset,udata.view.analysis)

set(handles.temp.selection,'userdata',inpoints)


function ravesizeselectiondone(src,eventdata,ai) 
handles=guidata(src);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
set(handles.infobar,'string','');

if handles.temp.didntmove
    processpointselecthistogram(findobj(gca,'tag','main'),[]);
    return
end

inpoints=get(handles.temp.selection,'userdata');
delete(handles.temp.selection);

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

%store indices of selected points.
handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',[],udata.view.dataset,udata.view.analysis);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=handles.alldata{udata.view.dataset}(inpoints,:);
    guidata(src,handles);
    raveupdateanalysis(src,[],'xdials',[]);
end

function processpointselecthistogram(src,ev)

handles=guidata(src);

%if ~strcmp(handles.selectionmode,'point');return;end;
set(handles.infobar,'string','shift+click to add to selection, alt+click to remove from selection, ctrl+click to select subset');

ai=get(gca,'userdata');
udata=get(handles.fakeax(ai),'userdata');

subax=get(src,'parent');
clicked=get(subax,'currentpoint');

xclick=clicked(1,1,1);
c=find(handles.subax{ai}==subax);
x=handles.alldata{udata.view.dataset}(:,udata.view.x(c));  %#ok<FNDSB>

edges=udata.view.edges{c};
[count bins]=histc(x,edges);

%find corresponding data range:
thisbin=find(abs((edges-xclick))==min(abs(edges-xclick)),1); %index of next largest edge. 

inpoints=bins==thisbin;
if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if min(edges)==max(edges) %if this variable is constant, select all data
    inpoints=~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

mods = get(handles.fig,'currentmodifier');

if numel(mods)>1;return;end %not defined for multiple modifiers

if isempty(mods)
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
elseif strcmp(mods,'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(mods,'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(mods,'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}=lastselected & inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

for c=1:numel(handles.subax{ai})
    selected=findobj(handles.subax{ai}(c),'tag','selected');
    x=handles.alldata{udata.view.dataset}(:,udata.view.x(c));
    
    edges=udata.view.edges{c};
    selectedcount=histc(x(handles.isselected{udata.view.dataset}{udata.view.analysis}),edges);
    
    if udata.view.normalize %normalize counts (make pdfs)
        selectedcount=selectedcount./length(x);
    end
    
    selectedcount=selectedcount(:);
    
    seldata=[zeros(size(selectedcount,1),2),selectedcount,selectedcount,zeros(size(selectedcount,1),1)];
    seldata=seldata';
    
    sh=get(selected,'children');
    sv=get(sh,'vertices');
    sv(1:end-1,2)=seldata(:);
    
    set(sh,'vertices',sv);
    
    %set(selected,'ydata',selectedcount);
    
    
    
end

handles.lastd=udata.view.dataset;
handles.lasta=udata.view.analysis;

guidata(handles.fig,handles);

raveupdateanalysis(src,ev,'isselected',ai,udata.view.dataset,udata.view.analysis)
