function handles=raveupdatehistogramisselected(src,ev,handles)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%handles=guidata(src);
getudata;
ai=handles.activeindex;

a=udata.view.analysis; 
d=udata.view.dataset; %data set index

allnothidden=handles.isvisible{d}{a};
allisselected=handles.isselected{d}{a};

if isempty(allnothidden);return;end % empty data set;

for c=1:numel(handles.subax{ai})
    selected=findobj(get(handles.subax{ai}(c),'children'),'tag','selected');
    x=handles.alldata{udata.view.dataset}(:,udata.view.x(c));
    
    keep=~isnan(x);
    x=x(keep);
    isselected=allisselected(keep);
    nothidden=allnothidden(keep);
    
    edges=udata.view.edges{c};
    selectedcount=histc(x(isselected & nothidden),edges);
    
    if udata.view.normalize %normalize counts (make pdfs)
        selectedcount=selectedcount./length(x);
    end
     
    seldata=[zeros(size(selectedcount,1),2),selectedcount,selectedcount,zeros(size(selectedcount,1),1)];
    seldata=seldata';
    sh=get(selected,'children');
    sv=get(sh,'vertices');
    sv(1:end-1,2)=seldata(:);
    set(sh,'vertices',sv);
end