function viewtabbarcategorical(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.
d=udata.view.dataset;

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
optionstext=text(.15-.10317,.35*1.0317-.0317,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title,'visible','off');

%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


%% variable lists

iscategorical=find(ismember(handles.datatype{d},'discrete') | ismember(handles.datatype{d},'string'));
isnumerical = find(~ismember(handles.datatype{d},'string'));

if udata.view.z<1
    stackvalue=udata.view.z+2;
else
    stackvalue=find(iscategorical==udata.view.z)+2;
end

if udata.view.y<1
    yvalue=1;
else
    yvalue=find(isnumerical==udata.view.y)+1;
end


analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',view.analysis);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',view.dataset);

if udata.view.x==0
    handles.tabobjects=[datasettext datasetmenu,...
        analysistext projecttext analysismenu dataseriestext optionstext];
    return
    
end

xaxistext=text(.25-.10317,.72*1.0317-.0317,'X-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,.65*1.0317-.0317,'Y-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
colortext=text(.25-.10317,.58*1.0317-.0317,'Divide Bars by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
sizetext=text(.25-.10317,.455,'Aggregate Values by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+405 180 30],...
    'style','popupmenu','string',handles.allnames{d}(iscategorical),'callback',@xaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',find(iscategorical==udata.view.x));
yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+360 180 30],...
    'style','popupmenu','string',[cellstr('<Count Occurrences>') handles.allnames{d}(isnumerical)],'callback',@yaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',yvalue);
stackmenu=uicontrol('position',[origin(1)+55 origin(2)+315 180 30],...
    'style','popupmenu','string',[cellstr('<None>'),cellstr('<Row Colors>'),handles.allnames{d}(iscategorical)],'callback',@stackmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','stackmenu','value',stackvalue);
aggregatemenu=uicontrol('position',[origin(1)+55 origin(2)+270-26 180 30],...
    'style','popupmenu','string',{'Sum Values','Average Value'},'callback',@aggregatemenu_callback,...
    'backgroundcolor',[1 1 1],'tag','aggregatemenu','value',udata.view.aggregateby);

stackcheck=uicontrol('position',[origin(1)+55 origin(2)+297 60 24],...
    'style','radiobutton','string','Stacked','callback',@stackcheck_callback,...
    'backgroundcolor',[1 1 1],'tag','stackcheck','value',udata.view.stack);

groupcheck=uicontrol('position',[origin(1)+145 origin(2)+297 70 24],...
    'style','radiobutton','string','Grouped','callback',@groupcheck_callback,...
    'backgroundcolor',[1 1 1],'tag','groupcheck','value',~udata.view.stack);

%% buttons

scalebutton=uicontrol('position',[origin(1)+55 origin(2)+165 180 30],...
    'style','pushbutton','string','Scale/Transform Variables','backgroundcolor',handles.colors.buttonbg,'visible','off');
changeunitsbutton=uicontrol('position',[origin(1)+55 origin(2)+130 180 30],...
    'style','pushbutton','string','Change Units','backgroundcolor',handles.colors.buttonbg,'visible','off');

%% group items and finish up
handles.tabobjects=[datasettext xaxistext yaxistext colortext datasetmenu xaxismenu yaxismenu stackmenu,...
    scalebutton analysistext projecttext analysismenu dataseriestext optionstext,...
    changeunitsbutton sizetext aggregatemenu stackcheck groupcheck];

handles.activetab='view';

guidata(src,handles);


%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=get(src,'value');
udata.view.dataset=d;

iscategorical=find(ismember(handles.datatype{d},'discrete') | ismember(handles.datatype{d},'string'),1);
isnumerical = find(~ismember(handles.datatype{d},'string'),2);
if isnumerical(1)==iscategorical;isnumerical=isnumerical(2);end;

if isempty(iscategorical) || isempty(isnumerical)
    udata.view.x=0; %x axis (categorical)
    udata.view.y=0; %y axis (numerical)
    udata.view.z=0; %stack by (categorical)
    udata.view.c=0; %unused
    udata.view.s=0; %unused
else
    udata.view.x=iscategorical; %x axis (categorical)
    udata.view.y=isnumerical(1); %y axis (numerical)
    udata.view.z=0; %stack by (categorical) 0 = none.
    udata.view.c=0; %unused
    udata.view.s=0; %unused
end


set(handles.fakeax(handles.activeindex),'userdata',udata);


handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);
ravecreatebarcategorical(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatebarcategorical(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
iscategorical=find(ismember(handles.datatype{d},'discrete') | ismember(handles.datatype{d},'string'));

udata.view.x=iscategorical(get(src,'value'));

set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatebarcategorical(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
isnumerical = find(~ismember(handles.datatype{d},'string'));

value=get(src,'value');
if value==1;
    udata.view.y=0;
else
    udata.view.y=isnumerical(get(src,'value')-1);
end

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatebarcategorical(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function stackmenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
iscategorical=find(ismember(handles.datatype{d},'discrete') | ismember(handles.datatype{d},'string'));

value=get(src,'value');
if value<=2
    udata.view.z=value-2;
else
    udata.view.z=iscategorical(value-2);
end

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatebarcategorical(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function aggregatemenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.aggregateby=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatebarcategorical(src,[]);


function stackcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

groupcheck=findobj(handles.tabobjects,'tag','groupcheck');
set(groupcheck,'value',0);
set(src,'value',1);
drawnow;

udata.view.stack=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatebarcategorical(src,[]);

function groupcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

stackcheck=findobj(handles.tabobjects,'tag','stackcheck');
set(stackcheck,'value',0);
set(src,'value',1);
drawnow;

udata.view.stack=~get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatebarcategorical(src,[]);


