function viewtaboverlayscatter(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.
d=udata.view.dataset;

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
optionstext=text(.15-.10317,.35*1.0317-.0317-.075,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title,'visible','off');

%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
dirtext=text(.25-.10317,.72*1.0317-.0317,'Image File:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
xaxistext=text(.25-.10317,.58*1.0317-.0317,'X-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,.51*1.0317-.0317,'Y-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
colortext=text(.25-.10317,.44*1.0317-.0317,'Color Points by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
sizetext=text(.25-.10317,.37*1.0317-.0317,'Size Points by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


%% variable lists

filename=fullfile(udata.view.path,udata.view.filename);
diredit=uicontrol('position',[origin(1)+55 origin(2)+415 150 22],...
    'style','edit','string',filename,'callback','',...
    'backgroundcolor',[1 1 1],'tag','diredit','max',1,'horizontalalignment','left');
browsebutton=uicontrol('position',[origin(1)+210 origin(2)+415 24 24],...
    'style','pushbutton','cdata',imread('browse.bmp'),'callback',@browsebutton_callback);

pickbutton=uicontrol('position',[origin(1)+55 origin(2)+415-35 180 30],...
    'style','togglebutton','string','Define Coordinate System','backgroundcolor',handles.colors.buttonbg,...
    'callback',@definecoordinates);

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',view.analysis);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',view.dataset);
xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+405-45-45 180 30],...
    'style','popupmenu','string',handles.allnames{d},'callback',@xaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu');
yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+360-45-45 180 30],...
    'style','popupmenu','string',handles.allnames{d},'callback',@yaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu');
colormenu=uicontrol('position',[origin(1)+55 origin(2)+315-45-45 180 30],...
    'style','popupmenu','string',[handles.allnames{d}(1:end),cellstr('<Use Row Colors>')],'callback',@colormenu_callback,...
    'backgroundcolor',[1 1 1],'tag','colormenu','value',length(handles.allnames{1}));
sizemenu=uicontrol('position',[origin(1)+55 origin(2)+270-45-45 180 30],...
    'style','popupmenu','string',[handles.allnames{d}(1:end),cellstr('')],'callback',@sizemenu_callback,...
    'backgroundcolor',[1 1 1],'tag','sizemenu','value',length(handles.allnames{1}));


%% buttons

scalebutton=uicontrol('position',[origin(1)+55 origin(2)+165-50 180 30],...
    'style','pushbutton','string','Scale/Transform Variables','backgroundcolor',handles.colors.buttonbg,'visible','off');
changeunitsbutton=uicontrol('position',[origin(1)+55 origin(2)+130-50 180 30],...
    'style','pushbutton','string','Change Units','backgroundcolor',handles.colors.buttonbg,'visible','off');
useresponsedata=uicontrol('position',[origin(1)+55 origin(2)+100-50 200 30],...
    'style','checkbox','string','Limit Y-axis to Response Variables',...
    'backgroundcolor',handles.colors.tabbg,'value',view.response,'callback',@useresponsedata_callback,'tag','useresponsedata','visible','off');
sortdatacheck=uicontrol('position',[origin(1)+55 origin(2)+78-50 200 30],...
    'style','checkbox','string','Sort Data by X-Axis Variable',...
    'backgroundcolor',handles.colors.tabbg,'value',0,'tag','sortdatacheck','visible','off');
excludecheck=uicontrol('position',[origin(1)+55 origin(2)+56-50 200 30],...
    'style','checkbox','string','Hide constant columns in menus',...
    'backgroundcolor',handles.colors.tabbg,'value',view.exclude,'callback',@excludecheck_callback,'tag','excludecheck','visible','off');


%% group items and finish up
handles.tabobjects=[datasettext xaxistext yaxistext colortext datasetmenu xaxismenu yaxismenu colormenu,...
    scalebutton analysistext projecttext analysismenu dataseriestext optionstext useresponsedata,...
    changeunitsbutton sortdatacheck excludecheck sizetext sizemenu dirtext diredit browsebutton pickbutton];

handles.activetab='view';

guidata(src,handles);
% update menus to hide excluded vars
viewtabmenufilter(src,[])


%% Exclude hidden variables from menus:

function viewtabmenufilter(src,eventdata) %#ok<INUSD>

handles=guidata(src);

%get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.

% datasetmenu=findobj(handles.tabobjects,'tag','datasetmenu');
xaxismenu=findobj(handles.tabobjects,'tag','xaxismenu');
yaxismenu=findobj(handles.tabobjects,'tag','yaxismenu');
colormenu=findobj(handles.tabobjects,'tag','colormenu');
sizemenu=findobj(handles.tabobjects,'tag','sizemenu');
% useresponsedata=findobj(handles.tabobjects,'tag','useresponsedata');
% excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

%get old strings/values
oldxvalue=view.x;
oldyvalue=view.y;
oldcvalue=view.c;
oldsvalue=view.s;


%d=get(datasetmenu,'value');
d=view.dataset;

%if get(useresponsedata,'value') && get(excludecheck,'value') && ~all(handles.isresponse{d}==0)
if view.response && view.exclude && ~all(handles.isresponse{d}==0)
    %filter menus by responses and hide constant cols
    
    %get new strings/values
    newxstring=handles.allnames{d}(~handles.isconstant{d} & ~handles.isresponse{d});
    
    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=find((~handles.isconstant{d} & ~handles.isresponse{d}));
    %handles.visibleycols=find((~handles.isconstant{d} & handles.isresponse{d}));
    handles.visibleccols=[find((~handles.isconstant{d} & handles.isresponse{d})) 0];
    
    
    %elseif get(useresponsedata,'value') && ~all(handles.isresponse{d}==0)
elseif view.response && ~all(handles.isresponse{d}==0)
    %filter responses only
    
    %get new strings/values
    newxstring=handles.allnames{d}(handles.isresponse{d});
    
    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=find((~handles.isresponse{d}));
    %handles.visibleycols=find((handles.isresponse{d}));
    handles.visibleccols=[find((handles.isresponse{d})) 0];
    
    
    
    %elseif get(excludecheck,'value') %hide constant cols only
elseif view.exclude %hide constant cols only
    
    %get new strings/values
    newxstring=handles.allnames{d}(~handles.isconstant{d});
    
    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=find((~handles.isconstant{d}));
    handles.visibleycols=find((~handles.isconstant{d}));
    handles.visibleccols=[find((~handles.isconstant{d})) 0];
    
    
    
else %show all variables
    
    %get new strings/values
    newxstring=handles.allnames{d};
    
    %store column numbers of available cols. pulldown menus index into these:
    handles.visiblexcols=1:1:length(handles.allnames{d});
    handles.visibleycols=1:1:length(handles.allnames{d});
    handles.visibleccols=[1:1:length(handles.allnames{d}) 0];
    
    
end

newxvalue=find(strcmp(handles.allnames{d}(oldxvalue),newxstring));
if isempty(newxvalue);newxvalue=1;end

newyvalue=find(ismember(newxstring,handles.allnames{d}(oldyvalue)));
if isempty(newyvalue);newyvalue=1;end

newcstring=[newxstring,cellstr('<Use Row Colors>')];
newsstring=[newxstring,cellstr('')];

if oldcvalue~=0 %something selected
    newcvalue=find(strcmp(handles.allnames{d}(oldcvalue),newcstring));
else %'none selected'
    newcvalue=numel(newcstring); %last entry in c string (='')
end

if isempty(newcvalue);newcvalue=1;end

if oldsvalue~=0 %something selected
    newsvalue=find(strcmp(handles.allnames{d}(oldsvalue),newcstring));
else %'none selected'
    newsvalue=numel(newcstring); %last entry in c string (='')
end

if isempty(newsvalue);newsvalue=1;end

%reset menu strings/values to match displayed data.
set(yaxismenu,'string',newxstring,'value',newyvalue);
set(xaxismenu,'string',newxstring,'value',newxvalue);
set(colormenu,'string',newcstring,'value',newcvalue);
set(sizemenu,'string',newsstring,'value',newsvalue);



guidata(src,handles)


%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=get(src,'value');

%get initial columns for this data set:
if ~all(handles.isresponse{d}==0)
    x=find((~handles.isconstant{d} & ~handles.isresponse{d}),1);
    y=find((~handles.isconstant{d} & handles.isresponse{d}),1);
    c=0;
    s=0;
else
    x=find((~handles.isconstant{d}),1);
    y=find((~handles.isconstant{d}),1);
    c=0;
    s=0;
end

udata.view.dataset=d;
udata.view.x=x;
udata.view.y=y;
udata.view.c=c;
udata.view.s=s;

set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);
viewtabmenufilter(src,[])
ravecreateoverlayscatter(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateoverlayscatter(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

useresponsedata=findobj(handles.tabobjects,'tag','useresponsedata');
excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

%if selected ~response, turn off filter response button
if ~handles.isresponse{udata.view.dataset}(handles.visiblexcols(get(src,'value')))
    set(useresponsedata,'enable','off')
else
    set(useresponsedata,'enable','on')
end

%if selected isconstant, turn off filter constant button
if handles.isconstant{udata.view.dataset}(handles.visiblexcols(get(src,'value')))
    set(excludecheck,'enable','off')
else
    set(excludecheck,'enable','on')
end

guidata(src,handles);

%set fakeax userdata

udata.view.x=handles.visiblexcols(get(src,'value'));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateoverlayscatter(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

useresponsedata=findobj(handles.tabobjects,'tag','useresponsedata');
excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

%if selected ~response, turn off filter response button
if ~handles.isresponse{udata.view.dataset}(handles.visibleycols(get(src,'value')))
    set(useresponsedata,'enable','off')
else
    set(useresponsedata,'enable','on')
end

%if selected isconstant, turn off filter constant button
if handles.isconstant{udata.view.dataset}(handles.visibleycols(get(src,'value')))
    set(excludecheck,'enable','off')
else
    set(excludecheck,'enable','on')
end

guidata(src,handles);

%set fakeax userdata

udata.view.y=handles.visiblexcols(get(src,'value'));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateoverlayscatter(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colormenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
legdata=get(handles.fakerax(handles.activeindex),'userdata');


colormenu=findobj(handles.tabobjects,'tag','colormenu');
excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

%if selected isconstant, turn off filter constant button
if get(src,'value')~=numel(get(src,'string'))
    if any(handles.isconstant{udata.view.dataset}(handles.visibleccols(get(src,'value'))))
        set(excludecheck,'enable','off')
    else
        set(excludecheck,'enable','on')
    end
end

guidata(src,handles);


%set fakeax userdata
%udata=get(handles.fakeax(handles.activeindex),'userdata');


udata.view.c=handles.visibleccols(get(colormenu,'value'));

set(handles.fakeax(handles.activeindex),'userdata',udata);

%update colorbar label:
if udata.format.colorbar
    if udata.view.c
        %do nothing
    else
        %check for existing colorbar:
        cbar=findobj('tag','Colorbar','userdata',handles.activeindex);
        if ~isempty(cbar)
            legdata=setdiff(legdata,cbar);
        end
        %turn if off:
        colorbar('off','peer',handles.activegraph);
        %udata.format.colorbar=0;
        set(handles.fakerax(handles.activeindex),'userdata',legdata);
        set(handles.fakeax(handles.activeindex),'userdata',udata);
    end
    
end


ravecreateoverlayscatter(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sizemenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

useresponsedata=findobj(handles.tabobjects,'tag','useresponsedata');
excludecheck=findobj(handles.tabobjects,'tag','excludecheck');

%if selected isconstant, turn off filter constant button
if get(src,'value')~=numel(get(src,'string'))
    if any(handles.isconstant{udata.view.dataset}(handles.visibleccols(get(src,'value'))))
        set(excludecheck,'enable','off')
    else
        set(excludecheck,'enable','on')
    end
end

guidata(src,handles);

%set fakeax userdata

udata.view.s=handles.visibleccols(get(src,'value'));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateoverlayscatter(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function useresponsedata_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%set fakeax userdata
udata.view.response=get(src,'value'); %response check box value
set(handles.fakeax(handles.activeindex),'userdata',udata);
viewtabmenufilter(src,[])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function excludecheck_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.exclude=get(src,'value'); %exclude constant check box value

set(handles.fakeax(handles.activeindex),'userdata',udata);

viewtabmenufilter(src,[])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function definecoordinates(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if get(src,'value') %position rectangle
    set(handles.infobar,'string','Drag the corners of the green rectangle to known positions in the graph...');
    set(udata.view.limits,'visible','on');
    set(udata.view.grabbers,'visible','on');
    
else %prompt to define rectangle coordinates
    screensize=get(handles.fig,'position');
    askbox=figure('units','pixels','position',[screensize(1)+screensize(3)/2-200 screensize(2)+screensize(4)/2-200 400 400],...
        'numbertitle','off','menubar','none','name','Select a Data Set','color',handles.colors.frame,...
        'resize','off','windowstyle','modal');
    
    axpos=get(handles.activegraph,'position');
    ar=axpos(3)/axpos(4);
    
    axpos=[90 120 240 190];
    xlim=get(handles.activegraph,'xlim');
    ylim=get(handles.activegraph,'ylim');
    
    xr=xlim(2)-xlim(1);
    yr=ylim(2)-ylim(1);
    
    if ar>1 %width constrained
        ylim=ylim+[-0.5 0.5].*(xr*190/240-yr);
    else
        xlim=xlim+[-0.5 0.5].*(yr*240/190-xr);
    end
    
    aaa=axes('parent',askbox,'units','pixels','position',axpos,'ydir','reverse','visible','on',...
        'xlim',xlim,'ylim',ylim);
    
    origimg=findobj(handles.activegraph,'type','image');
    im=copyobj(origimg,aaa);
    imgdata=get(im,'cdata');
    imgdata=imgdata+255*ones(size(imgdata),'uint8')./2;
    try %not sure if double/uint8 error could occur here...
        set(im,'cdata',imgdata);
    end
    
    newline=copyobj(udata.view.limits,aaa);
    set(newline,'linewidth',2);
    
    xdat=get(newline,'xdata');
    ydat=get(newline,'ydata');
    
    line([xlim(1) xdat(1)],[ylim(2) ydat(1)],'color',[0 0 0])
    line([xlim(1) xdat(2)],[ylim(1) ydat(2)],'color',[0 0 0])
    line([xlim(2) xdat(3)],[ylim(1) ydat(3)],'color',[0 0 0])
    line([xlim(2) xdat(4)],[ylim(2) ydat(4)],'color',[0 0 0])
    set(aaa,'visible','off')
    
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[30 350 340 40],...
        'string','Enter the coordinates of at least three of the vertices, using the image''s coordinate system.','hor','left')
    
    
    %bottom left:
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[10 94 19 22],...
        'string','x=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[10 70 19 22],...
        'string','y=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[30 94 60 22],'tag','SWX')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[30 70 60 22],'tag','SWY')
    
    %top left:
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[10 94+240 19 22],...
        'string','x=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[10 70+240 19 22],...
        'string','y=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[30 94+240 60 22],'tag','NWX')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[30 70+240 60 22],'tag','NWY')
    
    %top right:
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[310 294+40 19 22],...
        'string','x=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[310 270+40 19 22],...
        'string','y=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[330 294+40 60 22],'tag','NEX')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[330 270+40 60 22],'tag','NEY')
    
    %bottom right:
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[310 94 19 22],...
        'string','x=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','text','backgroundcolor',handles.colors.frame,'units','pixels',...
        'position',[310 70 19 22],...
        'string','y=','hor','left','fontsize',12,'fontname','arial','fontweight','bold')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[330 94 60 22],'tag','SEX')
    uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
        'position',[330 70 60 22],'tag','SEY')
    
    
    uicontrol('style','pushbutton','string','Ok','parent',askbox,'units','pixels',...
        'position',[170 10 100 30],'callback',{@coordspopup_callback,handles.fig},'fontsize',10);
    
    uicontrol('style','pushbutton','string','Cancel','parent',askbox,'units','pixels',...
        'position',[280 10 100 30],'callback',{@coordspopup_callback,handles.fig},'fontsize',10);
    
    
    uiwait(askbox)
    
    set(udata.view.limits,'visible','off');
    set(udata.view.grabbers,'visible','off');
    %
    %refresh udata:
    udata=get(handles.fakeax(handles.activeindex),'userdata');
    
    if isempty(udata.view.imagecoordinates) %user hit cancel;
        return
        
    elseif size(udata.view.imagecoordinates,1)==3 || size(udata.view.imagecoordinates,1)==4 %good transformation
        deezrows=~isnan(udata.view.imagecoordinates(:,1));
        
        inpts=[get(udata.view.limits,'xdata') get(udata.view.limits,'ydata')];
        inpts=inpts(deezrows,:);
        outpts=udata.view.imagecoordinates(deezrows,:);
        
        if sum(deezrows)==3
            udata.view.tform=maketform('affine',inpts,outpts);
        else
            udata.view.tform=maketform('projective',inpts,outpts);
        end
        
        set(handles.fakeax(handles.activeindex),'userdata',udata);
        
        
        ravecreateoverlayscatter(src,ev)
        
    else
        errordlg('You entered the coordinates incorrectly. Try again.')
        return
    end
    %apply transformation to data using: [X, Y] = tformfwd(T, U, V) or maybe
    %tforminv
end



function browsebutton_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

[filename path]=uigetfile({'*.bmp;*.jpg;*.png;*.tif','Image Files (*.bmp,*.jpg,*.png,*.tif)'},'Choose an image file');
if filename==0;return;end

udata.view.filename=fullfile(path,filename);
udata.view.invalid=0; %note: should really check to make sure it is a valid image file.

delete(udata.view.limits);
delete(udata.view.grabbers);
udata.view.limits=[];
udata.view.grabbers=[];

set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(src,handles)

ravecreateoverlayscatter(src,ev);


function coordspopup_callback(src,ev,fighandle)
handles=guidata(fighandle);
udata=get(handles.fakeax(handles.activeindex),'userdata');
fig=get(src,'parent');

if strcmp(get(src,'string'),'Cancel')
    close(fig)
    return
end

%get entered coordinates in order: SW,NW,NE,SE:
try
    SW=[str2double(get(findobj(fig,'tag','SWX'),'string')) str2double(get(findobj(fig,'tag','SWY'),'string'))];
    NW=[str2double(get(findobj(fig,'tag','NWX'),'string')) str2double(get(findobj(fig,'tag','NWY'),'string'))];
    NE=[str2double(get(findobj(fig,'tag','NEX'),'string')) str2double(get(findobj(fig,'tag','NEY'),'string'))];
    SE=[str2double(get(findobj(fig,'tag','SEX'),'string')) str2double(get(findobj(fig,'tag','SEY'),'string'))];
catch %#ok<CTCH>
    errordlg('You may only enter numerical values in the text boxes.')
    return
end

allcoords=[SW;NW;NE;SE];

if any(sum(isnan(allcoords),1)>1) %more than one vertex was unlabelled
    errordlg('You must enter coordinates for at least three of the vertices')
    return
end

if sum(logical(sum(isnan(allcoords),2)))>1 %an x coordinate was entered but no y coordiante or vice verse
    errordlg('You must enter both x and y coordinates for each vertex you label.')
    return
end

udata.view.imagecoordinates=allcoords;
set(handles.fakeax(handles.activeindex),'userdata',udata)

close(fig);






