function viewtabgoodness(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
a=udata.view.analysis;
d=udata.view.dataset;

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% clear existing tab
delete(handles.tabobjects)

%% text headers

projecttext=text(.15,.95,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

dataseriestext=text(.15,.75,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


% optionstext=text(.15,.35,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
%     'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


%% text labels

analysistext=text(.2-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');

datasettext=text(.2-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

xaxistext=text(.2-.10317,.72*1.0317-.0317,'Choose a Graph:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

yaxistext=text(.2-.10317,.65*1.0317-.0317,'"Actual" Variable:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

zaxistext=text(.2-.10317,.58*1.0317-.0317,'"Predicted" Variable:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


fitrowstext=text(.2-.10317,.48*1.0317-.0317,'Model Fit Rows:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

reprowstext=text(.2-.10317,.34*1.0317-.0317,'Model Representation Rows:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

fitrangecheck=uicontrol('style','radio','position',[origin(1)+40 origin(2)+264 100 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string','Range:','tag','fitrangecheck','fontname','arial','value',~udata.view.usefitcol,'callback',@fitradio_callback);
fitvarcheck=uicontrol('style','radio','position',[origin(1)+40 origin(2)+240 100 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string','Column:','tag','fitvarcheck','fontname','arial','value',udata.view.usefitcol,'callback',@fitradio_callback);
fitinvertcheck=uicontrol('style','checkbox','position',[origin(1)+60 origin(2)+216 100 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string','Invert Values','tag','fitinvertcheck','fontname','arial','value',udata.view.invertfitcol,'callback',@fitinvert_callback);

fitrange=uicontrol('style','edit','position',[origin(1)+114 origin(2)+264 136 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string',udata.view.fitrows,'tag','fitrange','fontname','arial','horizontalalignment','left');
fitmenu=uicontrol('position',[origin(1)+114 origin(2)+236 136 24],...
    'style','popupmenu','string',handles.allnames{d},...
    'backgroundcolor',[1 1 1],'tag','fitmenu','callback',@fitcolmenu_callback,'value',udata.view.fitcol);

unfitrangecheck=uicontrol('style','radio','position',[origin(1)+40 origin(2)+172 100 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string','Range:','tag','unfitrangecheck','fontname','arial','value',~udata.view.useunfitcol,'callback',@unfitradio_callback);
unfitvarcheck=uicontrol('style','radio','position',[origin(1)+40 origin(2)+148 100 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string','Column:','tag','unfitvarcheck','fontname','arial','value',udata.view.useunfitcol,'callback',@unfitradio_callback);
unfitinvertcheck=uicontrol('style','checkbox','position',[origin(1)+60 origin(2)+124 100 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string','Invert Values','tag','unfitinvertcheck','fontname','arial','value',udata.view.invertunfitcol,'callback',@unfitinvert_callback);

unfitrange=uicontrol('style','edit','position',[origin(1)+114 origin(2)+172 136 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string',udata.view.unfitrows,'tag','unfitrange','fontname','arial','horizontalalignment','left');
unfitmenu=uicontrol('position',[origin(1)+114 origin(2)+144 136 24],...
    'style','popupmenu','string',handles.allnames{d},...
    'backgroundcolor',[1 1 1],'tag','unfitmenu','callback',@unfitcolmenu_callback,'value',udata.view.unfitcol);


%% variable lists

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','callback',@analysismenu_callback,'value',a);

datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',d,'callback',@datasetmenu_callback);

graphmenu=uicontrol('position',[origin(1)+55 origin(2)+405 180 30],...
    'style','popupmenu','string',{'Actual v Predicted';'Residual v Predicted';'MFE Histogram';'MRE Histogram';'All Four Graphs'},...
    'backgroundcolor',[1 1 1],'tag','graphmenu','value',udata.view.graphs,'callback',@graphmenu_callback);

actualmenu=uicontrol('position',[origin(1)+55 origin(2)+360 180 30],...
    'style','popupmenu','string',handles.allnames{d},...
    'backgroundcolor',[1 1 1],'tag','actualmenu','value',udata.view.x,'callback',@actualmenu_callback);

predictedmenu=uicontrol('position',[origin(1)+55 origin(2)+315 180 30],...
    'style','popupmenu','string',handles.allnames{d},...
    'backgroundcolor',[1 1 1],'tag','predictedmenu','value',udata.view.y,'callback',@predictedmenu_callback);



roundcheck=uicontrol('style','checkbox','position',[origin(1)+25 origin(2)+90 230 20],'backgroundcolor',handles.colors.tabbg,...
    'fontsize',9,'string','Round Predicted to precision of Actual','tag','unfitinvertcheck','fontname','arial','value',udata.view.round,'callback',@roundcheck_callback);






%% group items and finish up
handles.tabobjects=[datasettext xaxistext yaxistext zaxistext datasetmenu graphmenu actualmenu predictedmenu,...
    analysistext projecttext analysismenu dataseriestext fitrowstext reprowstext fitrangecheck fitvarcheck fitinvertcheck,...
    fitrange fitmenu unfitrangecheck unfitvarcheck unfitinvertcheck,...
    unfitrange unfitmenu roundcheck];

handles.activetab='view';

guidata(src,handles);


%% callbacks



function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
%update other menus to show correct variables

analysismenu=findobj(handles.tabobjects,'tag','analysismenu');
datasetmenu=findobj(handles.tabobjects,'tag','datasetmenu');

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.analysis=get(analysismenu,'value');
udata.view.dataset=get(datasetmenu,'value');
udata.view.x=1;
udata.view.y=2;

set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);

ravecreategoodness(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(src,[]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function graphmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.graphs=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);


function actualmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.x=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);

function predictedmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.y=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreategoodness(handles.fig,[]);

function fitcolmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.fitcol=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreategoodness(handles.fig,[]);

function unfitcolmenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.unfitcol=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);





function fitradio_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

fitrangecheck=findobj(handles.tabobjects,'tag','fitrangecheck');
fitvarcheck=findobj(handles.tabobjects,'tag','fitvarcheck');

set([fitrangecheck fitvarcheck],'value',0)
set(src,'value',1);

udata.view.usefitcol=get(fitvarcheck,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);

function unfitradio_callback(src,ev)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

unfitrangecheck=findobj(handles.tabobjects,'tag','unfitrangecheck');
unfitvarcheck=findobj(handles.tabobjects,'tag','unfitvarcheck');

set([unfitrangecheck unfitvarcheck],'value',0)
set(src,'value',1);

udata.view.useunfitcol=get(unfitvarcheck,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreategoodness(handles.fig,[]);

function fitinvert_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.invertfitcol=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreategoodness(handles.fig,[]);

function unfitinvert_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.invertunfitcol=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreategoodness(handles.fig,[]);

function roundcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.round=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreategoodness(handles.fig,[]);








