function selecttableallpoints(src,ev)
%this function selects data in a tableallpoints when you click on it
%for this to work, unselected and selected data must both be visible, and selectionallowed must be true. 

handles=guidata(src);

thisax=get(src,'parent');
clicked=get(thisax,'currentpoint');

ai=find(handles.fakeax==thisax);

udata=get(handles.fakeax(ai),'userdata');
if ~udata.format.allowselection;return;end
if ~all(udata.view.showrows(1,2))
    set(handles.infobar,'string','Table can only be used to select data when unselected and selected rows are displayed.')
    return
end

originalselection=handles.isselected{udata.view.dataset}{udata.view.analysis};

clicked=clicked(1,2); %only need y coordinate

rowheight=udata.view.rowheight;

thisrow=ceil(clicked./rowheight);
allrows=udata.view.allrows;

if strcmp(get(handles.fig,'currentmodifier'),'shift')
        handles.isselected{udata.view.dataset}{udata.view.analysis}(allrows(thisrow))=true;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
        handles.isselected{udata.view.dataset}{udata.view.analysis}(allrows(thisrow))=false;
else
        handles.isselected{udata.view.dataset}{udata.view.analysis}=false(size(handles.alldata{udata.view.dataset},1),1);
        handles.isselected{udata.view.dataset}{udata.view.analysis}(allrows(thisrow))=true;
        originalselection=handles.isselected{udata.view.dataset}{udata.view.analysis};
end



guidata(handles.fig,handles);


raveupdateanalysis(handles.fig,[],'isselected',[],udata.view.dataset,udata.view.analysis)

set(handles.fig,'windowbuttonmotionfcn',{@tabledrag,ai,thisrow,originalselection})
set(handles.fig,'windowbuttonupfcn',{@tabledragdone,ai,thisrow})

function tabledrag(src,ev,ai,startrow,wasselected)
handles=guidata(src);

thisax=handles.fakeax(ai);
clicked=get(thisax,'currentpoint');
udata=get(handles.fakeax(ai),'userdata');

clicked=clicked(1,2); %only need y coordinate
rowheight=udata.view.rowheight;
endrow=ceil(clicked./rowheight);

if endrow<startrow
    a=endrow;
    endrow=startrow;
    startrow=a;
end

allrows=udata.view.allrows;


if startrow<1;startrow=1;end
if endrow>numel(allrows);endrow=numel(allrows);end




switch get(handles.fig,'selectiontype')
    case 'normal'
        wasselected(allrows(startrow:endrow))=true; 
    case 'extend'
        wasselected(allrows(startrow:endrow))=true;   
    case 'alt'
        wasselected(allrows(startrow:endrow))=false; 
end

handles.isselected{udata.view.dataset}{udata.view.analysis}=wasselected;      
guidata(handles.fig,handles);

raveupdateanalysis(handles.fig,[],'isselected',[],udata.view.dataset,udata.view.analysis)


function tabledragdone(src,ev,ai,startrow)
handles=guidata(src);
udata=get(handles.fakeax(ai),'userdata');
set(handles.fig,'windowbuttonmotionfcn',@ravedefaultwindowbuttonmotionfcn)
set(handles.fig,'windowbuttonupfcn','')

raveupdateanalysis(handles.fig,[],'isselected',[],udata.view.dataset,udata.view.analysis)

if handles.prefs.setxdialswhensingleselected && sum(handles.isselected{udata.view.dataset}{udata.view.analysis})==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=handles.alldata{udata.view.dataset}(handles.isselected{udata.view.dataset}{udata.view.analysis},:);
    guidata(src,handles);
    raveupdateanalysis(src,[],'xdials',[]);
end
