function horztablescroll(src,ev,newvalue) %#ok<INUSL>
%scroll a table horizontally to the new position in newvalue.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.


handles=guidata(src);

%determine which table this scrollbar belongs to:
ai=find(handles.allgraphs==src);


udata=get(handles.fakeax(ai),'userdata');

%on horizontal scroll, move main table and column headers.
maintable=handles.fakeax(ai);
texttab=handles.allgraphs(ai);


oldtablepos=get(maintable,'position');
p=handles.fakerax(ai);
pos=get(p,'position');

%hide old text:
tablepos=get(handles.allgraphs(ai),'position');
texthandles=udata.view.texthandles; 

firstvisiblerow=ceil((tablepos(4)+tablepos(2)-pos(4)+udata.view.headerheight)/udata.view.rowheight);
if firstvisiblerow<1;firstvisiblerow=1;end;
lastvisiblerow=ceil((tablepos(4)+tablepos(2)+udata.view.headerheight)/udata.view.rowheight);
if lastvisiblerow>size(texthandles,1);lastvisiblerow=size(texthandles,1);end;


firstvisiblecol=find(cumsum(udata.view.colwidths(udata.view.x))>=-tablepos(1)+udata.view.headerwidth,1);
if firstvisiblecol<1;firstvisiblecol=1;end;
lastvisiblecol=find([1 cumsum(udata.view.colwidths(udata.view.x))]+tablepos(1)>=pos(3)-udata.view.headerwidth,1);
if lastvisiblecol>numel(udata.view.colwidths(udata.view.x));lastvisiblecol=numel(udata.view.colwidths(udata.view.x));end;

set(texthandles(firstvisiblerow:lastvisiblerow,firstvisiblecol:lastvisiblecol),'visible','off');



set([maintable texttab],'position',[udata.view.headerwidth-newvalue oldtablepos(2:4)]);


colheader=udata.view.colheader;

if ~isempty(colheader)
    oldheaderpos=get(colheader,'position');
    set(colheader,'position',[udata.view.headerwidth-newvalue oldheaderpos(2:4)]);
end



%hide invisible rows:
tablepos=get(handles.allgraphs(ai),'position');
texthandles=udata.view.texthandles; 

firstvisiblerow=ceil((tablepos(4)+tablepos(2)-pos(4)+udata.view.headerheight)/udata.view.rowheight);
if firstvisiblerow<1;firstvisiblerow=1;end;
lastvisiblerow=ceil((tablepos(4)+tablepos(2)+udata.view.headerheight)/udata.view.rowheight);
if lastvisiblerow>size(texthandles,1);lastvisiblerow=size(texthandles,1);end;


firstvisiblecol=find(cumsum(udata.view.colwidths(udata.view.x))>=-tablepos(1)+udata.view.headerwidth,1);
if firstvisiblecol<1;firstvisiblecol=1;end;
lastvisiblecol=find([1 cumsum(udata.view.colwidths(udata.view.x))]+tablepos(1)>=pos(3)-udata.view.headerwidth,1);
if lastvisiblecol>numel(udata.view.colwidths(udata.view.x));lastvisiblecol=numel(udata.view.colwidths(udata.view.x));end;


%set(texthandles,'visible','off');
set(texthandles(firstvisiblerow:lastvisiblerow,firstvisiblecol:lastvisiblecol),'visible','on');


