function verttablescroll(src,ev,newvalue) %#ok<INUSL>
%scroll a table vertically to the new position in newvalue.
%newvalue is number of pixel that should appear at top of table (just below
%colheader)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.


handles=guidata(src);

ai=find(handles.allgraphs==src);

udata=get(handles.fakeax(ai),'userdata');

pos=get(handles.fakerax(ai),'position');

%on vertical scroll, move main table and row headers.
maintable=handles.fakeax(ai);
texttab=handles.allgraphs(ai);

oldtablepos=get(maintable,'position');

newpos=-newvalue;
if newpos<pos(4)-oldtablepos(4)-udata.view.headerheight
    newpos=pos(4)-oldtablepos(4)-udata.view.headerheight;
end



%hide old text:
tablepos=get(handles.allgraphs(ai),'position');
texthandles=udata.view.texthandles; 

firstvisiblerow=ceil((tablepos(4)+tablepos(2)-pos(4)+udata.view.headerheight)/udata.view.rowheight);
if firstvisiblerow<1;firstvisiblerow=1;end;
lastvisiblerow=ceil((tablepos(4)+tablepos(2)+udata.view.headerheight)/udata.view.rowheight);
if lastvisiblerow>size(texthandles,1);lastvisiblerow=size(texthandles,1);end;


firstvisiblecol=find(cumsum(udata.view.colwidths(udata.view.x))>=-tablepos(1)+udata.view.headerwidth,1);
if firstvisiblecol<1;firstvisiblecol=1;end;
lastvisiblecol=find([1 cumsum(udata.view.colwidths(udata.view.x))]+tablepos(1)>=pos(3)-udata.view.headerwidth,1);
if lastvisiblecol>numel(udata.view.colwidths(udata.view.x));lastvisiblecol=numel(udata.view.colwidths(udata.view.x));end;

set(texthandles(firstvisiblerow:lastvisiblerow,firstvisiblecol:lastvisiblecol),'visible','off');




set([maintable texttab],'position',[oldtablepos(1) newpos-1 oldtablepos(3:4)]);

%p=handles.fakerax(handles.activeindex);
%rowheader=findobj(p,'tag','rowheader');
rowheader=udata.view.rowheader;

if ~isempty(rowheader)
oldheaderpos=get(rowheader,'position');
set(rowheader,'position',[oldheaderpos(1) newpos-1 oldheaderpos(3:4)]);
end

%hide invisible rows:
tablepos=get(handles.allgraphs(ai),'position');
texthandles=udata.view.texthandles; 

firstvisiblerow=ceil((tablepos(4)+tablepos(2)-pos(4)+udata.view.headerheight)/udata.view.rowheight);
if firstvisiblerow<1;firstvisiblerow=1;end;
lastvisiblerow=ceil((tablepos(4)+tablepos(2)+udata.view.headerheight)/udata.view.rowheight);
if lastvisiblerow>size(texthandles,1);lastvisiblerow=size(texthandles,1);end;


firstvisiblecol=find(cumsum(udata.view.colwidths(udata.view.x))>=-tablepos(1)+udata.view.headerwidth,1);
if firstvisiblecol<1;firstvisiblecol=1;end;
lastvisiblecol=find([1 cumsum(udata.view.colwidths(udata.view.x))]+tablepos(1)>=pos(3)-udata.view.headerwidth,1);
if lastvisiblecol>numel(udata.view.colwidths(udata.view.x));lastvisiblecol=numel(udata.view.colwidths(udata.view.x));end;


%set(texthandles,'visible','off');
set(texthandles(firstvisiblerow:lastvisiblerow,firstvisiblecol:lastvisiblecol),'visible','on');

