//A renderer for use with RaveDataTypeTableModel that colors rows according to a row status integer.
// row status colors:
// 0 = white
// 1 = red
// 2 = yellow
// 3 = green
// 4 = blue
// 5 = gray

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.*;
import javax.swing.border.*;
import java.text.DecimalFormat;

public class RaveRowStatusRenderer extends DefaultTableCellRenderer {
    private RaveDataTypeTableModel rtm;
    private Color backgroundColor;
    //protected DecimalFormat formatter = new DecimalFormat("#.#####");
 
    public Component getTableCellRendererComponent(JTable table, Object value,
    boolean isSelected, boolean hasFocus, int row, int column) {
        
        super.getTableCellRendererComponent(table,value,isSelected,hasFocus,row,column);
        
        //setText(value.toString()); //an alternate way to format numbers
        //setText(formatter.format(value)); //another option...
        //setText(String.format("%.5g",value));
        setOpaque(true);
        // setBackground(defaultColor);
        //setForeground(textColor);

        this.rtm = (RaveDataTypeTableModel)table.getModel();
        //int modelrow= this.rtm.modelIndex(row);
        int[] rowStatus = this.rtm.getRowStatus();
        
        
        if(isSelected) {
            backgroundColor = new Color(0,0,128);
         } else if(rowStatus[row]==0) {
            backgroundColor = new Color(255,255,255);
         } else if(rowStatus[row]==1) {
            backgroundColor = new Color(255,195,195);
         } else if(rowStatus[row]==2) {
            backgroundColor = new Color(255,250,195);
         } else if(rowStatus[row]==3) {
            backgroundColor = new Color(195,255,195);
         } else if(rowStatus[row]==4) {
            backgroundColor = new Color(173,217,255);
         } else if(rowStatus[row]==5) {
            backgroundColor = new Color(210,210,210); 
        } else {            
            backgroundColor = new Color(255,255,255);
        }
        
        setBackground(backgroundColor);
        //setBorder(BorderFactory.createMatteBorder(0, 4, 0, 0, backgroundColor));
         
        return this;
    }

    public boolean isOpaque() {
        return true;
    }  

    public void validate() {}
    public void revalidate() {}
    public void repaint(long tm, int x, int y, int width, int height) {}
    public void repaint (Rectangle r) {}
    protected void firePropertyChange(String propertyName, Object oldValue, Object newValue) {} 
    public void firePropertyChange(String propertyName, boolean oldValue, boolean newValue) {} 
       
}