function ravemaintableredo(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

if isempty(handles.maintable.redos{1})
    return %nothing to redo
end

evt=handles.maintable.redos{1};

if evt.d ~= handles.maintable.d
    set(handles.infobar,'string',['Next "Redo" refers to dataset ' handles.datasetnames{evt.d} ' View it in table to redo.'])
    beep
    return
end

d=evt.d;

row=evt.row;
col=evt.col;

restorevalues=evt.newvalue;

%turn off tablechanged callback to avoid a loop:
set(handles.maintable.models{d},'TableChangedCallback',[]);

%update table
for c=1:numel(col)
    for r=1:numel(row)
        switch handles.datatype{d}{col(c)+1}
            case 'string'
                if ~isnan(restorevalues{r,c})
                    handles.maintable.jtable.setValueAt(handles.discretevalues{evt.d}{evt.a}{evt.col(c)+1}{restorevalues{r,c}},row(r),col(c))
                else
                    handles.maintable.jtable.setValueAt('invalid entry',row(r),col(c))
                end
            otherwise %numerical data
                handles.maintable.jtable.setValueAt(restorevalues{r,c},row(r),col(c));
        end
    end
end

%store event:
handles.maintable.undos(2:50)=handles.maintable.undos(1:49);
handles.maintable.undos{1}=evt;

handles.maintable.redos(1:49)=handles.maintable.redos(2:50);
handles.maintable.redos{50} = [];

%turn table callback back on:
set(handles.maintable.models{d},'TableChangedCallback',{@ravemaintablechangedcallback,handles.fig});

%check if legal redos remain:
if isempty(handles.maintable.redos{1})
    set(src,'enable','off')
end
set(findobj(handles.fig,'tag','undobutton'),'enable','on');

%update data set:
guidata(handles.fig,handles);