function varargout = manageanalysesgui(varargin)
% MANAGEANALYSESGUI M-file for manageanalysesgui.fig
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


% Last Modified by GUIDE v2.5 31-Mar-2009 16:56:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @manageanalysesgui_OpeningFcn, ...
    'gui_OutputFcn',  @manageanalysesgui_OutputFcn, ...
    'gui_LayoutFcn',  @managedatagui_LayoutFcn , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function h=managedatagui_LayoutFcn(varargin)
h=openfig('manageanalysesgui.fig');

% --- Executes just before manageanalysesgui is made visible.
function manageanalysesgui_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<INUSL,DEFNU>

handles.managefig=hObject;

set(hObject,'windowstyle','modal');


origin=get(0,'userdata');
thispos=get(hObject,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=origin(2)+origin(4)/2-thispos(4)/2;
set(hObject,'position',thispos);

%set theme:
load raveprefs

set(0,'userdata','cancel');

set(hObject,'color',raveprefs.colors.frame);
set(handles.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);
set(handles.uipanel2,'backgroundcolor',raveprefs.colors.tabbg);


set(handles.titleaxes,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);
set(handles.topframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);
set(handles.bottomframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);

%make titles
text(0,.4,'Manage Analyses','parent',handles.titleaxes,'fontname',raveprefs.fonts.title,'fontsize',20*raveprefs.fonts.titlescale,...
    'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Create / Rename / Delete','parent',handles.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.2,'Modify Existing Analyses','parent',handles.bottomframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

%get exising handles structure from maingui
handles.indata=guidata(gcbo); %gcbo = "manage data sets" button in maingui
set(handles.analysislist,'string',handles.indata.analysisnames,'max',100);
set(handles.datasetmenu,'string',handles.indata.datasetnames);

% Choose default command line output for manageanalysesgui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);




% --- Outputs from this function are returned to the command line.
function varargout = manageanalysesgui_OutputFcn(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% Get default command line output from handles structure
varargout{1} = handles.output;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function createbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>

%prompt for name:
%newname=inputdlg('Name this analysis:','New Analysis');
set(0,'userdata',[]);
origin=get(handles.indata.fig,'position');

askbox=figure('units','pixels','position',[origin(1)+origin(3)/2-350/2 origin(2)+origin(4)/2-150/2 350 150],...
    'numbertitle','off','menubar','none','name','Create New Analysis','color',handles.indata.colors.frame,...
    'resize','off','windowstyle','modal');


uicontrol('style','text','backgroundcolor',handles.indata.colors.frame,'units','pixels',...
    'position',[20 100 320 40],...
    'string','Select the analysis to use as a starting point for the new analysis:',...
    'horizontalalignment','left')
uicontrol('style','popupmenu','string',handles.indata.analysisnames,'backgroundcolor',[1 1 1],'units','pixels',...
    'position',[60-20 70+30 180 22],'tag','analysismenu')

uicontrol('style','text','backgroundcolor',handles.indata.colors.frame,'units','pixels',...
    'position',[20 50 320 40],...
    'string','Name the new analysis:','horizontalalignment','left')
uu=uicontrol('style','edit','string','','backgroundcolor',[1 1 1],'units','pixels',...
    'position',[60-20 50 180 22],'tag','analysisname','hor','left');

uicontrol('style','pushbutton','string','Ok','parent',askbox,'units','pixels',...
    'position',[110 10 100 30],'callback',@newanalysispopup_callback,'fontsize',10);
uicontrol('style','pushbutton','string','Cancel','parent',askbox,'units','pixels',...
    'position',[220 10 100 30],'callback',@newanalysispopup_callback,'fontsize',10);

uicontrol(uu);
uiwait(askbox)

outdata=get(0,'userdata');

if isempty(outdata);return;end;

newname=outdata.name;
index=outdata.value;

%add this name to the list:
oldnames=get(handles.analysislist,'string');
oldnames{end+1}=newname;
set(handles.analysislist,'string',oldnames);

%make new cells for this analysis:
handles.indata.analysisnames=oldnames;
for D=1:numel(handles.indata.datasetnames) %apparently can't use deal here.
   %handles.indata.targetvalues{D}{end+1}=handles.indata.targetvalues{D}{index};
    handles.indata.xdials{D}{end+1}=handles.indata.xdials{D}{index};
    handles.indata.minlimit{D}{end+1}=handles.indata.minlimit{D}{index};
    handles.indata.maxlimit{D}{end+1}=handles.indata.maxlimit{D}{index};
    handles.indata.discretevalues{D}{end+1}= handles.indata.discretevalues{D}{index};
    handles.indata.rowcolors{D}{end+1}=handles.indata.rowcolors{D}{index};
    handles.indata.ineqconstraints{D}{end+1}=handles.indata.ineqconstraints{D}{index};
    handles.indata.isselected{D}{end+1}=handles.indata.isselected{D}{index};
    handles.indata.isvisible{D}{end+1}=handles.indata.isvisible{D}{index};
    handles.indata.constrainthandles{D}{end+1}=handles.indata.constrainthandles{D}{index};
    handles.indata.constrainttext{D}{end+1}=handles.indata.constrainttext{D}{index};
    handles.indata.constrainttype{D}{end+1}=handles.indata.constrainttype{D}{index};
    handles.indata.constraintvalues{D}{end+1}=handles.indata.constraintvalues{D}{index};
    handles.indata.constraintadders{D}{end+1}=handles.indata.constraintadders{D}{index};
    handles.indata.constraintscalers{D}{end+1}=handles.indata.constraintscalers{D}{index};
    handles.indata.constraintvars{D}{end+1}=handles.indata.constraintvars{D};
    handles.indata.constraintcolors{D}{end+1}=handles.indata.constraintcolors{D};
    handles.indata.distname{D}{end+1}=handles.indata.distname{D}{index};
    handles.indata.distparams{D}{end+1}=handles.indata.distparams{D}{index};
    handles.indata.isfiltered{D}{end+1}=handles.indata.isfiltered{D}{index};
    handles.indata.minfilter{D}{end+1}=handles.indata.minfilter{D}{index};
    handles.indata.maxfilter{D}{end+1}=handles.indata.maxfilter{D}{index};
    handles.indata.discretefilter{D}{end+1}=handles.indata.discretefilter{D}{index};
    handles.indata.analysisupdatespending{D}{end+1}=cell(0);
end

%update da handles
guidata(hObject,handles);


% --- Executes on button press in changerangebutton.
function changerangebutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
set(0,'userdata',get(handles.indata.fig,'position'));

d=get(handles.datasetmenu,'value');
a=get(handles.analysislist,'value');


hhh=ravechangerangesgui(d,a,handles.indata);
uiwait(hhh);



newranges=get(0,'userdata');
if ~isstruct(newranges);return;end

handles.indata=newranges;

guidata(handles.indata.fig,handles.indata);
guidata(hObject,handles);

set(0,'userdata',[]);


%%--- Executes on button press in edittargetsbutton.
function edittargetsbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>

hhh=ravedefinetargetsgui(hObject,[]);
uiwait(hhh)

newranges=get(0,'userdata');
if isempty(newranges);return;end

d=get(handles.datasetmenu,'value');
a=get(handles.analysislist,'value');

fullranges=zeros(numel(handles.indata.allnames{d}),1);
fullranges(logical(handles.indata.isresponse{d}))=newranges;

handles.indata.targetvalues{d}{a}=fullranges;


guidata(handles.indata.fig,handles.indata);
guidata(hObject,handles);

set(0,'userdata',[]);



% --- Executes on button press in defineunitsbutton.
function defineunitsbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>

% --- Executes on button press in constrainbutton.
function constrainbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>


% --- Executes on button press in changexdialsbutton.
function changexdialsbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>


% --- Executes on button press in scalebutton.
function scalebutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to scalebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in changeunitsbutton.
function changeunitsbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to changeunitsbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% % --- Executes on button press in definetargetsbutton.
% function definetargetsbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% % hObject    handle to definetargetsbutton (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% %open definerolesgui
% hhh=ravedefinetargetsgui;
% uiwait(hhh)
% %collect results
% handles.indata.targetvalues{get(handles.listbox1,'value')}=get(0,'userdata');
% set(0,'userdata',[]);
%
% guidata(hObject,handles);


%%
%
%
%                       DONE BUTTONS
%
%
%
%%

% --- Executes on button press in donebutton.
function donebutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>

%set(0,'userdata',handles.indata)

%update main handles structure:
guidata(handles.indata.fig,handles.indata);

close(handles.managefig);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in stopbutton.
function stopbutton_Callback(hObject, eventdata, handles) %#ok<DEFNU>
keyboard;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in recolorbutton.
function recolorbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>



% --- Executes on selection change in analysislist.
%function analyseslist_Callback(hObject, eventdata, handles)
% hObject    handle to analysislist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns analysislist contents as cell array
%        contents{get(hObject,'Value')} returns selected item from analysislist


% --- Executes during object creation, after setting all properties.
function analysislist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to analysislist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in renamebutton.
function renamebutton_Callback(hObject, eventdata, handles)
% hObject    handle to renamebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in deletebutton.
function deletebutton_Callback(hObject, eventdata, handles)
% hObject    handle to deletebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --- Executes on button press in regressbutton.
function regressbutton_Callback(hObject, eventdata, handles)
% hObject    handle to regressbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --- Executes on selection change in analysislist.
function analysislist_Callback(hObject, eventdata, handles)
%doesnt have a callback



% --- Executes on selection change in datasetmenu.
function datasetmenu_Callback(hObject, eventdata, handles)
% hObject    handle to datasetmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns datasetmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from datasetmenu


% --- Executes during object creation, after setting all properties.
function datasetmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to datasetmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function newanalysispopup_callback(src,ev)
%callback for the donebuttons of the create new analysis popup window.
amenu=findobj(get(src,'parent'),'tag','analysismenu');
aname=findobj(get(src,'parent'),'tag','analysisname');


outdata.value=get(amenu,'value');
outdata.name=get(aname,'string');

set(0,'userdata',[]);
if strcmp(get(src,'string'),'Ok')
    if isempty(outdata.name)
        errordlg('You must enter a name for the new analysis','Name Required');
        return
    end
    set(0,'userdata',outdata);
end

close(get(gcbo,'parent'))



