function varargout = managedatagui(varargin)
% MANAGEDATAGUI M-file for managedatagui.fig
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

% Last Modified by GUIDE v2.5 27-Oct-2012 20:07:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @managedatagui_OpeningFcn, ...
    'gui_OutputFcn',  @managedatagui_OutputFcn, ...
    'gui_LayoutFcn',  @managedatagui_LayoutFcn , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function h=managedatagui_LayoutFcn(varargin)
h=openfig('managedatagui.fig');

% --- Executes just before managedatagui is made visible.
function managedatagui_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<INUSL>
handles.managefig=hObject;

origin=get(0,'userdata');
thispos=get(hObject,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=origin(2)+origin(4)/2-thispos(4)/2;
set(hObject,'position',thispos);



set(hObject,'closerequestfcn',@closegui)

%set theme:
load raveprefs
set(hObject,'color',raveprefs.colors.frame,'windowstyle','modal');
set(handles.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);
set(handles.uipanel2,'backgroundcolor',raveprefs.colors.tabbg);

set(handles.titleaxes,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);
set(handles.topframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);
set(handles.bottomframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);

%make titles
text(0,.4,'Manage Data Sets','parent',handles.titleaxes,'fontname',raveprefs.fonts.title,'fontsize',20*raveprefs.fonts.titlescale,...
    'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Create a New Data Set','parent',handles.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.2,'Manage Data Sets','parent',handles.bottomframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

%display button icons
A=imread('browse.bmp');
set(handles.browsebutton,'cdata',A)

%get exising handles structure from maingui
handles.indata=guidata(gcbo); %gcbo = "manage data sets" button in maingui
set(0,'userdata',handles.indata.fig);

%update listbox with current data sets
set(handles.linkbutton,'enable','off');

if isempty(handles.indata.datasetnames)
    set(handles.datasetmenu,'string','No Data Sets Loaded')
    set(handles.appendbutton,'enable','off')
    set(handles.replacebutton,'enable','off')
    set(handles.defineunitsbutton,'enable','off')
    set(handles.scalebutton,'enable','off')
    set(handles.changeunitsbutton,'enable','off')
    set(handles.definecolorsbutton,'enable','off')
    set(handles.decidebutton,'enable','off')
    set(handles.definetypebutton,'enable','off')
    set(handles.definetargetsbutton,'enable','off')
    set(handles.definebestcollist,'enable','off')
    set(handles.reevaluatebutton,'enable','off')
    set(handles.renamedatasetbutton,'enable','off')
    set(handles.renamevarsbutton,'enable','off')
    set(handles.rowlabelbutton,'enable','off')
    
else
    set(handles.datasetmenu,'string',handles.indata.datasetnames,'value',1)
    set(handles.definebestcollist,'string',[cellstr('<None Specified>') handles.indata.allnames{1}],...
        'value',handles.indata.rankingcolumn{1}+1);
    set(handles.defineunitsbutton,'enable','off')
    set(handles.scalebutton,'enable','off')
    set(handles.changeunitsbutton,'enable','off')
    %set(handles.reevaluatebutton,'enable','off')
    set(handles.appendbutton,'enable','off')
end

if numel(handles.indata.datasetnames)>=2
    set(handles.linkbutton,'enable','on')
end

%disable create button until they choose a file
set(handles.createbutton,'enable','off')

% Choose default command line output for managedatagui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes managedatagui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = managedatagui_OutputFcn(hObject, eventdata, handles) %#ok<INUSL>
% Get default command line output from handles structure
varargout{1} = handles.output;

%%
%
%
%                     MAKE A NEW DATA SET
%
%
%%

function sourcefiletext_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
%no callback, just shows a value.

% --- Executes during object creation, after setting all properties.
function sourcefiletext_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in browsebutton.
function browsebutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
[name,path]=uigetfile({'*.txt;*.csv;*.xls;*.xlsx','Data Files (*.txt, *.csv, *.xls, *.xlsx)';'*.*','All Files (*.*)'},'Choose data file to load:');

if name==0
    set(handles.sourcefiletext,'string','');
    uicontrol(handles.sourcefiletext)
else
    set(handles.sourcefiletext,'string',fullfile(path,name));
    set(handles.newnametext,'string',name(1:end-4));
    set(handles.createbutton,'enable','on');
    uicontrol(handles.createbutton);
end

guidata(hObject,handles);

function newnametext_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% --- Executes during object creation, after setting all properties.

txt=get(hObject,'string');
if ~isempty(txt)
    set(handles.createbutton,'enable','on');
end


function newnametext_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in createbutton.
function createbutton_Callback(hObject, eventdata, handles) %#ok<INUSL>

%update uicontrols in this gui to reflect valid data set
set(handles.donebutton,'enable','off','string','Busy...');
drawnow;

datasetnames=handles.indata.datasetnames;

%read in data:
infile=get(handles.sourcefiletext,'String');

if isempty(infile)
    infile='-pastespecial';
end

%check if this is a variable name:
if ~any(infile==filesep) %it is a variable name or database name
    datasource='variable';
else
    datasource='file';
end

%If not creating a data set from a file, do whatever preprocessing is
%needed to make the "in" structure:
switch datasource
    
    case 'file'
        in=[];
        
    case 'variable'
        
        in=[];
        try
            evalin('base',['save ravetempdata ',infile]);
            indata = load('ravetempdata.mat');
            delete('ravetempdata.mat');
        catch
            in=importdata(infile);
        end
        
        %determine how many varaibles were specified and which came first:
        vars=symvar(infile);
        
        if numel(vars)==1
            datafield=vars{1};
            namesfield='';
        elseif numel(vars)==2
            if numel(unique(vars))<2;
                errordlg('You must input a single workspace variable name or two different workspace variable names.')
            end
            
            if min(strfind(infile,vars{1}))<min(strfind(infile,vars{2}))
                datafield=vars{1};
                namesfield=vars{2};
            else
                datafield=vars{2};
                namesfield=vars{1};
            end
        else
            errordlg('You can only specify the names of two workspace variables: a 2-D array of data and a 1-D cell array of variable names.');
            return
        end
        
        if isempty(in)
            in.data=indata.(datafield);
            if ~isempty(namesfield)
                if ~iscellstr(indata.(namesfield));
                    errordlg('When inputing workspace variable names, the variable containing the data must be listed first, (optionally) followed by the variable containing the column names')
                end
                
                in.colheaders=indata.(namesfield);
                in.textdata=indata.(namesfield);
            else
                colnames=cell(1,size(in.data,2));
                for c=1:numel(colnames)
                    colnames{c}=['Column ',num2str(c)];
                end
                in.colheaders=colnames;
                in.textdata=colnames;
            end
        end
end

%Parse for rave data:
[varnames,data,textdata,discretevalues,istext,islogical]=raveparsedatafile(infile,in);

%make data set(s)
datasetname=get(handles.newnametext,'string');

guidata(hObject,handles);
createdataset(hObject,datasetname,datasource,varnames,data,textdata,discretevalues,istext,islogical);
handles=guidata(hObject);


%% process metadata:
[pathstr, name, ext] = fileparts(infile);  %#ok<NASGU>

%look in the folder that contained the data set:
if exist(fullfile(pathstr,[name '.rvm']),'file')==2
    ravemetadata=fullfile(pathstr,[name '.rvm']);
else
    ravemetadata=[];
end

if ~isempty(ravemetadata) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravemetadata);
    if ~success
        set(handles.donebutton,'enable','on','string','Done');
        drawnow;
        %return
    end
end

pause(0.1); %attempt to avoid error
guidata(hObject,handles);

%create tableModel:
[model,rhmodel]=ravecreatemaintablemodel(hObject,[],handles.D,1);
handles.indata.maintable.models{handles.D}=model;
handles.indata.maintable.rhmodels{handles.D}=rhmodel;
handles.indata.maintable.d=handles.D;
handles.indata.maintable.a=1;
handles.indata.maintable.x{handles.D}=1:size(handles.indata.alldata{handles.D},2);
drawnow;
guidata(hObject,handles);

%check how many columns it has:
if size(handles.indata.alldata{end},2)==1;
    warndlg('This data set only has one variable. Attempting to create most types of graphs will cause errors until you add more varaibles to this data set.')
end

%Update managedatagui:
set(handles.donebutton,'enable','on','string','Done');


datasetnames{end+1}=get(handles.newnametext,'string');
set(handles.datasetmenu,'string',datasetnames)

%clear creation data:
set(handles.newnametext,'string','')
set(handles.sourcefiletext,'string','')
set(handles.createbutton,'enable','off')
uicontrol(handles.donebutton)

%set(handles.appendbutton,'enable','on')
set(handles.replacebutton,'enable','on')
%set(handles.gpgpubutton,'enable','off')
set(handles.defineunitsbutton,'enable','on')
%set(handles.excludebutton,'enable','on')
%set(handles.deletebutton,'enable','on')
set(handles.scalebutton,'enable','on')
set(handles.changeunitsbutton,'enable','on')
set(handles.definecolorsbutton,'enable','on')
set(handles.definetypebutton,'enable','on')
set(handles.definetargetsbutton,'enable','on')
set(handles.decidebutton,'enable','on')
set(handles.reevaluatebutton,'enable','on')
set(handles.renamedatasetbutton,'enable','on')
set(handles.renamevarsbutton,'enable','on')
set(handles.rowlabelbutton,'enable','on')
set(handles.definebestcollist,'enable','on')

%disable buttons that dont work yet:
%set(handles.appendbutton,'enable','off')
%set(handles.replacebutton,'enable','off')
set(handles.defineunitsbutton,'enable','off')
set(handles.scalebutton,'enable','off')
set(handles.changeunitsbutton,'enable','off')

if numel(handles.indata.datasetnames)>=2
    set(handles.linkbutton,'enable','on')
end

try %can give an error if no sound card, or if using remote desktop.
   play(handles.indata.sounds.finish);
catch
    try
        wavplay(handles.indata.sounds.finish,44000);
    end
end

function createdataset(src,datasetname,datasettype,varnames,data,textdata,discretevalues,istext,islogical)
handles=guidata(src);


handles.D=numel(handles.indata.datasetnames)+1;

%% store results:
numvars=size(data,2);
numrows=size(data,1);
numa=numel(handles.indata.analysisnames);
mapname=handles.indata.prefs.defaultvariablecolors;
newcolorz=getvariablecolors(numvars,mapname);

%store backupdata:
backupdata=getappdata(handles.indata.fig,'backupdata');
backupdata{handles.D}=data;
setappdata(handles.indata.fig,'backupdata',backupdata);

%format/initialize data for output to main gui:
handles.indata.datasettype{handles.D}=datasettype;
handles.indata.datasetfiles{handles.D}=datasetname;
handles.indata.alldata{handles.D}=data;
handles.indata.alltext{handles.D}=textdata;
handles.indata.allnames{handles.D}=varnames;
handles.indata.datasetlinks{handles.D}=cell(1,numvars);
handles.indata.datasetlinkinfo{handles.D}=cell(1,numvars);
handles.indata.variablecolors{handles.D}=newcolorz;
handles.indata.isresponse{handles.D}=false(1,numvars);
handles.indata.allunits{handles.D}=cell(1,numvars);
handles.indata.isvalid{handles.D}=true(size(data));
handles.indata.isincluded{handles.D}=true(1,numvars);
handles.indata.isdecided{handles.D}=false(1,numvars);
handles.indata.isnoise{handles.D}=false(1,numvars);
handles.indata.datasetnames{handles.D}=datasetname;
handles.indata.isconstant{handles.D}=false(1,numvars);  %<--- superceded by datatype, but i'll keep it in cause it shows up in a lot of places.
handles.indata.isfunction{handles.D}=false(1,numvars);
handles.indata.funclass{handles.D}=cell(1,numvars);
[handles.indata.funclass{handles.D}{:}]=deal('independent');
handles.indata.funnames{handles.D}=cell(1,numvars); %names of regressions for function columns.
handles.indata.funvars{handles.D}=num2cell(1:numvars); %variables in regressions for function columns.
handles.indata.nargout{handles.D}=zeros(1,numvars); %index of which output of its function this response is.
handles.indata.datatype{handles.D}=cell(1,numvars);
[handles.indata.datatype{handles.D}{:}]=deal('continuous');%constant values are replaced below.
handles.indata.targetvalues{handles.D}=zeros(1,numvars);
handles.indata.preferences{handles.D}=zeros(1,numvars);
handles.indata.normalizepreferences{handles.D}=true;
handles.indata.isobjective{handles.D}=false(1,numvars);
handles.indata.rankingcolumn{handles.D}=0;
handles.indata.rowlabelcolumn{handles.D}=0;
handles.indata.datasetupdatespending{handles.D}=cell(0);
handles.indata.analysisupdatespending{handles.D}=cell(numa,1);
handles.indata.tablemodelupdatespending{handles.D}=cell(0);
handles.indata.maintable.colwidths{handles.D}=handles.indata.prefs.colwidth*ones(1,numvars);
handles.indata.ispointofinterest{handles.D}=false(numrows,1);

%analysis variables:
handles.indata.xdials{handles.D}=cell(numa,1);
handles.indata.minlimit{handles.D}=cell(numa,1);
handles.indata.maxlimit{handles.D}=cell(numa,1);
handles.indata.discretevalues{handles.D}=cell(numa,1);
handles.indata.rowcolors{handles.D}=cell(numa,1);
handles.indata.ineqconstraints{handles.D}=cell(numa,1);
handles.indata.isselected{handles.D}=cell(numa,1);
handles.indata.isvisible{handles.D}=cell(numa,1);
handles.indata.constrainthandles{handles.D}=cell(numa,1);
handles.indata.constrainttext{handles.D}=cell(numa,1);
handles.indata.constrainttype{handles.D}=cell(numa,1);
handles.indata.constraintvalues{handles.D}=cell(numa,1);
handles.indata.constraintadders{handles.D}=cell(numa,1);
handles.indata.constraintscalers{handles.D}=cell(numa,1);
handles.indata.constraintvars{handles.D}=cell(numa,1);
handles.indata.constraintcolors{handles.D}=cell(numa,1);
handles.indata.distname{handles.D}=cell(numa,1);
handles.indata.distparams{handles.D}=cell(numa,1);
handles.indata.isfiltered{handles.D}=cell(numa,1);
handles.indata.minfilter{handles.D}=cell(numa,1);
handles.indata.maxfilter{handles.D}=cell(numa,1);
handles.indata.discretefilter{handles.D}=cell(numa,1);

[handles.indata.xdials{handles.D}{:}]=deal(mean(data,1));
[handles.indata.minlimit{handles.D}{:}]=deal(min(data,[],1));
[handles.indata.maxlimit{handles.D}{:}]=deal(max(data,[],1));
[handles.indata.discretevalues{handles.D}{:}]=discretevalues; %this will contain all allowable values of non-continuous variables
[handles.indata.rowcolors{handles.D}{:}]=deal(ones(numrows,1)*handles.indata.prefs.defaultrowcolor);
[handles.indata.isselected{handles.D}{:}]=deal(false(numrows,1));
[handles.indata.isvisible{handles.D}{:}]=deal(true(numrows,1));
[handles.indata.constrainthandles{handles.D}{:}]=deal(cell(0)); %function handles must be stored in a cell
[handles.indata.constrainttext{handles.D}{:}]=deal(cell(0));
[handles.indata.constrainttype{handles.D}{:}]=deal(cell(0));
[handles.indata.constraintvalues{handles.D}{:}]=deal(cell(0));
[handles.indata.constraintadders{handles.D}{:}]=deal([]);
[handles.indata.constraintscalers{handles.D}{:}]=deal([]);
[handles.indata.constraintvars{handles.D}{:}]=deal(cell(0));
[handles.indata.constraintcolors{handles.D}{:}]=deal(cell(0));
[handles.indata.distname{handles.D}{:}]=deal(repmat({'uniform'},1,numvars));
[handles.indata.distparams{handles.D}{:}]=deal(mat2cell([min(data,[],1)' max(data,[],1)'],ones(numvars,1),2)');
[handles.indata.isfiltered{handles.D}{:}]=deal(false(numrows,1));
[handles.indata.minfilter{handles.D}{:}]=deal(min(data,[],1));
[handles.indata.maxfilter{handles.D}{:}]=deal(max(data,[],1));
discretefilter=discretevalues;
for q=1:numel(discretefilter)
    discretefilter{q}=true(numel(discretefilter{q}),1);
end
[handles.indata.discretefilter{handles.D}{:}]=discretefilter;

%check for isconstant:
for c=1:numvars
    handles.indata.funvars{handles.D}{c}=c; %independent varibles are their own funvar.
    if numel(unique(data(:,c)))==1
        handles.indata.isconstant{handles.D}(c)=true;
        handles.indata.datatype{handles.D}{c}='constant';
    elseif istext(c)
        handles.indata.datatype{handles.D}{c}='string';
        [handles.indata.xdials{handles.D}{:}(c)]=deal(1);
    elseif islogical(c)
        handles.indata.datatype{handles.D}{c}='logical';
        [handles.indata.xdials{handles.D}{:}(c)]=deal(0);
    end
end



guidata(src,handles);

% --- Executes on selection change in datasetmenu.
function datasetmenu_Callback(src, eventdata, handles) %#ok<DEFNU>
%does nothing, just returns a value;

if isempty(handles.indata.allnames);return;end %no data loaded

set(handles.definebestcollist,'string',[cellstr('<None Specified>') handles.indata.allnames{get(src,'value')}],'value',handles.indata.rankingcolumn{get(src,'value')}+1);




function datasetmenu_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in appendbutton.
function appendbutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% --- Executes on button press in replacebutton.


function replacebutton_Callback(hObject, eventdata, handles) %#ok<DEFNU>
%update uicontrols in this gui to reflect valid data set

set(handles.donebutton,'enable','off','string','Busy...');
drawnow;

datasetnames=handles.indata.datasetnames;
datasetnames{end+1}=get(handles.newnametext,'string');

handles.D=get(handles.datasetmenu,'value');

[name,path]=uigetfile({'*.txt;*.csv;*.xls;*.xlsx','Data Files (*.txt, *.csv, *.xls, *.xlsx)';'*.*','All Files (*.*)'},'Choose data file to replace the current data set:');

if name==0
    set(handles.donebutton,'enable','on','string','Done');
    drawnow;
    return
else
    infile=fullfile(path,name);
end


[varnames,data,textdata,discretevalues,istext,islogical]=raveparsedatafile(infile);


%% check that new data set is compatible with existing data set
numvars=size(data,2);
numrows=size(data,1);

%check that there are the same number of independent variables:
if sum(~handles.indata.isfunction{handles.D})~=numvars
    errordlg('Cannot replace the selected data set with this file because the number of columns in the new file does not match the number of independent variables in the selected data set.','Cannot replace data set');
    set(handles.donebutton,'enable','on','string','Done');
    drawnow;
    return
end

%% evaluate functions:
newdata=zeros(numrows,numel(handles.indata.allnames{handles.D}));
newdata(:,~handles.indata.isfunction{handles.D})=data;
index=find(handles.indata.isfunction{handles.D});
if ~isempty(index);
    outs=raveevaluatefunction(handles.indata.fig,handles.D,index,newdata);
    newdata(:,index)=outs;
end;
data=newdata;

%% store results:
numa=numel(handles.indata.analysisnames);
mapname=handles.indata.prefs.defaultvariablecolors;
newcolorz=getvariablecolors(numvars,mapname);

if numrows~=size(handles.indata.alldata{handles.D})
    [handles.indata.rowcolors{handles.D}{:}]=deal(ones(numrows,1)*handles.indata.prefs.defaultrowcolor);
    [handles.indata.isselected{handles.D}{:}]=deal(false(numrows,1));
    [handles.indata.isvisible{handles.D}{:}]=deal(true(numrows,1));
    [handles.indata.isfiltered{handles.D}{:}]=deal(false(numrows,1));
end

%store backupdata:
backupdata=getappdata(handles.indata.fig,'backupdata');
backupdata{handles.D}=data;
setappdata(handles.indata.fig,'backupdata',backupdata);

%format/initialize data for output to main gui:
handles.indata.datasetfiles{handles.D}=infile;
handles.indata.alldata{handles.D}=data;
handles.indata.alltext{handles.D}=textdata;
handles.indata.isvalid{handles.D}=true(size(data));

[handles.indata.minlimit{handles.D}{:}]=deal(min(data));
[handles.indata.maxlimit{handles.D}{:}]=deal(max(data));
[handles.indata.discretevalues{handles.D}{:}]=discretevalues; %this will contain all allowable values of non-continuous variables
[handles.indata.minfilter{handles.D}{:}]=deal(min(data));
[handles.indata.maxfilter{handles.D}{:}]=deal(max(data));
[handles.indata.isfiltered{handles.D}{:}]=deal(false(numrows,1));
[handles.indata.discretefilter{handles.D}{:}]=discretevalues;

%% process metadata:
[pathstr, name, ext] = fileparts(infile);  %#ok<NASGU>
ravemetadata=which(fullfile(pathstr,[name '.rvm']));

if ~isempty(ravemetadata) && get(handles.metadatacheck,'value')
    [handles.indata,success]=raveloadmetadata(handles.indata,handles.D,ravemetadata);
    if ~success
        set(handles.donebutton,'enable','on','string','Done');
        drawnow;
        return
    end
end


pause(0.1); %attempt to avoid java error
guidata(hObject,handles);

%create tableModel:
[model,rhmodel]=ravecreatemaintablemodel(hObject,[],handles.D,1);
handles.indata.maintable.models{handles.D}=model;
handles.indata.maintable.rhmodels{handles.D}=rhmodel;
handles.indata.maintable.d=handles.D;
handles.indata.maintable.a=1;
handles.indata.maintable.x{handles.D}=1:numvars;

guidata(hObject,handles);

guidata(handles.indata.fig,handles.indata);
raveupdatedataset(handles.indata.fig,[],'replaceall',[],handles.D);

set(handles.donebutton,'enable','on','string','Done');
drawnow;



function gpgpubutton_Callback(hObject, eventdata, handles)

% --- Executes on button press in excludebutton.
function excludebutton_Callback(hObject, eventdata, handles)
hhh=raveexcludecolumnsgui;
uiwait(hhh)
%collect results
handles.indata.isincluded{get(handles.datasetmenu,'value')}=get(0,'userdata');
set(0,'userdata',[]);

guidata(hObject,handles);


function defineunitsbutton_Callback(hObject, eventdata, handles)



function deletebutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
%
% idx=get(hObject,'value');
% answer=questdlg('Are you sure you want to delete this data set? Any graphs that are currently displaying this data set will also be deleted. Warning: This action cannot be undone.','Delete data set');

function scalebutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>

function changeunitsbutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>

% --- Executes on button press in definecolorsbutton.
function definecolorsbutton_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>

%open define colors gui:
hhh=ravedefinevariablecolors(hObject,[]);
uiwait(hhh)

%collect results
newcolorz=get(0,'userdata');
if ~isempty(newcolorz)
    handles.indata.variablecolors=newcolorz;
end
set(0,'userdata',[]);

guidata(hObject,handles);


%%
%
%
%                       DONE BUTTONS
%
%
%
%%

% --- Executes on button press in donebutton.
function donebutton_Callback(hObject, eventdata, handles) %#ok<INUSL>

unprocessed=get(handles.sourcefiletext,'String');


if ~isempty(unprocessed) %check if they forgot to hit "create data set"
    answer=questdlg('You selected a file but did not create a data set from it. Create this data set now?',...
        'Create data set');
    if strcmp(answer,'Yes')
        createbutton_Callback(hObject,[], handles)
    end
    handles=guidata(hObject);
end

close(handles.managefig);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in stopbutton.
function stopbutton_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
keyboard;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in reevaluatebutton.
function reevaluatebutton_Callback(hObject, eventdata, handles)
% hObject    handle to reevaluatebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

answer=questdlg('Re-evaluate all functions for the selected data set now? (Use this if you have made changes to a function after it was loaded/created on the Model tab.)','Re-evaluate functions');

if ~strcmpi(answer,'yes');return;end
set(handles.donebutton,'enable','off','string','Busy...');
drawnow;
d=get(handles.datasetmenu,'value');
funs=find(handles.indata.isfunction{d});
newouts=raveevaluatefunction(handles.indata.fig,d,funs,handles.indata.alldata{d});
handles.indata.alldata{d}(:,funs)=newouts;
guidata(hObject,handles);
guidata(handles.indata.fig,handles.indata);
raveupdatedataset(handles.indata.fig,[],'replaceall',[],d)


set(handles.donebutton,'enable','on','string','Done');

function definetypebutton_Callback(hObject, eventdata, handles)

%open definerolesgui
handles=guidata(hObject);
d=get(handles.datasetmenu,'value');

set(0,'userdata',get(handles.indata.fig,'position'));

hhh=ravedefinetypesgui;
uiwait(hhh)
%collect results

newdata=get(0,'userdata');
if ~isstruct(newdata);return;end

handles.indata.isresponse{d}=newdata.isresponse{d};
handles.indata.datatype{d}=newdata.datatype{d};
handles.indata.discretevalues{d}=newdata.discretevalues{d};
handles.indata.isconstant{d}=newdata.isconstant{d};
handles.indata.minlimit{d}=newdata.minlimit{d};
handles.indata.maxlimit{d}=newdata.maxlimit{d};
handles.indata.xdials{d}=newdata.xdials{d};
handles.indata.discretefilter{d}=newdata.discretefilter{d};
%handles.indata.isresponse{d}=0;
set(0,'userdata',[]);

guidata(hObject,handles);


% --- Executes on button press in definetargetsbutton.
function definetargetsbutton_Callback(hObject, eventdata, handles)
% hObject    handle to definetargetsbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
src=hObject;

d=get(handles.datasetmenu,'value');

hhh=ravedefinetargetsgui(src,[]);
uiwait(hhh)

newranges=get(0,'userdata');
if isempty(newranges);return;end
fullranges=newranges;
handles.indata.targetvalues{d}=fullranges;
guidata(hObject,handles);
set(0,'userdata',[]);


% --- Executes on button press in definebestcollist.
function definebestcollist_Callback(hObject, eventdata, handles)
% hObject    handle to definebestcollist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

d=get(handles.datasetmenu,'value');
handles.indata.rankingcolumn{d}=get(hObject,'value')-1;
guidata(hObject,handles);

% --- Executes on button press in metadatacheck.
function metadatacheck_Callback(hObject, eventdata, handles)
% hObject    handle to metadatacheck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of metadatacheck
% --- Executes on button press in decidebutton.
function decidebutton_Callback(hObject, eventdata, handles)
% hObject    handle to decidebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

msgbox('This feature is not yet implemented in this GUI, however, you can decide variables by right clicking their column header in the data table and checking "Decided."','Coming Soon','help')


function closegui(src,ev)
%send updated handles back to main rave window
handles=guidata(src);
set(0,'userdata',handles.indata);
delete(src)

% --- Executes on button press in renamedatasetbutton.
function renamedatasetbutton_Callback(hObject, eventdata, handles)
% hObject    handle to renamedatasetbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

d=get(handles.datasetmenu,'value');

answer = inputdlg('Enter a new name for this data set:                         ','Rename data set',1,handles.indata.datasetnames(d));

if isempty(answer);return;end

handles.indata.datasetnames{d}=answer{1};
guidata(hObject,handles);

set(handles.datasetmenu,'string',handles.indata.datasetnames);



% --- Executes on button press in renamevarsbutton.
function renamevarsbutton_Callback(hObject, eventdata, handles)
% hObject    handle to renamevarsbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


msgbox('This feature is not yet implemented in this GUI, however, you can rename variables by right clicking their column header in the data table and selecting "Rename".','Coming Soon','help')



% --- Executes on button press in rowlabelbutton.
function rowlabelbutton_Callback(hObject, eventdata, handles)
% hObject    handle to rowlabelbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles=guidata(hObject);
d=get(handles.datasetmenu,'value');
set(0,'userdata',get(handles.indata.fig,'position'));
hhh=ravedefinerowlabelgui(hObject,[],d);
uiwait(hhh)

%collect results
val=get(0,'userdata');
if numel(val)~=1;return;end
handles.indata.rowlabelcolumn{d}=val-1;
guidata(hObject,handles);


% --- Executes on button press in showoptionscheck.
function showoptionscheck_Callback(hObject, eventdata, handles)
% hObject    handle to showoptionscheck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of showoptionscheck



% --- Executes on button press in linkbutton.
function linkbutton_Callback(hObject, eventdata, handles)
% hObject    handle to linkbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%open definerolesgui
handles=guidata(hObject);
d=get(handles.datasetmenu,'value');

set(0,'userdata',get(handles.indata.fig,'position'));

hhh=ravedefinedatasetlinksgui;
uiwait(hhh)
%collect results

newdata=get(0,'userdata');
if ~isstruct(newdata);return;end

handles.indata.datasetlinks{d}=newdata.datasetlinks{d};
handles.indata.datasetlinkinfo{d}=newdata.datasetlinkinfo{d};

set(0,'userdata',[]);

guidata(hObject,handles);

