function settings=ravemakemodeltriscatteredinterp(src,ev,settings)
%must do three things:
%1) Fit the model.
%2) Assess the model against all rows and calculate predicted values. Store
%   these in settings.predictedvalues.
%3) Make a cell array of strings to be printed in a text file to make a
%   valid matlab function to calculate this model. (this is the hard part).

handles=guidata(src);

xcol=settings.inputs;
d=settings.dataset;

xfitdata=handles.alldata{d}(settings.fitrows,xcol);
yfitdata=handles.alldata{d}(settings.fitrows,settings.output);

%make interpolant:
T=TriScatteredInterp(xfitdata,yfitdata,settings.interp);

%predict data:
alldata=handles.alldata{d}(:,xcol);

y=T(alldata);
settings.predictedvalues=y;%.*yrange+ymin;

%make model string:
varnames=handles.allnames{d}(xcol);
varnames=ravemakevariablenames(varnames);

line1='xdata = [';
for v=1:numel(varnames);
    line1=[line1,varnames{v},' ']; %#ok<AGROW>
end

str={};
str{end+1} = 'persistent T';
str{end+1} = [line1(1:end-1),'];'];
str{end+1} = 'if isempty(T)';
str{end+1} = ['    xdat = ',mat2str(xfitdata),';'];
str{end+1} = ['    ydata = ',mat2str(yfitdata),';'];
str{end+1} = ['    T=TriScatteredInterp(xdat,ydata,''',settings.interp,''');'];
str{end+1} = 'end';
str{end+1} = 'y=T(xdata);';

settings.modelstring=str';










