function [F,rank]=fast_non_dominated_sort(objective,cviolation)
%determine the domination rank of each row in objective. 
%objective is formatted so that max is best. 
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
N=size(objective,1);
F=cell(1);

%DO PARETO FILTERING:
% i=1; %frontier counter
% isnondominated=false(size(objective,1),1);
% bigindex=1:N;
% rank=zeros(N,1);


isfeasible=~cviolation;
objective=double(objective);

objective=-objective;


if any(isfeasible)

    feasibleobj=objective(isfeasible,:);
    
    rank=raveparetofront(feasibleobj,true);
    
    Rank=zeros(N,1);
    Rank(isfeasible)=rank;
    Rank(Rank==0)=max(Rank)+1;
    rank=Rank;
   
    ranks=unique(rank);
    
    for ff=1:numel(ranks)
        r=ranks(ff);
        F{ff}=find(rank==r)';
    end

%     isfeasible=~cviolation;
%     maxrank=max(rank);
%     rank(~isfeasible)=maxrank+1; %bump infeasible points to the worst frontier.


else %all are infeasible

    rank=ones(N,1);
    F{1}=1:N;

end