function [displaynames,settingvalues]=raveparseoptimizersettingsfile(dest,headerindex)
%read in the settings from a saved optimizer settings file. The settings
%under the headerindex-th header will be read in. 

fid=fopen(dest,'r');
tline=fgetl(fid);
linez={};

while ischar(tline)
    linez{end+1}=tline;
    tline=fgetl(fid);
end

%look for header lines:
headers=[];

for t=1:numel(linez)
   if length(linez{t})>=2 && strcmp(linez{t}(1:2),'%#')
       headers(end+1)=t;
   end
end

if isempty(headers)
    errordlg('No settings headers were found in this file. Headers must come at the beginning of a block of settings and must begin with ''%#'' followed by the optimizer''s keyword.','Invalid format');
    return
end

if numel(headers)>1
    warndlg('Optimization settings files with multiple headers are not yet supported. I will load the first header''s settings.')
end

headers=headers(headeridx);
%get header keyword:
spaces=strfind(linez{headers},' ');
spaces=spaces(1);
keyword=linez{headers}(3:spaces-1);

if ~strcmp(keyword,thismethod)
    errordlg('The settings in the file you selected do not match the algorithm selected in the menu on the Optimize tab.')
    return
end

%parse settings:
displaynames={};
settingvalues={};

for t=headers+1:numel(linez)
    div=find(linez{t}=='=',1,'first');
    if isempty(div);continue;end
    displaynames{end+1}=strtrim(linez{t}(1:div-1));
    settingvalues{end+1}=strtrim(linez{t}(div+1:end));
end