function raveappendrows(src,ev,d,newdata,rowcolor,isselected,isvisible,ispointofinterest)
%appends rows in "newdata" to dataset d, with properties
%rowcolor,isselected, isvisible
%and ispoint ofinterest. These can either be vectors or a logical scalar
%that applies to all rows. The matrix newdata should already have been
%evaulated by raveevaluatefunction (if necessary).

handles=guidata(src);
nrows=size(newdata,1);
if nrows==0;return;end

if isscalar(rowcolor);rowcolor=rowcolor*ones(nrows,1);end
if isscalar(isselected);isselected=logical(isselected*ones(nrows,1));end
if isscalar(isvisible);isvisible=logical(isvisible*ones(nrows,1));end
if isscalar(ispointofinterest);ispointofinterest=logical(ispointofinterest*ones(nrows,1));end

handles.alldata{d}=[handles.alldata{d};newdata];
handles.alltext{d}=[handles.alltext{d};cell(size(newdata))];
handles.isvalid{d}=[handles.isvalid{d};true(size(newdata))];

handles.ispointofinterest{d}=[handles.ispointofinterest{d};ispointofinterest];

for a=1:numel(handles.analysisnames)
    handles.rowcolors{d}{a}=[handles.rowcolors{d}{a};rowcolor];
    handles.isvisible{d}{a}=[handles.isvisible{d}{a};isvisible];
    handles.isfiltered{d}{a}=[handles.isfiltered{d}{a};false(nrows,1)];
    handles.isselected{d}{a}=[handles.isselected{d}{a};isselected];
end


guidata(handles.fig,handles);
raveupdatedataset(handles.fig,[],'addrows',[],d);

