function raveboxzoom2d(src,ev)
%draw a box on the current graph, then zoom to that box.

handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

clicked=get(gca,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps(xclick) eps(yclick)],'linewidth',1,'edgecolor',[210 196 212]./255,...
    'parent',src,'hittest','off','buttondownfcn','','facecolor','none','clipping','on','userdata',false);


set(handles.temp.selection,'userdata',false(size(handles.isselected{udata.view.dataset}{udata.view.analysis})));

%maintain manual/auto sizing:
handles.temp.axesmode=get(gca,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

setptr(handles.fig,'glassplus');


finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4],'userdata',true);
end


function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
setptr(handles.fig,'arrow');


if get(handles.temp.selection,'userdata') %userdata==true means user dragged the rectangle
    newlims=get(handles.temp.selection,'position');
    xlim=[newlims(1) newlims(1)+newlims(3)];
    ylim=[newlims(2) newlims(2)+newlims(4)];
    
    ravezoomgraph(handles.fig,[],ai,[],xlim,ylim,[]);
else
    %show zoom context menu
    drawnow;
    pos=get(handles.fig,'currentpoint');
    set(handles.contextmenus.graphzoom,'position',pos,'visible','on')
end
delete(handles.temp.selection);






