function varargout = ravechangeprefsgui(varargin)
% RAVECHANGEPREFSGUI M-file for ravechangeprefsgui.fig
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


% Last Modified by GUIDE v2.5 30-Nov-2007 14:45:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ravechangeprefsgui_OpeningFcn, ...
                   'gui_OutputFcn',  @ravechangeprefsgui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ravechangeprefsgui is made visible.
function ravechangeprefsgui_OpeningFcn(hObject, eventdata, handles, varargin)


origin=get(0,'userdata');
thispos=get(hObject,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=origin(2)+origin(4)/2-thispos(4)/2;
set(hObject,'position',thispos);


%set theme:
load raveprefs

set(0,'userdata','cancel');

set(hObject,'color',raveprefs.colors.frame);
set(handles.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);


set(handles.titleaxes,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);
set(handles.topframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);

%make titles
text(0,.4,'Change Your Preferences','parent',handles.titleaxes,'fontname',raveprefs.fonts.title,'fontsize',20*raveprefs.fonts.titlescale,...
   'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Change Where Your Files are Stored','parent',handles.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
   'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

%display button icons
A=imread('browse.bmp');
set(handles.browsebutton,'cdata',A)

%get exising handles structure from maingui
handles.indata=guidata(gcbo); %gcbo = "manage data sets" button in maingui

%show default dir:
set(handles.workdiredit,'string',raveprefs.defaultdir);

%disable create button until they choose a file
%set(handles.createbutton,'enable','off')

% Choose default command line output for ravechangeprefsgui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = ravechangeprefsgui_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;


function workdiredit_Callback(hObject, eventdata, handles)
%no callback, just shows a value.

% --- Executes during object creation, after setting all properties.
function workdiredit_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in browsebutton.
function browsebutton_Callback(hObject, eventdata, handles)
load raveprefs
path=uigetdir(raveprefs.defaultdir,'Choose Default Folder');

if path~=0
    set(handles.workdiredit,'string',path);
end

uicontrol(handles.workdiredit)
guidata(hObject,handles);


%% 
%
%
%                       DONE BUTTONS
%
%
%
%% 

% --- Executes on button press in donebutton.
function donebutton_Callback(hObject, eventdata, handles)

set(0,'userdata',handles.indata)

prefspath=which('raveprefs.mat');
load raveprefs;

newdir=get(handles.workdiredit,'string');
if ~strcmp(newdir(end),char(92))
    newdir(end+1)=char(92);
end

raveprefs.defaultdir=newdir;
save(prefspath,'raveprefs');

if ~isdir(newdir)
    mkdir(newdir);
    addpath(newdir)
    try
        savepath
    end
    rehash;
end

%create structure of new preferences to update in main gui:
newprefs.newdir=newdir;

set(0,'userdata',newprefs)
close(gcf);



% --- Executes on button press in stopbutton.
function stopbutton_Callback(hObject, eventdata, handles)
keyboard;




