function newcolor=ravecolorchooser(varargin)
%newcolor=ravecolorchooser(pos,oldcolor,Title)
%display a java color chooser in desired location, starting with oldcolor. units of pos are in
%pixels. only first 2 elements of pos matter, height and width are fixed. pos can also be the handle
%of a figure, in which case popup will be centered over figure. 
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

if numel(varargin{1})==1 %position at center of figure in varargin{1}
    oldcolor=varargin{2};
    Title=varargin{3};
    pos=get(varargin{1},'position');
    pos=[pos(1)+pos(3)/2-430/2 pos(2)+pos(4)/2-386/2];
else
    pos=varargin{1};
    oldcolor=varargin{2};
    Title=varargin{3};
end

handles.newcolor=oldcolor;

R=floor(255*oldcolor(1));
G=floor(255*oldcolor(2));
B=floor(255*oldcolor(3));

f=figure('units','pixels','position',[pos(1:2) 430 386],'menubar','none','toolbar','none','windowstyle','modal','numbertitle','off',...
    'name',Title,'resize','off');
handles.j=javacomponent('javax.swing.JColorChooser',[0 36 430 350]);
handles.j.setColor(R,G,B);

bgcolor=handles.j.getBackground;
R=bgcolor.getRed;
G=bgcolor.getGreen;
B=bgcolor.getBlue;

set(f,'color',[R G B]/255);

uicontrol('position',[150 6 100 22],'style','pushbutton','string','OK','callback',@okbutton_callback);
uicontrol('position',[270 6 100 22],'style','pushbutton','string','Cancel','callback',@cancelbutton_callback);

handles.f=f;
guidata(f,handles)
uiwait(f) %wait for window to close, then return newcolor. 

if ishandle(f) %window wasnt closed. 

    handles=guidata(f);
    newcolor=handles.newcolor;

    close(f);
else
    newcolor=oldcolor;

end


function okbutton_callback(src,ev)
handles=guidata(src);

newcolor=handles.j.getColor;

R=newcolor.getRed;
G=newcolor.getGreen;
B=newcolor.getBlue;

handles.newcolor=[R G B]/255;

guidata(handles.f,handles);
uiresume(handles.f);


function cancelbutton_callback(src,ev)
handles=guidata(src);
uiresume(handles.f);
