function ravedisplaypage(src,ev)
%displays the graphs on the current sheet and hides all others.

%% hide last page:
handles=guidata(src);

aaa=find(handles.sheet==handles.lastsheet & ishandle(handles.allgraphs));

stackorder=get(handles.boneyard,'children');

for ai=aaa
    if isempty(handles.rasters{ai})
        if ~ishandle(handles.allgraphs(ai));continue;end %graph has been deleted
        udata=get(handles.fakeax(ai),'userdata'); %#ok this line may be used by the eval statements!
        %hide main axes:
        allparents=[handles.allgraphs(ai);handles.fakeax(ai);handles.fakerax(ai);...
            handles.subax{ai}(:);handles.subfakeax{ai}(:);handles.subfakerax{ai}(:)];
        
        %hide legends:
        legdata=get(handles.fakerax(ai),'userdata');
        if isempty(legdata)
            legs=[];
        else
            legs=findobj(legdata(ishandle(legdata)),'parent',handles.wspanel);
        end

        %move other graph-specific objects:
        graphtype=get(handles.allgraphs(ai),'userdata');
        
        if strcmp(graphtype,'backgroundframe')
            set(udata.view.rectangle,'visible','off');
            set(udata.view.title,'visible','off');
        end
        
        
        if isfield(handles.graphinfo.(graphtype),'deletehandles')
            deletehandles=handles.graphinfo.(graphtype).deletehandles;
            for f=1:numel(deletehandles)
                thesehandles=eval([deletehandles{f},';']);
                allparents=[allparents;thesehandles(:)];  %#ok<AGROW>
            end
        end
        
        allparents=findobj(allparents,'parent',handles.wspanel,'-depth',1);
        %lastkids=get(handles.boneyard,'children');
        %set(allparents,'parent',handles.boneyard);
        %set(legs,'parent',handles.boneyard);
        %set(handles.boneyard,'children',[legs(:);lastkids;allparents]);
        stackorder=[legs(:);stackorder;allparents];
        set(handles.allblockers(ai),'visible','off')
        set(handles.expblockers(ai),'visible','off')
        set(handles.grabbers{ai},'visible','off')
    else %move raster
        set(handles.rasters{ai},'parent',handles.boneyard)
    end
end

%outkidz=get(handles.boneyard,'children');
set(stackorder,'parent',handles.boneyard);
set(handles.boneyard,'children',stackorder);




%% show new page:

stackorder=get(handles.wspanel,'children');


aaa=find(handles.sheet==handles.activesheet & ishandle(handles.allgraphs));
for ai=aaa
    if isempty(handles.rasters{ai})
        udata=get(handles.fakeax(ai),'userdata');  %#ok this line may be used by the eval statements!
        %hide main axes:
        allparents=[handles.allgraphs(ai);handles.fakeax(ai);handles.fakerax(ai);...
            handles.subax{ai}(:);handles.subfakeax{ai}(:);handles.subfakerax{ai}(:)];
        
        %hide legends:
        legdata=get(handles.fakerax(ai),'userdata');
        if isempty(legdata)
            legs=[];
        else
            legs=findobj(legdata(ishandle(legdata)),'parent',handles.boneyard);
        end
        

        %move other graph-specific objects:
        graphtype=get(handles.allgraphs(ai),'userdata');
        
        if strcmp(graphtype,'backgroundframe')
            set(udata.view.rectangle,'visible','on');
            set(udata.view.title,'visible','on');
        end
        
        
        if isfield(handles.graphinfo.(graphtype),'deletehandles')
            deletehandles=handles.graphinfo.(graphtype).deletehandles;
            for f=1:numel(deletehandles)
                thesehandles=eval([deletehandles{f},';']);
                allparents=[allparents;thesehandles(:)];  %#ok<AGROW>
            end
        end
        
        allparents=findobj(allparents,'parent',handles.boneyard,'-depth',1);
        
        %lastkids=get(handles.wspanel,'children');
        %set(allparents,'parent',handles.wspanel);
        %set(legs,'parent',handles.wspanel);
        %set(handles.wspanel,'children',[legs(:);allparents;lastkids]);
        
        stackorder=[legs(:);allparents;stackorder];
        
        if strcmp(get(handles.tablemodebutton,'visible'),'on') %if not in full screen mode...
            set(handles.allblockers(ai),'visible','on')
            set(handles.expblockers(ai),'visible','on')
        end
        
    else %move raster
        set(handles.rasters{ai},'parent',handles.wspanel)
    end
end

set(stackorder,'parent',handles.wspanel);
set(handles.wspanel,'children',stackorder);


guidata(handles.fig,handles);


%%if there are any new graphs on the new page, select one of them:
if ~isempty(aaa) && strcmp(get(handles.tablemodebutton,'visible'),'on')
    newgraph=handles.allgraphs(aaa(1));
    raveselectgraph(newgraph,[]);
    %handles=guidata(handles.fig);
    %set(handles.grabbers{handles.activeindex},'visible','on') %not sure why this isnt already handled by raveselectgraph...
end


