function raveexportrvffile(src,ev,name,ai)
%export a rave graph to an interactive .fig file. 
%
%ai is list of indiced (into handles.activeindex) of graphs to include in
%the export.
%
%the strategy is to save the ENTIRE rave figure, then delete everything
%that is not needed. Ridiculous, i know, but we need to ensure that all the
%handles are identical, which can't be done using copyobj.

handles=guidata(src);

name(end-2:end)='fig'; %make as a fig file initially.


%this is copied straight out of ravesavestate:
if ~isempty(name)

  %  blanktab(handles.fig,[]); %clear tabs so tabobjects don't get saved.
  %  handles=guidata(handles.fig);

    %delete tray icon:
    
    pause(0.1) %to avoid java crash
    sysTray = java.awt.SystemTray.getSystemTray;
    if (sysTray.isSupported)
        java.awt.SystemTray.getSystemTray.remove(handles.trayIcon);
    end
    pause(0.1)
    handles.trayIcon=[];
    guidata(handles.fig,handles);

   
    
    hgS = handle2struct(handles.fig);
    SaveVer = '070000'; %if error, change to '080000'
    SaveVars.(sprintf('hgS_%s', SaveVer)) = hgS;
  
    %no, really:
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.maintable.jtable=[];
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.maintable.defaultRowHeaderRenderer=[];
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.maintable.rhmodels=[];
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.maintable.models=[];
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.maintable.jscroll=[];
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.mousetimer=[]; %timer objects cant be saved
    SaveVars.hgS_070000.properties.ApplicationData.UsedByGUIData_m.sounds=[]; %audioplayer objects cant be saved
    
      %Remove the java controls associated with graphaxes control types. This
    %is necessary because their delete functions are specific to the MATLAB version used to create them. (I
    %suppose I could also jsut clear their delete functions, but presumably
    %those are doing something important).
    
    gacontrols=[];
    for c=1:numel(handles.allgraphs);
        if ishandle(handles.allgraphs(c)) && strcmp(get(handles.allgraphs(c),'userdata'),'graphaxes')
            gacontrols=union(gacontrols,handles.fakeax(c));
        end
    end
    
    if ~isempty(gacontrols)
        for g=1:numel(SaveVars.hgS_070000.children)
            if strcmp(SaveVars.hgS_070000.children(g).type,'uipanel')
                %look for hgjavacomponents:
                for j=1:numel(SaveVars.hgS_070000.children(g).children)
                    if  strcmp(SaveVars.hgS_070000.children(g).children(j).type,'hgjavacomponent')
                        mfd(j)=true;
                    else
                        mfd(j)=false;
                    end
                    
                    %also need to remove these from userdata so that we
                    %dont get an invalid handle error next time we try to delete them:
                    if  strcmp(SaveVars.hgS_070000.children(g).children(j).type,'axes')
                        if ismember(SaveVars.hgS_070000.children(g).children(j).handle,gacontrols)
                            SaveVars.hgS_070000.children(g).children(j).properties.UserData.view.X.menujobj=[];
                            SaveVars.hgS_070000.children(g).children(j).properties.UserData.view.Y.menujobj=[];
                            SaveVars.hgS_070000.children(g).children(j).properties.UserData.view.Z.menujobj=[];
                            SaveVars.hgS_070000.children(g).children(j).properties.UserData.view.C.menujobj=[];
                            SaveVars.hgS_070000.children(g).children(j).properties.UserData.view.S.menujobj=[];
                        end
                    end
                end
                SaveVars.hgS_070000.children(g).children(mfd)=[]; %delete this.
            end
        end
    end
    
    
    save(name, '-struct', 'SaveVars');

    handles.activedir=path;
    
    %restore tray icon:
    if (sysTray.isSupported)
        raveroot=which('rave');
        raveroot=raveroot(1:end-6);
        myIcon = fullfile(raveroot,'images\tinyrave.png');
        iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
        handles.trayIcon = java.awt.TrayIcon(iconImage, 'initial tooltip');
        handles.trayIcon.setToolTip('Rave is running.');
        sysTray.add(handles.trayIcon)
    else
        handles.trayIcon=[];
    end
end

guidata(handles.fig,handles);

clear handles

%% now open the new figure and delete everything that isnt needed:
handy=openfig(name,'new','invisible');
set(handy,'resizefcn','','windowscrollwheelfcn','');

handles=guidata(handy);

if numel(ai)==1;
    pos=get(handles.allblockers(ai),'position');
else
    pos=get(handles.roi(1),'position');
end

%delete Rave gui stuff:
[junk, namename, ext]=fileparts(name);

trash=findobj(handy,'-not','type','uipanel','-depth',1);
trash=setdiff(trash,handy);
delete(trash);

delete(handles.vscroll);
delete(handles.hscroll);

handles.vscroll=[];
handles.hscroll=[];
handles.tabobjects=[];

set(handles.allblockers,'visible','off')
delete(handles.lgrid);
delete(handles.sgrid);
delete(handles.mgrid);
allgrabs=cell2mat(handles.grabbers);
delete(allgrabs(ishandle(allgrabs)));
set(handy,'name','Rave Exported Figure')

handles.infobar=[];

%Avoid deleting graphs, since that will inevitably lead to errors when the analysis
%updates during interaction. Instead, just hide some visiblilties to try
%to improve performance a little:
for a=1:numel(handles.allgraphs)
    if ~ismember(a,ai) && ishandle(handles.allgraphs(a))
        set(findobj(handles.allgraphs(a)),'visible','off')
        set(findobj(handles.fakeax(a)),'visible','off')
        set(findobj(handles.fakerax(a)),'visible','off')
        set(findobj(handles.subax{a}),'visible','off')
        set(findobj(handles.subfakeax{a}),'visible','off')
        set(findobj(handles.subfakerax{a}),'visible','off')
    end
end

%% reposition stuff:
uipos=get(handles.wspanel,'position');
uipos=uipos+[-(30+315*handles.prefs.tabscale) 35 0 0];

set(handles.wspanel,'position',uipos);

uipos=get(handles.wspanel,'position');
uipos=uipos+[-pos(1) 0 0 0];
set(handles.wspanel,'position',uipos);

fpos=get(handy,'pos');
a=fpos(4);
b=uipos(4);
e=pos(2);
c=e-(b-a);

uipos=get(handles.wspanel,'position');
uipos=uipos+[0 -c 0 0];
set(handles.wspanel,'position',uipos);

set(handy,'resizefcn',[],'closerequestfcn','default','resize','on');
set(handy,'name',namename);
set(handy,'pos',[fpos(1) fpos(2) pos(3) pos(4)]);

allunits=findall(handy,'-property','units');
set(allunits,'units','normalized');

set(handles.mainaxes,'hittest','off')
set(handles.allblockers,'hittest','off')
set(handles.wspanel,'hittest','off')

%save figure:
guidata(handy,handles);
set(handy,'visible','on');
saveas(handy,name);
close(handy);

%rename to .rvf:
rname=name;
rname(end-2:end)='rvf';
movefile(name,rname,'f');




