function f=ravefile2mgui(src,ev)
handles=guidata(src);

info.cancelled=1;
set(0,'userdata',info);

%make figure:
f=figure('units','pixels','position',[0 0 652 657],'name',...
    'Import model from file','numbertitle','off','menubar','none','resize','off','windowstyle','normal',...
    'color',handles.colors.frame);

handles.gui=f;
origin=get(handles.fig,'position');
thispos=get(f,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=thispos(2)+origin(2)+origin(4)/2-thispos(4)/2;
set(f,'position',thispos);

titleaxes=axes('units','pixels','position',[11 605 218 37],'visible','off',...
    'xlimmode','manual','ylimmode','manual','parent',f);

u1=uipanel('units','pixels','position',[23 444 610 158],...
    'bordertype','etchedin','backgroundcolor',handles.colors.tabbg,'foregroundcolor',[0 0 0],...
    'shadowcolor',[.5 .5 .5],'parent',f);

u1titleaxes=axes('units','pixels','position',[5 110 218 37],'visible','off',...
    'xlimmode','manual','ylimmode','manual','parent',u1);

uicontrol('style','text','units','pixels','position',[20 96 391 15],'parent',u1,...
    'backgroundcolor',[1 1 1],'foregroundcolor',[0 0 0],'fontsize',8,'hor','left',...
    'string','Source file (must include full path if file is not on MATLAB search path):');

A=imread('browse.bmp');
uicontrol('style','pushbutton','units','pixels','position',[40 67 24 24],...
    'callback',@browsebutton_Callback,'tooltip','Browse...','parent',u1,'cdata',A);

uicontrol('style','pushbutton','units','pixels','position',[422 25 150 24],...
    'callback',@parsebutton_Callback,'string','Parse File','parent',u1);

uicontrol('style','edit','units','pixels','position',[77 66 497 25],'tag','sourcename',...
    'callback',[],'backgroundcolor',[1 1 1],'hor','left','parent',u1);

uicontrol('style','text','units','pixels','position',[20 48 170 15],'parent',u1,...
    'backgroundcolor',[1 1 1],'foregroundcolor',[0 0 0],'fontsize',8,'hor','left',...
    'string','Select associated data set:');

uicontrol('style','popup','units','pixels','position',[40 26 236 20],'parent',u1,...
    'backgroundcolor',[1 1 1],'callback',@datasetmenu_Callback,...
    'string',handles.datasetnames,'value',1,'tag','datasetmenu');


u2=uipanel('units','pixels','position',[23 174 300 262],...
    'bordertype','etchedin','backgroundcolor',handles.colors.tabbg,'foregroundcolor',[0 0 0],...
    'shadowcolor',[.5 .5 .5],'parent',f);

u2titleaxes=axes('units','pixels','position',[2 225 287 30],'visible','off',...
    'xlimmode','manual','ylimmode','manual','parent',u2);

uicontrol('style','text','units','pixels','position',[12 212-20 237 35],'parent',u2,...
    'backgroundcolor',[1 1 1],'foregroundcolor',[0 0 0],'fontsize',8,'hor','left',...
    'string',{'New variables with these names will be added';'to the selected data set.'});

uicontrol('style','listbox','units','pixels','position',[20 17 266 179],'parent',u2,'tag','funlist',...
    'backgroundcolor',[1 1 1],'hor','left','max',100,'string','You must first parse a source file.');

u3=uipanel('units','pixels','position',[333 174 300 262],...
    'bordertype','etchedin','backgroundcolor',handles.colors.tabbg,'foregroundcolor',[0 0 0],...
    'shadowcolor',[.5 .5 .5],'parent',f);

u3titleaxes=axes('units','pixels','position',[2 225 287 30],'visible','off',...
    'xlimmode','manual','ylimmode','manual','parent',u3);

uicontrol('style','text','units','pixels','position',[12 212-20 267 35],'parent',u3,...
    'backgroundcolor',[1 1 1],'foregroundcolor',[0 0 0],'fontsize',8,...
    'string',{'Function will recalculate when these variables change values. When in doubt, select them all.'},...
    'hor','left');

uicontrol('style','listbox','units','pixels','position',[20 17 266 179],'parent',u3,'tag','varlist',...
    'backgroundcolor',[1 1 1],'hor','left','max',100,'string',handles.allnames{1},'value',find(~handles.isresponse{1}));

uicontrol('style','text','units','pixels','position',[22 132 620 34],'parent',f,...
    'backgroundcolor',handles.colors.frame,'foregroundcolor',[0 0 0],'fontsize',8,...
    'string',{'Select function attributes below. (All variables selected above must share these attributes. If variables do not share attributes,';'simply use this gui multiple times changing the variables selected above.)'},...
    'hor','left');

uicontrol('style','checkbox','units','pixels','position',[22 107 679 23],'parent',f,'tag','objectivecheck',...
    'backgroundcolor',handles.colors.frame,'string','Check box if these variables are functions of Preferences (in addition to the input variables selected above)');

uicontrol('style','checkbox','units','pixels','position',[22 84 278 23],'parent',f,'tag','staticcheck',...
    'backgroundcolor',handles.colors.frame,'string','Check box if these variables are static functions','value',0,...
    'enable','off','visible','off');

uicontrol('style','pushbutton','units','pixels','position',[22 12 289 39],'parent',f,'tag','importbutton',...
    'string','Import this Function','fontsize',16,'enable','off','callback',@importbutton_Callback);

uicontrol('style','pushbutton','units','pixels','position',[537 12 96 39],'parent',f,...
    'string','Close','fontsize',16,'callback',@cancelbutton_Callback);

%make titles:
text(0,.4,'Import Function from File','parent',titleaxes,'fontname',handles.prefs.fonts.title,'fontsize',20*handles.prefs.fonts.titlescale,...
    'color',handles.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Select Variables to Model','parent',u2titleaxes,'fontname',handles.prefs.fonts.tab,'fontsize',18*handles.prefs.fonts.tabscale,...
    'color',handles.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Select Input Variables','parent',u3titleaxes,'fontname',handles.prefs.fonts.tab,'fontsize',18*handles.prefs.fonts.tabscale,...
    'color',handles.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Configure','parent',u1titleaxes,'fontname',handles.prefs.fonts.tab,'fontsize',18*handles.prefs.fonts.tabscale,...
    'color',handles.colors.text,'horizontalalignment','left','verticalalignment','baseline');

guidata(f,handles);


function cancelbutton_Callback(src,ev)
% info.cancelled=1;
% set(0,'userdata',info);
close(gcf);


function datasetmenu_Callback(src,ev)
handles=guidata(src);
%lets user select which data set they wanna use.
d=get(src,'value');
varlist=findobj(gcf,'tag','varlist');
set(varlist,'string',handles.allnames{d},'value',find(~handles.isresponse{d}));


function browsebutton_Callback(src,ev)
handles=guidata(src);

[name,path,index]=uigetfile({'*.m','m File (*.m)';'*.txt','Text File (*.txt)';'*.*','All Files (*.*)'},'Choose function file to load:'); %#ok<NASGU>
if ~ischar(name);return;end

sourcename=findobj(gcf,'tag','sourcename');
set(sourcename,'string',fullfile(path,name));



function parsebutton_Callback(src,ev)
handles=guidata(src);

sourcename=findobj(gcf,'tag','sourcename');
datasetmenu=findobj(gcf,'tag','datasetmenu');

d=get(datasetmenu,'value');
filename=get(sourcename,'string');

[junk,root,ext]=fileparts(filename);

if isempty(junk)
    filename=which(filename);
end

if isempty(filename)
    errordlg('No file with the specified name was found on the MATLAB search path.','File not found');
    return
end

info=[];

switch ext
    case '.m'
        info=raveparsemfilefunction(handles.fig,[],d,filename);
    case '.txt'
        info=raveparsetxtfilefunction(handles.fig,[],d,filename);
end

funlist=findobj(gcf,'tag','funlist');
importbutton=findobj(gcf,'tag','importbutton');
varlist=findobj(gcf,'tag','varlist');

if ~isempty(info)
    set(varlist,'value',info.inputvars);
    set(funlist,'string',info.outputnames,'value',1:numel(info.outputnames));
    set(importbutton,'enable','on');
end

switch info.funtype
    case 'matlab_varnames'
        set(varlist,'enable','off')
    otherwise
        set(varlist,'enable','on')
end

handles.temp.info=info;
guidata(src,handles);


function importbutton_Callback(src,ev)
handles=guidata(src);
set(src,'enable','off');
drawnow;

f=gcbf;
funlist=findobj(f,'tag','funlist');
sourcename=findobj(f,'tag','sourcename');
varlist=findobj(f,'tag','varlist');
objectivecheck=findobj(f,'tag','objectivecheck');
staticcheck=findobj(f,'tag','staticcheck');


info=handles.temp.info;
info.responsename=get(funlist,'string');
info.path=get(sourcename,'string');
info.cancelled=0;

switch info.funtype
    case 'matlab_varnames'
        %do nothing
    otherwise
        info.inputvars=get(varlist,'value');
end

info.nargout=get(funlist,'value');
info.isobjective=get(objectivecheck,'value');
info.isstatic=get(staticcheck,'value');
set(0,'userdata',info);

%determine file type from extension:
%get file name from path:
[pathstr, filename, ext] = fileparts(info.path); 

switch ext
    case '.m'
        processmfile(handles.fig,ev,info);
    case '.txt'
        processtxtfile(handles.fig,ev,info);
end

handles=guidata(handles.fig);
set(handles.infobar,'string','Function loaded successfully.');

%update maintable udata to display new columns:
d=info.dataset;
handles.maintable.x{d}=union(handles.maintable.x{d},(size(handles.alldata{d},2)-numel(info.nargout)):size(handles.alldata{d},2));
raveupdatedataset(handles.fig,[],'addcolumns',[],d);
ravefinish; %make a done sound.

%clear gui:
set(funlist,'string','You must first parse a source file.','value',1,'enable','off');
varz=get(varlist,'string');
set(varlist,'value',1:numel(varz),'enable','off');
set(sourcename,'string','');

function processmfile(src,ev,info)
handles=guidata(src);

responsename=info.responsename';
d=info.dataset;
%varnames=info.varnames;
path=info.path;
inputvars=info.inputvars;
inputnames=info.inputnames;

%remove spaces from varnames
% for j=1:length(varnames)
%     varnames{j}=varnames{j}(varnames{j}~=char(32));
% end

%find which column of data set holds each input variable:
%existingnames=handles.allnames{d};
%nvars=numel(inputvars);

% varorder=zeros(1,nvars);
% for i=1:nvars
%     if ~isempty(find(strcmp(existingnames,varnames(i)),1))
%         varorder(i)=find(strcmp(existingnames,varnames(i)),1);
%     else
%         varorder(i)=0; %a non-dataset variable
%     end
% end


%get file name from path:
[pathstr, filename, ext] = fileparts(path); %#ok
functionname=filename; %(1:end-2);
% 
% if isempty(which(functionname))
%     addpath(pathstr);
%     savepath;
%     if isempty(which(functionname))
%         warndlg('The function you selected is in a folder that is not on your MATLAB search path, and the folder could not be added to the path. You must move it onto your path before you can use it in RAVE.','I can''t let you do that');
%         return
%     end
% end
% 
% if ~strcmp(path,which(functionname))
%     warndlg({['The function you selected could not be loaded because there is another function ',...
%         'with the same name higher on your MATLAB search path. Rename the function or remove other ',...
%         'functions with the same name and try again.']; '(To see all functions on your path with this name, type:';['"which ',...
%         filename,' -all" at the MATLAB command prompt.)']},'I can''t let you do that');
%     return
% end

funhandle=str2func(functionname);
prefs=handles.preferences{d};
targets=handles.targetvalues{d};



% if nargin(funhandle)==1
%     [allvalues{:}]=funhandle(handles.alldata{d});
% else %should have 3 inputs
%     [allvalues{:}]=funhandle(handles.alldata{d},prefs,targets);
% end

udata=handles.alldata{d}(:,inputvars);
alloutputs=cell(1,nargout(funhandle));

switch info.funtype
    case 'matlab_generic' %not used anymore but keep here for backward compatibility
        if nargin(xfun)==3
            [alloutputs{:}]=funhandle(udata,prefs,targets);
        else
            [alloutputs{:}]=funhandle(udata);
        end
    case 'matlab_singleinput';
        [alloutputs{:}]=funhandle(udata);
    case 'matlab_threeinput'; %
        [alloutputs{:}]=funhandle(udata,prefs,targets);
    case 'matlab_varnames'; %each variable in its own column
        udata=mat2cell(udata,size(udata,1),ones(1,size(udata,2)));
        [alloutputs{:}]=funhandle(udata{:});
        
end

%update fields:
for j=1:numel(info.nargout) %for each variable being modelled
    newvalues=alloutputs{info.nargout(j)}(:,1); %just take first column, this protects against array outputs, which rave cant handle.
    
    handles.alldata{d}(:,end+1)=newvalues;
    handles.isvalid{d}(:,end+1)=true;
    handles.alltext{d}=[handles.alltext{d},cell(length(newvalues),1)];
    handles.allnames{d}{end+1}=responsename{info.nargout(j)};
    handles.datasetlinks{d}{end+1}=[];
    handles.datasetlinkinfo{d}{end+1}={};
    handles.variablecolors{d}(end+1,:)=rand(1,3);
    handles.isresponse{d}(end+1)=1;
    handles.allunits{d}{end+1}=''; %havent implemented this yet
    handles.isincluded{d}(end+1)=1;
    handles.isdecided{d}(end+1)=0;
    handles.isconstant{d}(end+1)=0; %note, should really use an if statement here to check if it's constant.
    handles.isfunction{d}(end+1)=1;
    handles.funclass{d}{end+1}=info.funtype;
    handles.funnames{d}{end+1}=functionname;
    handles.funvars{d}{end+1}=inputvars;
    handles.nargout{d}(end+1)=info.nargout(j);
    handles.datatype{d}{end+1}='continuous';
    handles.isnoise{d}(end+1)=false;
    handles.distname{d}{end+1}='uniform';
    handles.distparams{d}{end+1}=[min(newvalues) max(newvalues)];
    handles.preferences{d}(end+1)=0;
    handles.targetvalues{d}(end+1)=-inf;
    handles.isobjective{d}(end+1)=info.isobjective;
    handles.maintable.colwidths{d}(end+1)=handles.prefs.colwidth;
    for a=1:numel(handles.analysisnames)
        handles.xdials{d}{a}(end+1)=0;
        if ~isempty(newvalues)
            handles.minlimit{d}{a}(end+1)=min(newvalues);
            handles.maxlimit{d}{a}(end+1)=max(newvalues);
            handles.minfilter{d}{a}(end+1)=min(newvalues);
            handles.maxfilter{d}{a}(end+1)=max(newvalues);
        else
            handles.minlimit{d}{a}(end+1)=0;
            handles.maxlimit{d}{a}(end+1)=eps(1);
            handles.minfilter{d}{a}(end+1)=0;
            handles.maxfilter{d}{a}(end+1)=eps(1);
        end
        handles.discretevalues{d}{a}{end+1}=[];
    end
end

guidata(handles.fig,handles);

function processtxtfile(src,ev,info)




