function [maincount,selectedcount,filtcount,nbars,edges,mainbins]=ravehistogramcount(src,ev,d,a,xcol,idx,nbars,discreteascategory)
%generates histogram data for column xcol of dataset d. Calculations are
%made so the resulting histogram has nbars bars. Only rows for which
%idx=true are considered. Discrete varaibles are treated as strings if
%discreteascategory=true. Output nbars may differ from input nbars if the
%variable is discrete/string. Output vectors have length =sum(idx)
handles=guidata(src);
allnothidden=handles.isvisible{d}{a};
allisselected=handles.isselected{d}{a};
allisfiltered=handles.isfiltered{d}{a};


x=handles.alldata{d}(:,xcol);

%determine bounds before applying idx:
minx=min(x);
maxx=max(x);

x=x(idx);
isselected=allisselected(idx);
nothidden=allnothidden(idx);
isfiltered=allisfiltered(idx);


switch handles.datatype{d}{xcol}
    case {'continuous','constant','integer'}
        if minx==maxx %x is constant
            edges=[x(1)-1 x(1)+1];
        else
            edges=linspace(minx,maxx,nbars+1);
        end
        
    case 'discrete'
        if discreteascategory
            nbars=numel(handles.discretevalues{d}{a}{xcol});
            if minx==maxx %x is constant
                edges=[x(1)-1 x(1)+1];
            else
                edges=linspace(minx,maxx,nbars+1);
            end
        else
            nbars=numel(handles.discretevalues{d}{a}{xcol});
            if minx==maxx %x is constant
                edges=[x(1)-1 x(1)+1];
            else
                edges=linspace(minx,maxx,nbars+1);
            end
        end
        
    case 'string'
        nbars=numel(handles.discretevalues{d}{a}{xcol});
        if minx==maxx %x is constant
            edges=[x(1)-1 x(1)+1];
        else
            edges=1:maxx;
        end
end

%check if for all practical purposes, variable is a constant.
if numel(unique(edges))<numel(edges)
    edges=[x(1)-1 x(1)+1];
end

filtcount=histc(x(nothidden),edges); %this is all data, basically this forms the background. Only modify maincount when filtering.
[maincount,mainbins]=histc(x(nothidden & ~isfiltered),edges);

if ~isempty(x);
    selectedcount=histc(x(isselected & nothidden),edges);
else
    selectedcount=[0 0];
end


