function [xlabel ylabel zlabel]=ravemakelabelstrings(ax)
% return strings that contain the label text for axes "ax" as a string (even if they are really a cell array) so it can
% be displayed in a single line edit box.


% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


if ~ishandle(ax);return;end
if ~strcmp(get(ax,'type'),'axes');return;end

xlabel=get(ax,'xlabel');
xlabel=get(xlabel,'string');
if iscell(xlabel);
    newxlabel='';
    for f=1:numel(xlabel);
        if ~isempty(xlabel{f})
            newxlabel=[newxlabel xlabel{f} ';']; %#ok<AGROW>
        end
    end
    xlabel=newxlabel(1:end-1);
end

ylabel=get(ax,'ylabel');
ylabel=get(ylabel,'string');
if iscell(ylabel);
    newylabel='';
    for f=1:numel(ylabel);
        if ~isempty(ylabel{f})
            newylabel=[newylabel ylabel{f} ';']; %#ok<AGROW>
        end
    end
    ylabel=newylabel(1:end-1);
end



zlabel=get(ax,'zlabel');
zlabel=get(zlabel,'string');
if iscell(zlabel);
    newzlabel='';
    for f=1:numel(zlabel);
        if ~isempty(zlabel{f})
            newzlabel=[newzlabel zlabel{f} ';']; %#ok<AGROW>
        end
    end
    zlabel=newzlabel(1:end-1);
end
