function ravemakesurrogatemodels(src,ev)
%fit models in the queue. 

handles=guidata(src);

%check if anything needs doing:
if isempty(handles.modelqueue)
   warndlg('There are no models waiting to be created. Use the controls in the top half of the window to add models to the queue, then use this button to create the models.','No models in queue') ;
   return   
end

%turn create button into stop button:
set(src,'visible','off');

pb=findobj(gcf,'tag','pausebutton');
set(pb,'visible','on','value',0);
drawnow;

%make the models:
nmodels=numel(handles.modelqueue);
jtable=handles.temp.jscroll.getComponent(0).getComponent(0);
i=1;



%determine which row of table is the first unfinished model (in case of
%pausing:

asdf=1;

offset=0;
for k=1:jtable.getRowCount
    if strcmp(jtable.getValueAt(k-1,3),'Finished')
        offset=offset+1;
    end
end




for j=1:nmodels
    %check for pausing:
    drawnow
    if get(pb,'value') %pause
        set(pb,'visible','off','value',0)
        set(src,'visible','on')
        return
    end   
    
    %skip disabled models:
    if strcmp(handles.modelqueue{i}.status,'Disabled')
        i=i+1;
        continue
    end
    
    
    settings=handles.modelqueue{i};
    thistype=settings.modeltype; 
        
    
    jtable.setValueAt(java.lang.String('Creating...'),j-1+offset,3)
    rowstatus=jtable.getModel.getRowStatus;
    rowstatus(j+offset)=2;
    rs=javaArray('java.lang.Integer',nmodels+offset);
    for r=1:nmodels+offset;rs(r)=java.lang.Integer(rowstatus(r));end
    jtable.getModel.setRowStatus(rs);
    jtable.repaint;

    %make model (updates the settings structure);
    eval(['settings=ravemakemodel',thistype,'(handles.fig,[],settings);']);

    %move model from queue to finished models list:
    settings.status='Finished';
    handles.models{end+1}=settings;
    handles.modelqueue(i)=[];
    guidata(handles.fig,handles);
    guidata(gcf,handles); %makemodelgui
    %update table in makemodelgui:
    
    jtable.setValueAt(java.lang.String('Finished'),j-1+offset,3)
    rowstatus=jtable.getModel.getRowStatus;
    rowstatus(j+offset)=3;
    rs=javaArray('java.lang.Integer',nmodels+offset);
    for r=1:nmodels+offset;rs(r)=java.lang.Integer(rowstatus(r));end
    jtable.getModel.setRowStatus(rs);
    jtable.repaint;
end

set(pb,'visible','off','value',0)
set(src,'visible','on')


