function ravemodelselectiontablecallback(src,ev,method)
handles=guidata(src);
jtable=handles.temp.jscroll.getComponent(0).getComponent(0);
selection=jtable.getSelectedRows+1;
switch method
    case 'delete'
        answer=questdlg('Are you sure you want to delete the selected model? (This action cannot be undone.)','Delete Model');
        if ~strcmpi(answer,'yes');return;end
        maxmod=numel(handles.models);
        handles.models=handles.models(setdiff(1:maxmod,selection));
        guidata(src,handles);
        guidata(handles.fig,handles);
        
        %update table:
        nmodels=numel(handles.temp.visiblemodels);
        z=handles.temp.visiblemodels;
        
        if nmodels<1
            javarray = {'','','',''};
            rowstatus=[];
        else
            javarray=javaArray('java.lang.String',nmodels,4);
            rowstatus=javaArray('java.lang.Integer',nmodels);
            for r=1:nmodels
                d=handles.models{r}.dataset;
                javarray(r,1)=java.lang.String(handles.models{z(r)}.name);
                javarray(r,2)=java.lang.String(handles.models{z(r)}.longname);
                javarray(r,3)=java.lang.String(handles.allnames{d}{handles.models{z(r)}.output});
                javarray(r,4)=java.lang.String(handles.models{z(r)}.notes);
                switch handles.models{z(r)}.status
                    case 'Waiting...'
                        rowstatus(r)=java.lang.Integer(2);
                    case 'Error'
                        rowstatus(r)=java.lang.Integer(1);
                    case 'Finished'
                        rowstatus(r)=java.lang.Integer(0);
                end
                
                if ~isempty(handles.models{z(r)}.modeledcolumn)
                    rowstatus(r)=java.lang.Integer(4);
                end
            end
        end
        cnames = {'Name','Model Type','Variable','Notes'};
        
        dmod=RaveDataTypeTableModel(javarray,cnames);
        if ~isempty(rowstatus)
            dmod.setRowStatus(rowstatus);
        end
        
        drawnow;
        handles.temp.jtable.setModel(dmod);
        
        colwidths=[150 200 200 446]; %some column widths
        for c=1:4 %set the widths:
            handles.temp.jtable.getColumnModel().getColumn(c-1).setPreferredWidth(colwidths(c))
        end
        drawnow;
        
        %reset selection:
        if isempty(handles.temp.visiblemodels)
            handles.temp.jtable.clearSelection();
            clearselection(gcf,[]);
        else
            handles.temp.jtable.setRowSelectionInterval(0,0);
            tableSelectionChanged_callback(handles.temp.jtable,[],gcf)
        end
end
