function raveresizefcn(src,ev)
%resize the rave window
set(src,'resizefcn',[]);
handles=guidata(src);
set(src,'windowbuttonupfcn',@raveresizefiguredone);
pos=get(src,'position');

if pos(3)<500
    raveresizefiguredone(handles.fig,[]);
    return
end

if pos(4)<700
    pos(2)=pos(2)-(700-pos(4));
    pos(4)=700;
    set(src,'position',pos);
end

handles.height=pos(4);
handles.width=pos(3);

guidata(handles.fig,handles);

%% reposition frames (do this first since most things refer back to these positions)

set(handles.leftmargin,'position',[0 -5 30+315*handles.prefs.tabscale handles.height+11]);
set(handles.rightmargin,'position',[handles.width-13 -5 40 handles.height+20]);
set(handles.topmargin,'position',[-5 handles.height-35 handles.width+5 60]);
set(handles.bottommargin,'position',[-5 1 handles.width+10 17]);

%% reposition workspace:
if handles.tabsvisible
    leftpos=get(handles.leftmargin,'position');
    rightpos=get(handles.rightmargin,'position');
    toppos=get(handles.topmargin,'position');
    botpos=get(handles.bottommargin,'position');
    
    handles.workspacedims=[rightpos(1)-leftpos(1)-leftpos(3),toppos(2)-botpos(2)-botpos(4)];
    handles.workspacepos=[leftpos(1)+leftpos(3) botpos(2)+botpos(4) handles.workspacedims(1) handles.workspacedims(2)];
    
    mainaxespos=get(handles.wspanel,'position');
    makethistall=min(handles.workspacepos(4),handles.prefs.wsheight);
    makethiswide=min(handles.workspacepos(3),handles.prefs.wswidth);
    putthisfarup=handles.workspacepos(2)-mainaxespos(2);
    putthisfarleft=handles.workspacepos(1)-mainaxespos(1);
    %draw it
    set(handles.currentview,'position',[putthisfarleft putthisfarup makethiswide makethistall]);
    ravemoveview(handles.fig,[],[0 handles.wsrows*handles.prefs.gridsize]);
else
    %reduce leftmarginposition to 1 pixel
    leftpos=get(handles.leftmargin,'position');
    leftpos(3)=1;
    set(handles.leftmargin,'position',leftpos);
    toppos=get(handles.topmargin,'position');
    set(handles.topmargin,'position',toppos+[0 35 0 0])
    %update workspaceposition
    rightpos=get(handles.rightmargin,'position');
    toppos=get(handles.topmargin,'position');
    botpos=get(handles.bottommargin,'position');
    handles.workspacedims=[rightpos(1)-leftpos(1)-leftpos(3),toppos(2)-botpos(2)-botpos(4)];
    handles.workspacepos=[leftpos(1)+leftpos(3) botpos(2)+botpos(4) handles.workspacedims(1) handles.workspacedims(2)];
end



%% should explorer be visible?
if handles.height<=776
    set(handles.explorer,'position',[-500 -500 100 100]);
else
    if handles.height>=900
        pushdown=30; %move down a little so its not so cramped
        explheight=150;
    else
        pushdown=0;
        explheight=110;
    end
    
    if handles.wscols>=240/explheight*handles.wsrows %width constrained
        set(handles.explorer,'position',[100 handles.height-155-pushdown 240 handles.wsrows/handles.wscols*240]);
    else%height constrained
        set(handles.explorer,'position',[100 handles.height-5-explheight-pushdown handles.wscols/handles.wsrows*explheight explheight])
    end
end

%% should titles be visible?
if handles.height>900
    aaa=get(handles.explorertitle,'parent');
    set(aaa,'position',[340-handles.wscols/handles.wsrows*150 handles.height-1-pushdown 200 50]);
    if handles.tabsvisible
        set(handles.explorertitle,'visible','on')
    end
else
    set(handles.explorertitle,'visible','off');
end

if handles.height>=900
    if handles.tabsvisible
        set(handles.titleaxes,'visible','on');
    end
    axesoffset=85;
else
    set(handles.titleaxes,'visible','off');
    axesoffset=25;
end

%% reposition tabs
if handles.height>=900
    pushup=15;
else
    pushup=0;
end

set(handles.bgtabaxes,'position',[20+30*(handles.prefs.tabscale) pushup+axesoffset-20-650*(handles.prefs.tabscale-1) 261*handles.prefs.tabscale 631*handles.prefs.tabscale])
set(handles.tabaxes,'position',[20+60*(handles.prefs.tabscale) 20+pushup-20+axesoffset-650*(handles.prefs.tabscale-1) 261*handles.prefs.tabscale 631*handles.prefs.tabscale])
set(handles.fronttabaxes,'position',[20+30*(handles.prefs.tabscale) 20+pushup-20+axesoffset-650*(handles.prefs.tabscale-1) 30*handles.prefs.tabscale 631*handles.prefs.tabscale])
set(handles.backtabaxes,'position',[20 pushup-20+axesoffset-650*(handles.prefs.tabscale-1) 30*handles.prefs.tabscale 630*handles.prefs.tabscale])

%% reposition buttons
if handles.height>=900
    gap=9;
    if handles.tabsvisible
        set(handles.controltitle,'visible','on')
    end
else
    gap=3;
    set(handles.controltitle,'visible','off')
end

if handles.height<=776
    set(handles.tablemodebutton,'position',[10 660 73 32])
    set(handles.newbutton,'position',[85+20-18 660 32 32]);
    set(handles.zoombutton,'position',[85+36+20-18 660 32 32]);
    set(handles.showgridbutton,'position',[85+2*36+20-18 660 32 32]);
    set(handles.openglbutton,'position',[85+3*36+20-18 660 32 32]);
    set(handles.hideshowbutton,'position',[85+4*36+20-18 660 32 32]);
else
    set(handles.tablemodebutton,'position',[18 handles.height-35-pushdown 73 32])
    set(handles.newbutton,'position',[18 handles.height-66-gap-pushdown 32 32]);
    set(handles.zoombutton,'position',[59 handles.height-66-gap-pushdown 32 32]);
    set(handles.showgridbutton,'position',[18 handles.height-128-3*gap-pushdown 32 32]);
    set(handles.openglbutton,'position',[59 handles.height-97-2*gap-pushdown 32 32]);
    set(handles.hideshowbutton,'position',[18 handles.height-97-2*gap-pushdown 32 32]);
end

infoaxes=findobj(handles.fig,'type','axes','tag','infoaxes');

infopos=get(handles.topmargin,'position');
set(infoaxes,'position',infopos+[360 0 -360 0]);

pos=get(handles.fig,'pos');
if pos(4)<700
    pos(2)=pos(2)-(700-pos(4));
    pos(4)=700;
    set(src,'position',pos);
end

set(handles.stopbutton,'position',[handles.width-105 handles.height-32 100 32]);

%% reposition page controls:
if handles.tabsvisible
    set(handles.pageedit,'position',[280+5 handles.height-31 40 20])
    set(handles.pagecontrols.left,'position',[263+5 handles.height-35 17 27]);
    set(handles.pagecontrols.right,'position',[320+5 handles.height-35 17 27]);
else
    switch upper(handles.prefs.pagecontrollocation)
        case 'SE'
            set(handles.pageedit,'position',[handles.width+285-370 25 40 20]);
            set(handles.pagecontrols.left,'position',[handles.width+268-370 20 17 27]);
            set(handles.pagecontrols.right,'position',[handles.width+325-370 20 17 27]);
    end
end


%% reposition scroll bars
%get x y coords of rectangle in explorer
cvpos=get(handles.currentview,'position');


vslidestep=[.05 cvpos(4)/((handles.prefs.gridsize*handles.wsrows)-cvpos(4))];
if any(vslidestep<0) || any(isinf(vslidestep))
    set(handles.vscroll,'visible','off');
else
    set(handles.vscroll,'position',[handles.width-16 17 16 handles.height-53],'min',cvpos(4)/2,...
        'max',handles.prefs.gridsize*handles.wsrows-cvpos(4)/2+5,...
        'sliderstep',[.05 cvpos(4)/((handles.prefs.gridsize*handles.wsrows)-cvpos(4))],...
        'value',handles.prefs.gridsize*handles.wsrows-cvpos(4)/2);
    if ~handles.tablemode
        set(handles.vscroll,'visible','on')
    end
end


hslidestep=[.02 cvpos(3)/((handles.prefs.gridsize*handles.wscols)-cvpos(3))];
if any(hslidestep<0) || any(isinf(hslidestep))
    set(handles.hscroll,'visible','off');
else
    set(handles.hscroll,'position',[345+1 1 handles.width-345-17 16],'min',cvpos(3)/2,...
        'max',handles.prefs.gridsize*handles.wscols-cvpos(3)/2+5,...
        'sliderstep',[.02 cvpos(3)/((handles.prefs.gridsize*handles.wscols)-cvpos(3))],...
        'value',cvpos(3)/2);
    if ~handles.tablemode
        set(handles.hscroll,'visible','on')
    end
end


%% refresh tab so don't have to reposition all tab objects here:
if handles.tabsvisible
    managetab(handles.fig,[]);
end

set(handles.fig,'resizefcn',@raveresizefcn);

