function varargout = ravesavegui(varargin)
% RAVESAVEGUI M-file for ravesavegui.fig
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


% Last Modified by GUIDE v2.5 30-Nov-2007 15:55:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ravesavegui_OpeningFcn, ...
                   'gui_OutputFcn',  @ravesavegui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ravesavegui is made visible.
function ravesavegui_OpeningFcn(hObject, eventdata, handles, varargin)

%set theme:
load raveprefs

set(0,'userdata','');

handles.currentname=varargin{2};
set(handles.nameedit,'string',handles.currentname);


set(hObject,'color',raveprefs.colors.frame);
set(handles.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);


set(handles.titleaxes,'color','none','xcolor',raveprefs.colors.frame,...
    'ycolor',raveprefs.colors.frame,'zcolor',raveprefs.colors.frame);
set(handles.topframeaxes,'color','none','xcolor',raveprefs.colors.tabbg,...
    'ycolor',raveprefs.colors.tabbg,'zcolor',raveprefs.colors.tabbg);

%make titles
text(0,.4,'Save this Project','parent',handles.titleaxes,'fontname',raveprefs.fonts.title,'fontsize',20*raveprefs.fonts.titlescale,...
   'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Name this Project','parent',handles.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
   'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

set(handles.directorytext,'string',raveprefs.defaultdir);


%get exising handles structure from maingui
handles.indata=guidata(hObject); %gcbo = "manage data sets" button in maingui

% Choose default command line output for ravesavegui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

uicontrol(handles.nameedit);

% UIWAIT makes ravesavegui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ravesavegui_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;


%% 
%
%
%                       DONE BUTTONS
%
%
%
%% 

% --- Executes on button press in savebutton.
function savebutton_Callback(hObject, eventdata, handles)

load raveprefs;

name=get(handles.nameedit,'string');
set(0,'userdata',name);

%check if there is already a folder named this:
if isdir([raveprefs.defaultdir,'\',name])
    answer=questdlg('A project with this name already exists. Do you want to overwrite it? (Only the .rve file will be overwritten.)','Overwrite Files?');
    if strcmp(answer,'No')
        set(0,'userdata',[]);
    end       
end
close(gcf);

% --- Executes on button press in cancelbutton.
function cancelbutton_Callback(hObject, eventdata, handles)
set(0,'userdata',[]);
close(gcf);

