function ravescreenshot(f,ev,rez)
%takes screenshot of ravefigure with handle f at resolution "rez".
%ex, rez=300
%should  be run from debug mode in rave.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu


if nargin==2
rez=300; %resolution (dpi) of final graphic
end

set(f,'inverthardcopy','off');

comics=findobj(f,'fontname','tekton pro');

set(comics,'fontsize',14);

magnetos=findall(f,'fontname','magneto');
magnetosizes=get(magnetos,'fontsize');
set(magnetos,'fontsize',14);
ravelogo=findobj(f,'string','rave');
set(ravelogo,'fontsize',60);

%f is the handle of the figure you want to export

[name path]=uiputfile('*.png','Put it somewhere');

figpos=getpixelposition(f); %dont need to change anything here
resolution=get(0,'ScreenPixelsPerInch'); %dont need to change anything here
set(f,'paperunits','inches','papersize',figpos(3:4)/resolution,'paperposition',[0 0 figpos(3:4)/resolution]); %dont need to change anything here
print(f,fullfile(path,name),'-dpng',['-r',num2str(rez)],'-zbuffer') %save file (see notes below)



set(comics,'fontsize',20);


set(magnetos,{'fontsize'},magnetosizes);


