function f = ravetxt2mgui(src,ev)

handles=guidata(src);

f=figure('units','pixels','position',[0 0 667 645],'name',...
    'Convert text function to MATLAB function','numbertitle','off','menubar','none','resize','off');
handles.gui=f;
origin=get(0,'userdata');
thispos=get(f,'position');
thispos(1)=origin(1)+origin(3)/2-thispos(3)/2;
thispos(2)=thispos(2)+origin(2)+origin(4)/2-thispos(4)/2;
set(f,'position',thispos);

%set theme:
load raveprefs
set(0,'userdata','cancel');

set(f,'color',raveprefs.colors.frame);

handles.uipanel1=uipanel('units','pixels','position',[25 6 609 416],'backgroundcolor',raveprefs.colors.tabbg,...
    'bordertype','etchedin','foregroundcolor',[0 0 0],'highlightcolor',[1 1 1],'shadowcolor',[.5 .5 .5]);

handles.uipanel2=uipanel('units','pixels','position',[25 436 609 156],'backgroundcolor',raveprefs.colors.tabbg,...
    'bordertype','etchedin','foregroundcolor',[0 0 0],'highlightcolor',[1 1 1],'shadowcolor',[.5 .5 .5]);

handles.importbutton=uicontrol('style','pushbutton','units','pixels','position',[53 11 289 39],'parent',handles.uipanel1,...
    'fontname','arial','fontsize',16,'string','Import this Function','callback',@importbutton_Callback);

handles.donebutton=uicontrol('style','pushbutton','units','pixels','position',[462 11 96 39],'parent',handles.uipanel1,...
    'fontname','arial','fontsize',16,'string','Done','callback',@donebutton_Callback);

uicontrol('style','text','units','pixels','position',[12 351 114 18],'fontsize',8,'string','Insert variable name:',...
    'backgroundcolor',raveprefs.colors.tabbg,'parent',handles.uipanel1,'hor','left');

handles.varnamemenu=uicontrol('style','popupmenu','units','pixels','position',[128 351 236 21],'tag','varnamemenu','callback',@varnamemenu_Callback,...
    'string',handles.allnames{1},'parent',handles.uipanel1,'backgroundcolor',[1 1 1]);

handles.topframeaxes=axes('units','pixels','position',[9 375 332 33],'parent',handles.uipanel1,...
    'visible','off','xlimmode','manual','ylimmode','manual');

uicontrol('style','text','units','pixels','position',[93 10 349 16],'fontsize',8,'string','A new variable with this name will be added to the selected data set.',...
    'backgroundcolor',raveprefs.colors.tabbg,'parent',handles.uipanel2,'hor','left');

handles.varnamebox=uicontrol('style','edit','units','pixels','position',[62 31 402 22],'parent',handles.uipanel2,...
    'hor','left','tag','varnamebox','backgroundcolor',[1 1 1]);

uicontrol('style','text','units','pixels','position',[41 54 282 18],'fontsize',8,'string','Name the variable you are modeling:',...
    'backgroundcolor',raveprefs.colors.tabbg,'parent',handles.uipanel2,'hor','left');

handles.analysismenu=uicontrol('style','popupmenu','units','pixels','position',[62 82 236 21],'callback',@analysismenu_Callback,...
    'string',handles.analysisnames,'parent',handles.uipanel2,'tag','analysismenu','backgroundcolor',[1 1 1]);

handles.datasetmenu=uicontrol('style','popupmenu','units','pixels','position',[358 82 236 21],'callback',@datasetmenu_Callback,...
    'string',handles.datasetnames,'parent',handles.uipanel2,'tag','datasetmenu','backgroundcolor',[1 1 1]);

uicontrol('style','text','units','pixels','position',[40 104 282 18],'fontsize',8,'string','Choose an Analysis:',...
    'backgroundcolor',raveprefs.colors.tabbg,'parent',handles.uipanel2,'hor','left');
uicontrol('style','text','units','pixels','position',[338 104 171 18],'fontsize',8,'string','Choose a Data Set:',...
    'backgroundcolor',raveprefs.colors.tabbg,'parent',handles.uipanel2,'hor','left');

handles.bottomframeaxes=axes('units','pixels','position',[7 116 332 33],'parent',handles.uipanel2,...
    'visible','off','xlimmode','manual','ylimmode','manual');

handles.titleaxes=axes('units','pixels','position',[11 599 217 33],'parent',f,...
    'visible','off','xlimmode','manual','ylimmode','manual');

set(src,'color',raveprefs.colors.frame);
set(handles.uipanel1,'backgroundcolor',raveprefs.colors.tabbg);
set(handles.uipanel2,'backgroundcolor',raveprefs.colors.tabbg);

set(src,'units','pixels');

% %make title:
text(0,.4,'Import Plain Text Function','parent',handles.titleaxes,'fontname',handles.prefs.fonts.title,'fontsize',20*handles.prefs.fonts.titlescale,...
    'color',raveprefs.colors.title,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Paste/Type txt Function Here:','parent',handles.topframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');
text(0,.4,'Configure','parent',handles.bottomframeaxes,'fontname',raveprefs.fonts.tab,'fontsize',18*raveprefs.fonts.tabscale,...
    'color',raveprefs.colors.text,'horizontalalignment','left','verticalalignment','baseline');

%make main edit box:
drawnow;
j=javax.swing.JTextPane;
javaObjectEDT(j);
h=javax.swing.JScrollPane(j,javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
[crap,handy]=javacomponent(h,[47 64 573 290]);

handles.jtext=j;
handles.txtbox=handy;

set(handle(j,'CallbackProperties'),'MouseReleasedCallback',{@showcontextmenu,src});


%get exising handles structure from maingui
%handles.indata=guidata(gcbo); %gcbo = "manage data sets" button in maingui

set(handles.analysismenu,'string','Default');
set(handles.datasetmenu,'string',handles.datasetnames)

% Choose default command line output for ravetxt2mgui
handles.output = src;

%edit box context menu:
menu=uicontextmenu('parent',src);
uimenu(menu,'Label','Cut','callback',{@cuttext,j});
uimenu(menu,'Label','Copy','callback',{@copytext,j});
uimenu(menu,'Label','Paste','callback',{@pastetext,j});
handles.contextmenu=menu;

% Update handles structure
guidata(f, handles);

function importbutton_Callback(src, ev)
handles=guidata(src);

str=char(handles.jtext.getText);

%check that all fields are filled:
if isempty(str)
    errordlg('You need to paste or type a function in the box.')
    return
end

if isempty(get(handles.varnamebox,'string'))
    errordlg('You need to enter a name for the variable you are modeling.')
    return
end

result=ravetxt2m(handles.fig,[],get(handles.varnamebox,'string'),str,get(handles.datasetmenu,'value'));
if result==-1;return;end %failed


%clear input fieldS:
set(handles.varnamebox,'string','');
handles.jtext.setText('');

%% update the data
guidata(src,handles);


function donebutton_Callback(src,ev)
close(gcf);

function datasetmenu_Callback(src,ev)
handles=guidata(src);
d=get(src,'value');
set(handles.varnamemenu,'string',handles.allnames{d});

function varnamemenu_Callback(src, ev)
handles=guidata(src);
d=get(handles.datasetmenu,'value');

thisvariable=handles.allnames{d}{get(src,'value')};
jtext=handles.jtext;
caretpos=jtext.getCaretPosition;
currentstring=jtext.getText;
currentstring=char(currentstring);
newstring=[currentstring(1:caretpos),' ',thisvariable,' ',currentstring(caretpos+1:end)];
jtext.setText(newstring)
jtext.requestFocus

newcaretpos=caretpos+2+length(thisvariable);
jtext.setCaretPosition(newcaretpos);


function showcontextmenu(jsrc,jev,fig)
handles=guidata(fig);
if jev.getButton > 1  %right click
    set(handles.contextmenu,'position',[47+jev.getX 64+290-jev.getY],'visible','on')
end

function cuttext(src,ev,j)
j.cut();

function copytext(src,ev,j)
j.copy();

function pastetext(src,ev,j)
j.paste();
