function ravevectorize(varargin)
%this function is the opposite of raverasterize. it removes the bitmap image and restores original
%graph.
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu

src=varargin{1};
handles=guidata(src);

if nargin==3
    ai=varargin{3}; %index of graph to be vectorized;
else
    ai=handles.activeindex;
end

if isempty(handles.rasters{ai});return;end %this graph is already vectorized. (keep this for use in raveupdateanalysis)
%delete raster axes
delete(handles.rasters{ai});
handles.rasters{ai}=[];

% retrieve from boneyard:
udata=get(handles.fakeax(ai),'userdata'); %#ok this line may be used by the eval statements!
%hide main axes:
allparents=[handles.allgraphs(ai);handles.fakeax(ai);handles.fakerax(ai);...
    handles.subax{ai}(:);handles.subfakeax{ai}(:);handles.subfakerax{ai}(:)];
%move other graph-specific objects:
graphtype=get(handles.allgraphs(ai),'userdata');
if isfield(handles.graphinfo.(graphtype),'deletehandles')
    deletehandles=handles.graphinfo.(graphtype).deletehandles;
    for f=1:numel(deletehandles)
        thesehandles=eval([deletehandles{f},';']);
        allparents=[allparents;thesehandles(:)];  %#ok<AGROW>
    end
end

allparents=findobj(allparents,'parent',handles.boneyard,'-depth',1);

lastkids=get(handles.wspanel,'children');
set(allparents,'parent',handles.wspanel);
set(handles.wspanel,'children',[allparents;lastkids]);


if strcmp(get(handles.tablemodebutton,'visible'),'on') %seems to be a reliable check of full-screen mode...
    set(handles.allblockers(ai),'visible','on')   
    set(handles.expblockers(ai),'visible','on')
end

%restore explorer blocker color.
set(handles.expblockers(ai),'facecolor',[.7 .7 .7]);


%% human factors research only
handles.timerticks(ai)=0;
%% 


guidata(handles.fig,handles);

