function ravezoomgraph(src,ev,ai,subax,xlim,ylim,zlim)
%updates the zoom of graph ai to its proper xlim/ylim/zlim
%optional input subax (vector) updates only the specified subaxes of a matrix plot.

handles=guidata(src);
udata=get(handles.fakeax(ai),'userdata');

%get axes:
if isempty(subax)
    axez=[handles.allgraphs(ai) handles.fakeax(ai) handles.fakerax(ai)];
else
    axez=subax;
end

%zoom the graph:
if ~isempty(ylim)
    set(axez,'ylim',ylim);
end

if ~isempty(xlim)
    set(axez,'xlim',xlim);
end

if ~isempty(zlim)
    set(axez,'zlim',zlim);
end


%reposition tick marks:
ravemovecustomticks(handles.allgraphs(ai),[],0);


%look for zoombars:
if ismember('zoombars',udata.explore.method)
    ax=udata.explore.zoombars.ax;
    if ~isempty(xlim)
        xbar=findobj(ax,'tag','xbar');
        xlow=findobj(ax,'tag','xlow');
        xhigh=findobj(ax,'tag','xhigh');
        pos=get(ax,'pos');
        
        %get max limits:
        maxxlim=udata.format.xlim;
        
        normxlim=(xlim-maxxlim(1))./(maxxlim(2)-maxxlim(1));
        
        %convert to positions:
        relxlim=normxlim.*(pos(3)-16)+3;
        
        set(xlow,'xdata',relxlim(1));
        set(xhigh,'xdata',relxlim(2));
        set(xbar,'xdata',relxlim+[-3 3]);
    end
    
    if ~isempty(ylim)
        ybar=findobj(ax,'tag','ybar');
        ylow=findobj(ax,'tag','ylow');
        yhigh=findobj(ax,'tag','yhigh');
        pos=get(ax,'pos');
        
        %get max limits:
        maxylim=udata.format.ylim;
        
        normylim=(ylim-maxylim(1))./(maxylim(2)-maxylim(1));
        
        %convert to positions:
        relylim=normylim.*(pos(4)-16)+3;
        
        set(ylow,'ydata',relylim(1));
        set(yhigh,'ydata',relylim(2));
        set(ybar,'ydata',relylim+[-3 +3]);
    end
end





