function showhideworkspace(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

%note: paradoxically, this function uses the reverse logic of what you'd
%expect, since it changes to a new tablemode based on the current
%tablemode. Thus if tablemode=1 it shows the workspace. 


handles=guidata(src);

set(handles.infobar,'string','');

if handles.tablemode; %show workspace

    set(handles.maintable.handle,'visible','off');
    
    set(handles.wspanel,'visible','on')
    set(handles.hscroll,'visible','on')
    set(handles.vscroll,'visible','on')
    if strcmp(get(handles.tablemodebutton,'visible'),'on')
        set(handles.currentview,'visible','on')
    end
    set(handles.explorer,'hittest','on')
    set(handles.tablemodebutton,'string','Table')
    handles.tablemode=0;
    guidata(src,handles);
    ravedisplayworkspace(handles.fig,[]);
    ravedisplaypage(src,ev);
   % drawnow;
   if ~strcmp(handles.activetab,'manage')
    eval([handles.activetab,'tab(handles.fig,[])'])
   end
   
else %show table
    set(handles.wspanel,'visible','off')
    set(handles.hscroll,'visible','off')
    set(handles.vscroll,'visible','off')
    set(handles.currentview,'visible','off')
    set(handles.explorer,'hittest','off');
    set(handles.tablemodebutton,'string','Graphs');
    handles.tablemode=1;
    guidata(src,handles);
    ravedisplaymaintable(src,ev);
    drawnow;
    set(handles.maintable.handle,'visible','on');
    
   % drawnow;
    if ~strcmp(handles.activetab,'manage')
     eval([handles.activetab,'tab(handles.fig,[])'])
    end
end