function rowtab(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);
handles=guidata(src);
set(handles.infobar,'string','');
handles.activetab='row';
guidata(src,handles);

%move front tabs to front if necessary
set(handles.fronttabaxes,'position',handles.backtabposition)
set(handles.backtabaxes,'position',handles.fronttabposition)
[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,1,0); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)


%delete(handles.tabobjects);
set(handles.infobar,'string','');

%raise this tab to top
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,4,1); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

udata=get(handles.fakeax(handles.activeindex),'userdata');
if ~isempty(udata)
    d=udata.view.dataset;
    a=udata.view.analysis;
else
    d=1;
    a=1;
end


%%
statetext=text(.15-.10317,.969,'Row State','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
doetext=text(.15-.10317,0.5,'Generate Rows','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


selecttext=uicontrol('position',[origin(1)+21 origin(2)+120+450 180 20],...
    'style','text','string','Select Data:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

pointbutton=uicontrol('position',[origin(1)+115 origin(2)+119+450 26 26],...
    'style','togglebutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left','callback',@ravesetpointselectionmode,...
    'cdata',imread('singlepoint.bmp'),'tag','pointbutton');

boxbutton=uicontrol('position',[origin(1)+145 origin(2)+119+450 26 26],...
    'style','togglebutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left','callback',@ravesetboxselectionmode,...
    'cdata',imread('box.bmp'),'tag','boxbutton');

lassobutton=uicontrol('position',[origin(1)+175 origin(2)+119+450 26 26],...
    'style','togglebutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left','callback',@ravesetlassoselectionmode,...
    'cdata',imread('lasso.bmp'),'tag','lassobutton');


switch handles.selectionmode
    case 'point'
        set(pointbutton,'value',1)
    case 'lasso'
        set(lassobutton,'value',1)
    case 'box'
        set(boxbutton,'value',1)
end

invertbutton=uicontrol('position',[origin(1)+115 origin(2)+119+450-35 120 26],...
    'style','pushbutton','string','Invert Selection','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'horizontalalignment','left','callback',@invertselection_callback);

hidebutton=uicontrol('position',[origin(1)+222 origin(2)+119+450 26 26],...
    'style','pushbutton','string','','value',0,'backgroundcolor',handles.colors.togglebuttonbg,...
    'cdata',imread('hide.bmp'),'tooltip','Hide Selected Data','callback',@hidebutton_callback,'tag','hidebutton');

colortext=uicontrol('position',[origin(1)+21 origin(2)+120+410-30 220 20],...
    'style','text','string','Change Color of Selected Rows:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

colortestbutton=zeros(1,10);
thecolors=handles.prefs.rowcolors;

for c=1:10
    colortestbutton(c)=uicontrol('position',[origin(1)+10+22*c origin(2)+85+430-30 18 18],...
        'style','pushbutton','string','','value',0,'backgroundcolor',thecolors(c,:),...
        'fontname','arial narrow','fontsize',6,'horizontalalignment','left',...
        'callback',@rowcolorblob_callback,'tag','rowcolorblob','userdata',c);
end

colortext2=uicontrol('position',[origin(1)+21 origin(2)+480-30 220 20],...
    'style','text','string','Selection Highlight Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

colortext3=uicontrol('position',[origin(1)+21 origin(2)+425 220 20],...
    'style','text','string','Filtered Row Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

colortext4=uicontrol('position',[origin(1)+21 origin(2)+375 220 20],...
    'style','text','string','Mouseover Highlight Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

selectedcolorbutton=uicontrol('position',[origin(1)+190+18 origin(2)+482-30 22 22],...
    'style','pushbutton','string','','value',0,'backgroundcolor',handles.colors.selectionhighlight,...
    'fontname','arial narrow','fontsize',6,'horizontalalignment','left',...
    'callback',@selectedcolorblob_callback);

filteredcolorbutton=uicontrol('position',[origin(1)+190+18 origin(2)+482-26-30 22 22],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.filtered,...
    'callback',@filteredcolorblob_callback);

filtercheck=uicontrol('position',[origin(1)+35 origin(2)+403 200 22],...
    'style','checkbox','string','Filtered points are selectable','backgroundcolor',handles.colors.tabbg,...
    'callback',@filtercheck_callback,'value',handles.prefs.filteredselectable,'fontsize',10);

mouseovercolorbutton=uicontrol('position',[origin(1)+190+18 origin(2)+482-2*26-52 22 22],...
    'style','pushbutton','string','','backgroundcolor',handles.colors.mouseoverhighlight,...
    'callback',@mouseovercolorblob_callback);

mouseovercheck=uicontrol('position',[origin(1)+35 origin(2)+353 200 22],...
    'style','checkbox','string','Enable Mouseovers','backgroundcolor',handles.colors.tabbg,...
    'callback',@mouseovercheck_callback,'value',handles.prefs.processmouseovers,'fontsize',10);



doebutton=uicontrol('position',[origin(1)+20 origin(2)+275 220 24],...
    'style','pushbutton','string','Design of Experiments',...
    'callback',@doebutton_callback,...
    'backgroundcolor',handles.colors.buttonbg,'tag','doebutton');

doebuttontext=uicontrol('position',[origin(1)+20 origin(2)+195 220 75],...
    'style','text','string',{'Use this button to access all methods related to generating new rows for a data set.';'This includes structured and random sampling; appending data and replacing data.'},...
    'callback','','hor','left',...
    'backgroundcolor',handles.colors.tabbg,'tag','');

handles.tabobjects=[statetext doetext doebutton doebuttontext pointbutton boxbutton lassobutton invertbutton mouseovercheck...
    hidebutton colortestbutton selecttext colortext colortext2 colortext3 colortext4 selectedcolorbutton filteredcolorbutton mouseovercolorbutton filtercheck];

guidata(src,handles);


function doebutton_callback(src,ev)

ravemakedoe(src,ev);
%{
function lassobutton_callback(src,ev)
handles=guidata(src);

otherbuttons=findobj(handles.tabobjects,'tag','boxbutton','-or','tag','pointbutton');
set(otherbuttons,'value',0);

discretecontrols=findobj(handles.allgraphs(ishandle(handles.allgraphs)),'userdata','discretecontrols');
if ~isempty(discretecontrols)
    idx=find(handles.allgraphs==discretecontrols);
    for i=1:numel(idx)
        uuu=get(handles.fakeax(idx(i)),'userdata');
        unpushtogglebutton(uuu.view.pointbutton,[]);
        pushtogglebutton(uuu.view.lassobutton,[]);
        unpushtogglebutton(uuu.view.boxbutton,[]);
    end
end


if get(src,'value')
    handles.selectionmode='lasso';
else
    handles.selectionmode='none';
end
guidata(src,handles);

%update graphs if necessary:
for ai=1:numel(handles.allgraphs)
    if ~ishandle(handles.allgraphs(ai));continue;end
    thistype=get(handles.allgraphs(ai),'userdata');
    if ~isempty(which(['ravesetselectionmode',thistype,'.m']));
        funhandle=str2func(['ravesetselectionmode',thistype]);
        funhandle(handles.fig,ai);
    end
end


function boxbutton_callback(src,ev)
handles=guidata(src);

otherbuttons=findobj(handles.tabobjects,'tag','lassobutton','-or','tag','pointbutton');
set(otherbuttons,'value',0);

discretecontrols=findobj(handles.allgraphs(ishandle(handles.allgraphs)),'userdata','discretecontrols');
if ~isempty(discretecontrols)
    idx=find(handles.allgraphs==discretecontrols);
    for i=1:numel(idx)
        uuu=get(handles.fakeax(idx(i)),'userdata');
        unpushtogglebutton(uuu.view.pointbutton,[]);
        unpushtogglebutton(uuu.view.lassobutton,[]);
        pushtogglebutton(uuu.view.boxbutton,[]);
    end
end

if get(src,'value')
    handles.selectionmode='box';
else
    handles.selectionmode='none';
end

guidata(src,handles);

%update graphs if necessary:
for ai=1:numel(handles.allgraphs)
    if ~ishandle(handles.allgraphs(ai));continue;end
    thistype=get(handles.allgraphs(ai),'userdata');
    if ~isempty(which(['ravesetselectionmode',thistype,'.m']));
        funhandle=str2func(['ravesetselectionmode',thistype]);
        funhandle(handles.fig,ai);
    end
end


function pointbutton_callback(src,ev)
handles=guidata(src);

otherbuttons=findobj(handles.tabobjects,'tag','lassobutton','-or','tag','boxbutton');
set(otherbuttons,'value',0);

discretecontrols=findobj(handles.allgraphs(ishandle(handles.allgraphs)),'userdata','discretecontrols');
if ~isempty(discretecontrols)
    idx=find(handles.allgraphs==discretecontrols);
    for i=1:numel(idx)
        uuu=get(handles.fakeax(idx(i)),'userdata');
        pushtogglebutton(uuu.view.pointbutton,[]);
        unpushtogglebutton(uuu.view.lassobutton,[]);
        unpushtogglebutton(uuu.view.boxbutton,[]);
    end
end

if get(src,'value')
    handles.selectionmode='point';
else
    handles.selectionmode='none';
end
guidata(src,handles);

%update graphs if necessary:
for ai=1:numel(handles.allgraphs)
    if ~ishandle(handles.allgraphs(ai));continue;end
    thistype=get(handles.allgraphs(ai),'userdata');
    if ~isempty(which(['ravesetselectionmode',thistype,'.m']));
        funhandle=str2func(['ravesetselectionmode',thistype]);
        funhandle(handles.fig,ai);
    end
end

%}
function hidebutton_callback(src,ev) %#ok<INUSD>
%hide the selected points
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

newhidden=false(size(nothidden));
newhidden(handles.isselected{udata.view.dataset}{udata.view.analysis})=true;

allhidden= ~nothidden | newhidden;

handles.isvisible{udata.view.dataset}{udata.view.analysis}=~allhidden;

%set(handles.fakeax(handles.activeindex),'userdata',udata);

%now apply this change:
guidata(src,handles);

raveupdateanalysis(src,[],'visiblerows',[]);


function rowcolorblob_callback(src,ev)
handles=guidata(src);

if ~handles.tablemode
    udata=get(handles.fakeax(handles.activeindex),'userdata');
    if isempty(udata)
        d=1;
        a=1;
    else
        d=udata.view.dataset;
        a=udata.view.analysis;
    end
    handles.rowcolors{d}{a}(handles.isselected{d}{a})=get(src,'userdata');
else
    d=handles.maintable.d;
    a=handles.maintable.a;
    
    isselected=handles.maintable.jtable.getSelectedRows();
    for g=1:numel(isselected);
        isselected(g)=handles.maintable.models{d}.modelIndex(isselected(g));
    end
    isselected=isselected+1;
    
    if strcmp(get(handles.fig,'currentmodifier'),'control')
        
        oldcolor=handles.prefs.rowcolors(get(src,'userdata'),:);
        newcolor=ravecolorchooser(handles.fig,oldcolor,'Choose a new row color');
        thecolors=get(handles.fig,'colormap');
        
        thecolors(1920+get(src,'userdata'),:)=newcolor;
        set(handles.fig,'colormap',thecolors);
        
        set(src,'backgroundcolor',newcolor);
        for d=1:numel(handles.alldata)
            handles.maintable.models{d}.setRowColorSpec(get(src,'userdata')-1,java.awt.Color(newcolor(1),newcolor(2),newcolor(3)));
        end
    end
    
    handles.rowcolors{d}{a}(isselected)=get(src,'userdata');
    handles.analysisupdatespending{d}{a}=union(handles.analysisupdatespending{d}{a},'rowcolors');
    guidata(handles.fig,handles);
    
    %update table:
    rowcolors=handles.rowcolors{d}{a};
    jRowColors=javaArray('java.lang.Integer',size(rowcolors,1));
    for r=1:numel(rowcolors)
        jRowColors(r)=java.lang.Integer(rowcolors(r)-1);
    end
    handles.maintable.models{d}.setRowColors(jRowColors)
    
    %update display:
    rowHeaderViewport=handles.maintable.jscroll.getComponent(3);
    rowHeader=rowHeaderViewport.getComponent(0);
    rowHeader.repaint;
    
end

if strcmp(get(handles.fig,'currentmodifier'),'control')
    oldcolor=handles.prefs.rowcolors(get(src,'userdata'),:);
    newcolor=ravecolorchooser(handles.fig,oldcolor,'Choose a new row color');
    thecolors=get(handles.fig,'colormap');
    
    thecolors(1920+get(src,'userdata'),:)=newcolor;
    set(handles.fig,'colormap',thecolors);
    
    set(src,'backgroundcolor',newcolor);
    
    
    handles.prefs.rowcolors(get(src,'userdata'),:)=newcolor;
    
    raveprefs=handles.prefs; %#ok<NASGU>
    prefspath=which('raveprefs.mat');
    save(prefspath,'raveprefs');
    
    
end

guidata(handles.fig,handles);

raveupdateanalysis(src,[],'rowcolors',[],d,a);


function selectedcolorblob_callback(src,ev)
handles=guidata(src);

oldcolor=handles.colors.selectionhighlight;

newcolor=ravecolorchooser(handles.fig,handles.colors.selectionhighlight,'Choose the color to highlight selected data');
set(src,'backgroundcolor',newcolor);
handles.colors.selectionhighlight=newcolor;
guidata(handles.fig,handles);

load raveprefs
raveprefs.colors.selectionhighlight=newcolor;%#ok<STRNU>
save(which('raveprefs.mat'),'raveprefs')


%update graphs:
a=findobj(handles.fig,'tag','selected','edgecolor',oldcolor);
set(a,'edgecolor',newcolor);
a=findobj(handles.fig,'tag','selected','color',oldcolor);
set(a,'color',newcolor);
a=findobj(handles.fig,'tag','selected','facecolor',oldcolor);
set(a,'facecolor',newcolor);
a=findobj(handles.fig,'tag','selected','markeredgecolor',oldcolor);
set(a,'markeredgecolor',newcolor);
a=findobj(handles.fig,'tag','selected','markerfacecolor',oldcolor);
set(a,'markerfacecolor',newcolor);


function mouseovercolorblob_callback(src,ev)
handles=guidata(src);

newcolor=ravecolorchooser(handles.fig,handles.colors.mouseoverhighlight,'Choose the color to highlight mouseover data');
set(src,'backgroundcolor',newcolor);
handles.colors.mouseoverhighlight=newcolor;
guidata(handles.fig,handles);

load raveprefs
raveprefs.colors.mouseoverhighlight=newcolor;%#ok<STRNU>
save(which('raveprefs.mat'),'raveprefs')





function filteredcolorblob_callback(src,ev)
handles=guidata(src);

oldcolor=handles.colors.filtered;

newcolor=ravecolorchooser(handles.fig,handles.colors.filtered,'Choose the color to draw filtered data');
set(src,'backgroundcolor',newcolor);
handles.colors.filtered=newcolor;
guidata(handles.fig,handles);

load raveprefs
raveprefs.colors.filtered=newcolor; %#ok<STRNU>
save(which('raveprefs.mat'),'raveprefs')

a=findobj(handles.fig,'tag','filtered','edgecolor',oldcolor);
set(a,'edgecolor',newcolor);
a=findobj(handles.fig,'tag','filtered','color',oldcolor);
set(a,'color',newcolor);
a=findobj(handles.fig,'tag','filtered','facecolor',oldcolor);
set(a,'facecolor',newcolor);
a=findobj(handles.fig,'tag','filtered','markeredgecolor',oldcolor);
set(a,'markeredgecolor',newcolor);
a=findobj(handles.fig,'tag','filtered','markerfacecolor',oldcolor);
set(a,'markerfacecolor',newcolor);


function invertselection_callback(src,ev)
handles=guidata(src);

if isempty(handles.activeindex);
    set(handles.infobar,'string','Cannot invert selection when no workspace object is selected');
    return
end

udata=get(handles.fakeax(handles.activeindex),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

handles.isselected{d}{a}=~handles.isselected{d}{a};


guidata(handles.fig,handles);

raveupdateanalysis(src,[],'isselected',[],d,a);


function mouseovercheck_callback(src,ev)

handles=guidata(src);
handles.prefs.processmouseovers=get(src,'value');
guidata(handles.fig,handles);

clear ravedefaultwindowbuttonmotionfcn

prefpath=which('raveprefs.mat');
load raveprefs
raveprefs.processmouseovers=get(src,'value');
save(prefpath,'raveprefs');

function filtercheck_callback(src,ev)
handles=guidata(src);
handles.prefs.filteredselectable=get(src,'value');
guidata(handles.fig,handles);

clear ravedefaultwindowbuttonmotionfcn

prefpath=which('raveprefs.mat');
load raveprefs
raveprefs.filteredselectable=get(src,'value');
save(prefpath,'raveprefs');





